# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class FishermanBuilding(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.to_building_subtype = "smokery"
        self.SetIsHome(False)
# ============================================================
    def need_base_resource(self):
        return False
# ============================================================
    def on_res_gen_started(self):
        self.PlaySound('SND_FISHERMAN_WORK')
        self.Drawer.SetAnimationEvent('unit', 80, 'rod_event')
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'rod_event':
            self.PlaySound('SND_FISHERMAN_ROD')
# ============================================================
    def on_minimal_effectiveness(self):
        EMgr.AppendLetter([('text','LETTER_EFFECTIVENESS_10')], self.get('uid'))
        UI.show_top_text('MSG_EFFECTIVENESS_FISHERMAN', self.get('uid'))
# ============================================================
