# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

class Nofog(base_building.BaseBuilding):
    def __init__(self, cdata):
        self.need_show_effect = False
        base_building.BaseBuilding.__init__(self, cdata)
        self.SetIsHome(False)
# ============================================================
    # @override
    def activate(self):
        if self.is_deactivated:
            if self.is_territory: UStats.AddLevelValue('territory', 1)
        self.is_deactivated = False
        self.add_fog_circle()
        self.need_show_effect = True
        if self.need_show_effect: self.Drawer.RestartEffect('effect')
        self.switch_animation()
        #Camera.MoveTo(self)
# ============================================================
    # @override
    def add_fog_circle(self):
        if not self.is_deactivated:
            _name = self.get('name')
            self.AddFogCircle((_name == 'main_no_fog')) # main_no_fog - если этот объект, то он заменяет главное здание в подземельях (открывает видимость)
            _need_unfog_sound = self.GetAttrBool('need_unfog_sound')
            if _need_unfog_sound:
                self.PlaySoundG('SND_NEW_AREA')
# ============================================================
    # @override
    def switch_animation(self):
        self.Drawer.ShowImages('', False)
        self.Drawer.ShowImages('effect', self.need_show_effect)
# ============================================================
# #######################################################
# #######################################################
# #######################################################
