# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building
import task_upgrade
#import task_classes


class Totem(base_building.BaseBuilding):
    def __init__(self, cdata):
        self.build_task_started = False
        base_building.BaseBuilding.__init__(self, cdata)
        self.SetIsHome(False)
        self.is_indians = True
# ============================================================
    def need_base_resource(self):
        return False
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        if not self.HasAccess():
            trace('Cancel click (access)', self.get('name') )
            LBoard.CrossNoToLastClick()
            return
        if not self.is_active():
            trace('Cancel click (inactive)', self.get('name') )
            trace('Cancel info:', self.is_deactivated, self.non_selectable, self.get_next_level_name())
            #LBoard.MoveCameraToLastClick()
            LBoard.CrossNoToLastClick()
            return
        self.on_mouse_out() # чтобы обновить состояние селекта
        state = self.SM.GetCurrentState()
        if self.is_next_level_possible() and state not in ['upgrade', 'build', 'repair', 'awaiting_action'] and self.status == 'broken' and not self.build_task_started:
            if btn_name in ["button", "default", "floor", '_click_rect_']:
                self.PlaySoundG('SND_CLICK_TASK')
                TMgr.add_task( task_upgrade.UpgradeTask(self) )
                self.build_task_started = True
                self.show_arrow(False)
        elif state == 'awaiting_action':
            if btn_name == 'button':
                self.build_task_started = False
                task = self.get_participating_task("upgrade_building")
                if task:
                    self.PlaySoundG('SND_CLICK_TASK_CANCEL')
                    task.cancel()
                self.SM.SetState('normal')
# ============================================================
    def is_next_level_possible(self):
        '''Возможен ли апгрейд/ремонт до следующего уровня'''
        next_var_name = self.get_next_level_name()
        if next_var_name:
            res_need = self.get_needs_res(next_var_name)
            if self.SM.GetCurrentState() in ["", "normal"]:   # если не в состоянии стройки и т.д.
                if self.status == 'broken':         # если есть что апгрейдить
                    _is_res_enough = UStats.IsResEnough(res_need)
                    if _is_res_enough:          # если ресурсов достаточно
                        return True
        return False
# ============================================================
    __normal_empty = ['', 'normal']
    def get_raw_button_frame(self):
        '''Возвращает номер кадра кнопки, без учета положения курсора мыши'''
        if self.is_deactivated: # если здание деактивировано
            return -1
        _partial_fog = self.Drawer.IsPartiallyInFog()
        if _partial_fog:        # если в тумане
            return -1
        _has_access = self.HasAccess()
        #if not _has_access:
        #    return -1
        frame = -1
        state = self.SM.GetCurrentState()
        #_name = self.get('name')
        #can_build = BMgr.Is_build_action_possible(_name, False)
        if state in self.__normal_empty:         # '' - это состояние после выхода из любого другого
            if self.status == 'broken' and self.has_next_level: # если можно отремонтировать
                _build_case = False
                if self.button_res_enough and _has_access:                      # и хватает ресурсов
                    #if can_build:
                    _build_case = True
                if _build_case:
                    frame = 6
                else:
                    frame = 8
            elif self.has_next_level:    # если возможен апгрейд
                _build_case = False
                if self.button_res_enough:                      # и хватает ресурсов
                    #if can_build:
                    _build_case = True
                if _build_case:
                    frame = 0
                else:
                    frame = 2
        elif state == 'awaiting_action':            # если ожидаем какого-то действия, правда прибегание юнита тоже вызывает это... нужно проверить
            frame = 3       # галка
        elif state in ['build', 'upgrade']: # в момент действия кнопку не отображаем (отменить уже нельзя)
            frame = -1
        return frame
# ============================================================
    def Get_button_frame(self):
        frame = self.get_raw_button_frame()
        state = self.SM.GetCurrentState()
        if frame >= 0:
            if self.is_mouse_over:
                if state not in ['build', 'upgrade']:   # чтобы в этих режимах кнопка при наведении на объект появлялась
                    if frame in self.button_active_frames: # подсветка кнопки при наведении
                        if frame == self.cancel_build_active_frame:     # для отмены подсвечиваем только над кнопкой
                            if self.is_mouse_over_zone == 'button':
                                frame += 1
                        else:
                            frame += 1
        if frame < 0:
            self.Drawer.ShowImages('button', False)
        else:
            self.Drawer.ShowImages('button')
        return frame
# ============================================================
    #@override
    def on_repair_complete(self):
        '''Для обработки ситуации окончания repair'''
        base_building.BaseBuilding.on_repair_complete(self)
        if self.is_territory: UStats.AddLevelValue('territory', 1)
# ============================================================
    def scale_bump(self):
        _pos = self.GetAttrPoint('center_item_pos')
        self.Drawer.ScaleBump(self.bump_layers, _pos, 120, 1.05)
        _is_stone = self.GetAttrBool('is_stone')
        if _is_stone:
            self.PlaySound('SND_HAMMER_HIT_ROCK')
        else:
            self.PlaySoundRandom(['SND_HAMMER_HIT_1', 'SND_HAMMER_HIT_2', 'SND_HAMMER_HIT_3'])
# #######################################################
