# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_building

# ============================================================
# ============================================================
class WarehouseBuilding(base_building.BaseBuilding):
    def __init__(self, cdata):
        base_building.BaseBuilding.__init__(self, cdata)
        self.SetIsHome(False)
        #self.init_anim()
# ============================================================
    def init_anim(self):
        self.Drawer.SetAnimationEvent('unit', 10, 'worker_event')
        settings = []
        settings.append( ['unit', ('random', 2, 4)] )
        settings.append( ['no_action', 1] )
        self.anim_helper.set_animations('default', settings)
# ============================================================
    #@override
    def on_awaiting_action(self):
        self.anim_helper.hide()
        self.anim_helper.stop()
# ============================================================
    # @override
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        if msg_type == 'worker_event':
            self.PlaySound('SND_WAREHOUSE_LOADER')
# ============================================================
    #@override
    def need_to_show_unit(self):
        return False
# ============================================================
    #@override
    def need_no_action(self):
        return False
# ============================================================
    #@override
    def need_pers_no_action(self):
        return False
# ============================================================
    #@override
    def start_resource_generation(self):
        base_building.BaseBuilding.start_resource_generation(self)
        #self.PlaySound('SND_WAREHOUSE_WORK')
        self.anim_helper.start_group('default')
# ============================================================
    #@override
    def take_resource(self, resource):
        '''Вызывается в момент, когда юнит отдает ресурс зданию. Может инициировать процесс генерации зависимого ресурса, либо добавляет ресурс к общим ресурсам'''
        resource = resource.Clone()
        resource.FixFood()
        UStats.AddRes(resource) # добавим ресурсы к ресурсам игры
        TMgr.send_event("resource_stored", None)
        res_count = resource.GetSingleValue()
        res_name = resource.GetSingleName()
        if res_name in self.res_images:
            LBoard.FlyResCount(self, self.res_images[res_name], res_count)
# ============================================================
    #@override
    def start_task_participation(self, task, sub=''):
        '''Начало участия здания в задании. Но хранилище имеет некоторые исключения'''
        if task.type == "take_res":
            return
        return base_building.BaseBuilding.start_task_participation(self, task, sub)
# ============================================================
    #@override
    def stop_task_participation(self, task, sub = ''):
        '''Конец участия здания в задании. Но хранилище имеет некоторые исключения'''
        if task.type == 'take_res':
            return
        return base_building.BaseBuilding.stop_task_participation(self, task, sub)
# ============================================================
    #@override
    def is_task_participating(self, task_type):
        '''Участвует ли уже здание в данном типе задания. Но хранилище имеет некоторые исключения'''
        if task_type in ['take_res', 'take_resfrom', 'take_resto']:
            return False
        return base_building.BaseBuilding.is_task_participating(self, task_type)
# ============================================================
    #@override
    def on_worker_in(self, unit):
        '''Чтобы здание могло отловить когда пришел юнит-работник в здание'''
        self.PlaySound('SND_BUILDING_OCCUPY')
        #self.Drawer.ShowIn('unit')
        self.update_next_res()
        self.switch_animation()
        #self.start_resource_generation()
        #self.PlaySound('SND_WAREHOUSE_WORK')
        self.init_anim()
        self.anim_helper.start_group('default')
# ============================================================
    def on_upgrade_complete(self, building_info):
        base_building.BaseBuilding.on_upgrade_complete(self, building_info)
        self.Drawer.SetAnimationEvent('unit', 10, 'worker_event')
# ============================================================
    def on_repair_complete(self, building_info):
        base_building.BaseBuilding.on_repair_complete(self, building_info)
        _need_help = LBoard.Core.is_help_needed(5)
        if _need_help:
            Camera.MoveTo(self)
            UI.open_help(True)
# #######################################################
# #######################################################
# #######################################################
    #@override
    def is_home(self):  # is home for units
        return 0
# ============================================================