# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import anim_helper
import task_res
import task_res_store
import task_upgrade
import task_callworker
import toolz

#@statemachine
class BaseBuilding(Building):
    #cancel_switch_place_variant_name = 'map_place'
    variants_switch = {
            'map_place': 'place',
            'map_place1': 'place',
            'map_place2': 'place',
            'map_place3': 'place',
            'place': 'level_1',
            'level_1': 'level_2',
            'level_2': 'level_3',
            'level_3': 'level_4',
            'level_4': 'level_5',
            'level_5': 'level_6',
            'level_6': 'level_7',
            'level_7': 'level_8',
            'level_8': 'level_9',
            'level_9': 'level_10',  # до 10 апгрейдов максимум
            'broken_1': 'level_1',
            'broken_2': 'level_2',
            'broken_3': 'level_3'
        }
    variants_indexes = {
            'map_place': 0,
            'map_place1': 0,
            'map_place2': 0,
            'map_place3': 0,
            'place': 0,
            'level_1': 1,
            'level_2': 2,
            'level_3': 3,
            'level_4': 4,
            'level_5': 5,
            'level_6': 6,
            'level_7': 7,
            'level_8': 8,
            'level_9': 9,  # до 10 апгрейдов максимум
            'broken_1': 0,
            'broken_2': 1,
            'broken_3': 2,
            'thrown_1': 0,
            'thrown_2': 1,
            'thrown_3': 2
        }
    blocked_switch = {
            'level_1': 'thrown_1',
            'level_2': 'thrown_2',
            'level_3': 'thrown_3'
        }
    broken_switch = {
            'level_1': 'broken_1',
            'level_2': 'broken_2',
            'level_3': 'broken_3'
        }
    resource_names = ['food', 'bricks', 'boards', 'coins', '_berries', '_fish']
    res_images = {
        'food': 'IMG_I_TIP_FOOD',
            '_berries': 'IMG_I_TIP_FOOD',
            '_fish': 'IMG_I_TIP_FOOD',
            #'_flour': 'IMG_I_TIP_FOOD',
        'bricks': 'IMG_I_TIP_BRICKS',
            #'_granite': 'IMG_I_TIP_BRICKS',
        'boards': 'IMG_I_TIP_BOARDS',
            #'_wood': 'IMG_I_TIP_BOARDS',
        'coins': 'IMG_I_TIP_COINS',
            #'_ore': 'IMG_I_TIP_COINS',
        'gold': 'IMG_I_TIP_GOLD'
        }
    shaded_layers = ['floor','default','unit','resources','upgrading','build','anim']
    bump_layers = ['default','unit','upgrading','build','anim']
    not_for_attack = {'hq':0, 'hq_small':0, 'watchtower':0, 'house':0,\
                        'boatyard':0, 'verf':0, 'bridge':0, 'column':0,\
                        'dam':0, 'enemy':0, 'farm_field':0, 'fence':0, 'no_fog':0,\
                        'ind_house_w':0, 'totem':0, 'totem_stone':0}
    has_no_effectiveness = {'hq':0, 'hq_small':0, 'watchtower':0, 'house':0,\
                        'boatyard':0, 'verf':0, 'bridge':0, 'column':0,\
                        'dam':0, 'enemy':0, 'farm':0, 'fence':0, 'no_fog':0,\
                        'ind_house_w':0, 'totem':0, 'totem_stone':0,\
                        'warehouse':0}      # 'woodcutter':0, 'quarry':0,

    button_active_frames = [0,3,6]
    cancel_build_active_frame = 3

    # trying to optimize a bit:
    _normal__empty = ['normal', '']
    _normal__broken = ['normal', 'broken']
    _place__broken = ['place', 'broken']
# ============================================================
# ============================================================
    def __init__(self, cdata):
        Building.__init__(self, cdata)

        self.uid = -1
        self.subtype = self.get('stype')
        self.prev_mplace_name = '__none__'
        #self.action_units = []     # units interacting with current building
        self.start_cell_pos = {"col":0, "row":0}        # ячейка, из/в которой будут выбегать юниты
        self.road_cell_pos = {"col":0, "row":0}         # начало дороги от здания
        self.max_units_count = 0 # default - no units                  # максимальное число юнитов в здании
        self.cur_units_count = 0                    # текущее число юнитов данного здания
        self.status = '__none__' #"place"                                  # статус  здания, обычно: [normal, broken, ...]
        self.prev_status = '__none__'               # предыдущий статус здания (используется при смене варианта здания)
        #self.status = self.GetAttrStr("status")
        self.current_episode = self.GetEpisodeIndex()
        self.is_territory = self.GetAttrBool('is_territory')
        self.is_thrown = False
        self.need_max_time = False          # нужно ли выставить 'res_gen_max_time'
        self.max_res_generation_time = 0
        self.max_res_gen_time = 0
        self.has_effectivness_inited = False    # здание работало хотя бы сколько-то? Нужно, чтобы не сбрасывать эффективность полей после ремонта после атаки варваров
        self.current_effectiveness = 100
        self.generation_count = 0
        self.effectiveness_degradation_count = 0
        self.is_priority_building = False   # здание строится по приоритету
        self.build_time = 1                    # время, необходимое для постройки/апгрейда/ремонта здания
        self.build_progress = 0                     # сколько времени постройки уже прошло
        self.hack_for_upgrade = False               # здание апгрейдится внутренней анимацией (все yard'ы)
        self.anim_helper = anim_helper.AnimHelper()
        self.anim_helper.initialize(self.Drawer, self.Signals, 'ah_signal')
        self.road_was_builded = False               # была ли проведена дорога к зданию
        self._building_units = []         # free units for actions  - юниты данного здания
        self.walking_home_units = []                # юниты, бегущие в здание (домой)
        self.max_build_units = self.GetAttrInt('max_build_units')
        self.worker_units = []          # юниты, которые работают в здании
        self.barb_cells_names = []     # названия атрибутов-ячеек для атаки здания дикарями
        self.building_cells_names = []     # названия атрибутов-ячеек для постройки здания
        self.reserved_building_cells_names = []   # зарезервированные для использования названия ячеек
        self.cell_pos = self.get("cell")        # ячейка, к которой привязано положение здания на карте - относительно нее считаются другие ячейки
        self.res_generation_time = 0           # время, затрачиваемое на генерацию ресурса
        self.is_generating_res = False          # генерируется ли ресурс
        self.is_generated_res = False           # ресурс сгенерирован и лежит возле здания?
        self.to_building_subtype = "__none__"   # название подтипа здания, в которое нужно нести ресурсы от данного здания
        self.res_cell = {"col":0, "row":0}      # ячейка выкладывания ресурса
        #self.base_resource_count = 0    #??? базовый ресурс, из которого идет производство???
        self.has_base_res = False       # достаточно ли базового ресурса, из которого идет производство
        self.tasks_member = {}          # участником каких заданий является данное здание. см. start_task_participation, stop_task_participation
        self.is_upgrading = False           # здание в процессе апгрейда?
        self.has_next_level = False         # есть ли куда обновлять здание? Или это уже максимум?
        self.next_res = None                #??? кол-во ресурсов, необходимое для апгрейда до следующего варианта
        self.button_res_enough = False  # достаточно ли ресурсов для апгрейда - используется в состоянии кнопки
        self.is_zone_hlighted = False   # находится ли курсор над объектом, отличается от self.is_mouse_over, предназначен для показа зоны подсветки
        self.is_mouse_over = False          # мышь находится над объектом?
        self.is_selected = False            # объект выделен?
        self.is_indians = False             # это индейское здание?
        self.is_under_attack = 0    # на здание нападает варвар, со зданием ничего нельзя делать (счетчик, варваров может быть больше одного)
        self.energy = 100 #percent
        self.energy_hit = self.GetAttrInt('action_hit') #percent per hit
        if self.energy_hit == 0:
            self.energy_hit = 10
        self.is_internal_free_units = False     # если вместо 'free_unit' из UMgr нужно использовать "внутренний" список
        self._internal_free_units = []          # внутренний список свободных юнитов
        self.action_unit_name = self.GetAttrStr('action_unit_name')     # название шаблона юнита, который использует данное здание
        self.max_variant = self.GetAttrStr('max_variant')               # ограничение на максимальный вариант при апгрейдах
        self.is_deactivated = self.GetAttrBool('deactivated')           # здание деактивировано для взаимодействия с игроком (типсы, похоже, лучше оставить)
        self.is_mouse_over_zone = ''                                    # название группы изображений, над которой сейчас находится курсор
        self.non_selectable = self.GetAttrBool('non_selectable')        # объект "невыделяемы", не подсвечиваемый и без селекта - почти как deactivated, но deactivated может активироваться, а вот non_selectable - никогда
        self.is_offscreen = True
        self.arrow_shown = False
        self.clock_shown = False
        self.lock_shown = False
        self.prev_fog_r = 0
        self.fog_r = self.GetAttrInt('fog_r')
        #self.task_call_res_uid = 0
        self.show_action_zone = False       # пока для Woodcutter - зона деревьев
        self.extra_event = self.GetAttrStr('extra_event')   # нужно в самом начале прочитать эти данные, чтобы вариант не перетер
        self.is_shaded = self.GetAttrBool('shaded')
        if self.is_shaded:
            self.Drawer.SetShaded(self.shaded_layers, True)
        if self.non_selectable:
            self.SetMouseActive(False)      # отключаем проверку на взаимодействие с мышью

        self.on_before_building_upgrade()
        #self.on_building_upgrade()
# ============================================================
    def dispose(self):
        pass
# ============================================================
    def set_under_attack(self):
        self.is_under_attack += 1
        if self.is_under_attack > 1: self.is_under_attack = 1 # у нас не более одного атакующего на здание
        self.lost_resource()        # теряем производимый ресурс
        self.switch_animation()
# ============================================================
    def reset_under_attack(self):
        self.is_under_attack -= 1
        if self.is_under_attack < 0: self.is_under_attack = 0
        if self.is_under_attack == 0:
            self.start_resource_generation()
            #self.call_units_or_start_resgen()
        self.switch_animation()
# ============================================================
    def is_broken(self):
        return (self.status == 'broken')
# ============================================================
    def is_main(self):
        return False
# ============================================================
    def on_msg(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        '''Предобработчик сообщений. Отделяет системные сообщения от обычных. И вызывает соответстующие методы обработки.'''
        if msg_type == 'refresh_next_res':
            self.update_next_res()
        elif msg_type == 'signal_msg':
            self.on_signal(msg_param1)
        elif msg_type == 'state_machine':
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == 'click':
            self.on_click(msg_param1)
        elif msg_type != 'on_create':
            self.on_message(msg_type, msg_param1, msg_param2, msg_dict)
        elif msg_type == 'on_create':
            self.on_create()
# ============================================================
    def on_msg_now(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'mouse_in':
            self.on_mouse_in(msg_param1)
        elif msg_type == 'mouse_out':
            self.on_mouse_out()
# ============================================================
    # interaction interface for objects
    def on_interact(self, sender, cmd, additional):
        '''Пока не используется'''
        if cmd == "building":
            return
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        '''Обработчик всех обычных сообщений (которые не были обработаны в on_msg)'''
        pass
# ============================================================
    def on_signal(self, signal):
        '''Обработчик сигналов'''
        #if signal == 'offscreen' and self.get('subtype') == 'verf':
        if signal == 'resource_generated':
            self.generate_resource()
        elif signal == 'update_button_signal':
            _rnd_time = tools.Rand(450, 550)    # чтобы не нагружать всех в один момент времени
            try:
                self.Signals.Restart('update_button_signal', _rnd_time) # здесь непонятный баг, вроде при апгрейдах зданий...
            except:
                trace('BUG: self.Signals.Restart("update_button_signal")', self)    # затычка, чтобы не падало и чтобы больше узнать про баг
            self.update_res_enough_state()
        elif signal == 'show_zone':
            # покажем зону здания
            self.show_action_zone = True
            self.is_zone_hlighted = True
            self.Drawer.ShowImages('zone', True)
        elif signal == 'ah_signal':
            self.anim_helper.start_next_animation()
        elif signal == 'got_access':
            _seq = 0
            if not self.is_green_state(): _seq = 1
            self.Drawer.SetSequence('arrow', _seq)
            self.switch_animation()
        elif signal == 'no_access':
            self.Drawer.SetSequence('arrow', 1)    # в любом случае красная будет
            self.switch_animation()
        elif signal == 'call_unit_with_res_signal':
            self.call_unit_with_res()
# ============================================================
    def update_res_enough_state(self, check_green = True):
        '''По сути это уже не только обновление состояния достаточности ресурсов'''
        prev_button_res_enough = self.button_res_enough
        if self.next_res:
            self.button_res_enough = UStats.IsResEnough(self.next_res)#, self.get('uid')) #<< нужно бы IsResEnough проверить по UID и что туда приходит
        else:
            self.button_res_enough = True   #@@ затычка от красного цвета
        if prev_button_res_enough != self.button_res_enough:
            self.switch_animation()
        if check_green:
            _is_green_state = self.is_green_state()
            _seq = 0
            if not _is_green_state: _seq = 1
            self.Drawer.SetSequence('arrow', _seq)
# ============================================================
    def on_state_machine(self, type, state_name, extra):
        '''Обработчик всех событий стейт-машины'''
        if type == "enter":
            self.switch_animation()
            self.on_state_enter(state_name, extra)
            return
        elif type == "exit":
            self.on_state_exit(state_name, extra)
            return
        elif type == "change":
            self.on_state_change(extra.prev_state, extra.next_state)
# ============================================================
    def on_state_enter(self, state_name, additional):
        if state_name == 'awaiting_action':
            BMgr.SuspendPriority(self.get('name'))
            BMgr.SuspendBuildTemplate(self.get('name'), True)
            self.is_priority_building = True
            #self.stop_resource_generation()
            self.on_awaiting_action()
# ============================================================
    def on_state_exit(self, state_name, additional):
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        building_info = {'type':self.get('type'), 'subtype':self.get('subtype'), 'uid':self.get('uid')}
        if cur_state != next_state:
            if cur_state == 'build':
                EMgr.send_event( 'build_building_complete', self, building_info )
                if self.is_priority_building:
                    EMgr.send_event('priority_complete', self, building_info)
                    self.is_priority_building = False
                self.on_build_complete(building_info)
            elif cur_state == 'upgrade':
                if self.prev_status == 'broken':    # prev_status, т.к. событие приходит уже после того, как произошла смена варианта
                    EMgr.send_event( 'build_repair_complete', self, building_info )
                    if self.is_priority_building:
                        EMgr.send_event('priority_complete', self, building_info)
                        self.is_priority_building = False
                    self.on_repair_complete(building_info)
                else:
                    EMgr.send_event( "build_upgrade_complete", self, building_info )
                    self.on_upgrade_complete(building_info)
            elif cur_state == 'awaiting_action':
                if next_state == 'normal':  # значит отменили
                    BMgr.UnsuspendPriority(self.get('name'))
                    BMgr.SuspendBuildTemplate(self.get('name'), False)
                    self.is_priority_building = False
        # ---
            if next_state == 'build':
                self.PlaySoundG('SND_BUILDING_LOOP')
                self.Drawer.RestartEffect('build')
            elif next_state == 'upgrade':
                self.PlaySoundG('SND_BUILDING_LOOP')
                if self.status == 'broken':
                    self.Drawer.RestartEffect('repair')
                else:
                    self.Drawer.RestartEffect('upgrading')
                    self.lost_resource()     # остановим генерацию ресурса, если здание начало апгрейд
# ============================================================
    def on_awaiting_action(self):
        pass
# ============================================================
    def on_repair_complete(self):
        '''Для обработки ситуации окончания repair'''
        self.send_extra_event()
# ============================================================
    def on_upgrade_complete(self, building_info):
        '''Для обработки ситуации окончания upgrade'''
        self.send_extra_event()
# ============================================================
    def on_build_complete(self, building_info):
        '''Для обработки ситуации окончания build'''
        pass
# ============================================================
    def on_survived_activate(self): #, building_info):
        '''Для обработки ситуации активации выживших зданий'''
        pass
# ============================================================
    def on_cancel_build(self):
        pass
# ============================================================
    def on_build_started(self):
        pass
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        _has_access = self.HasAccess()
        if not _has_access:
            trace('Cancel click (access)', self.get('name') )
            LBoard.CrossNoToLastClick()
            return
        _is_active = self.is_active()
        if not _is_active:
            trace('Cancel click (inactive)', self.get('name') )
            trace('Cancel info:', self.is_deactivated, self.non_selectable, self.get_next_level_name(), self.is_under_attack)
            #LBoard.MoveCameraToLastClick()
            LBoard.CrossNoToLastClick()
            return
        self.on_mouse_out() # чтобы обновить состояние селекта
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if self.status in ['broken', 'place', 'map_place']: _has_barbarians = False
        if self.subtype == 'watchtower': _has_barbarians = False
        if _has_barbarians:
            LBoard.CrossNoToLastClick()
            return
        state = self.SM.GetCurrentState()
        _name = self.get('name')
        _need_worker = not self.GetAttrBool('need_no_worker')
        if not BMgr.Is_build_action_possible(_name, _need_worker):
            trace('Cancel click (no_worker)', self.get('name') )
            #LBoard.MoveCameraToLastClick()
            LBoard.CrossNoToLastClick()
            return
        was_remove = False
        _is_next_level_possible = self.is_next_level_possible()
        if _is_next_level_possible and state not in ['upgrade', 'build'] and self.status != 'place':
            if btn_name in ['button']:
                #dima: default, floor, _click_rect_ removed
                if self.status == 'normal':
                    self.PlaySoundG('SND_UPGRADE_DONE')
                else:
                    self.PlaySoundG('SND_CLICK_TASK')
                TMgr.add_task( task_upgrade.UpgradeTask(self) )
                self.show_arrow(False)
            else: LBoard.CrossNoToLastClick()
        # elif state == "upgrade":
            # if btn_name == "button":
                # task = self.get_participating_task("upgrade_building")
                # if task:
                    # task.cancel()
                # self.start_resource_generation()    # начнем генерацию ресурсов
                # self.SM.SetState('normal')
        # elif state == "build" or self.status == "place":
        elif state == 'awaiting_action':    # or self.status == "place":
            if btn_name == 'button':
                task = self.get_participating_task('build_building')
                if task:    # если строили новое здание, но отменили
                    self.PlaySoundG('SND_CLICK_TASK_CANCEL')
                    task.cancel()
                    _is_fixed_place = self.GetAttrBool('fixed_place')
                    if not _is_fixed_place:     # потому что предустановленное здание на поле остается!
                        BMgr.remove_building(self)
                        was_remove = True
                else:            # если апгрейдили существующее
                    task = self.get_participating_task('upgrade_building')
                    if task:    # если отменяем апгрейд
                        self.PlaySoundG('SND_CLICK_TASK_CANCEL')
                        task.cancel()
                    self.start_resource_generation()    # начнем генерацию ресурсов
                self.SM.SetState('normal')
            else: LBoard.CrossNoToLastClick()
        else:
            LBoard.CrossNoToLastClick()
        if not was_remove:
            self.on_mouse_in(btn_name)
        # добавить задание на апгрейд/ремонт здания
            #@ self.switch_level() #@ перенести в Task
# ============================================================
    highlight_layers = ['floor','default','unit','anim','build','upgrading']
# ============================================================
    def on_mouse_in(self, over_zone):
        if self.status == 'normal':
            if not self.lock_shown:
                self.Signals.Restart('show_zone', 700)
        state = self.SM.GetState()
        if state == 'awaiting_action':  # ожидаем строителей
            if over_zone != 'button':
                if self.is_mouse_over_zone != 'button':   # если навели/убрали не на/с кнопку
                    self.is_mouse_over = False
                    self.is_selected = False
                    return
        self.is_mouse_over_zone = over_zone
        _is_active = self.is_active()
        if not _is_active:
            self.is_mouse_over = False
            self.is_selected = False
            return
        self.is_mouse_over = True
        #self.is_mouse_over_zone = over_zone
        _need_highlight = True
        #self.Drawer.HighlightImages(self.highlight_layers, True)
        if state in ['build', 'upgrade'] or self.status == 'map_place':
            _need_highlight = False
            #self.Drawer.HighlightImages(self.highlight_layers, False)
        self.Drawer.HighlightImages(self.highlight_layers, _need_highlight)
        self.check_button_only_selection(state)
        btn_frame = self.Get_button_frame()
        if btn_frame >= 0:
            self.Drawer.SetFrame('button', btn_frame)
        if state in ['', 'normal'] and not self.is_deactivated and not self.clock_shown:
            self.is_selected = True
            self.Drawer.ShowImages('select')
        else:
            self.is_selected = False
            self.Drawer.ShowImages('select', False)
# ============================================================
    def on_mouse_out(self):
        self.is_zone_hlighted = False
        self.show_action_zone = False
        self.Drawer.ShowImages('zone', False)
        self.Signals.Cancel('show_zone')
        _is_active = self.is_active()
        if not _is_active:
            self.is_mouse_over = False
            self.is_selected = False
            return
        self.is_mouse_over = False
        self.is_mouse_over_zone = ''
        self.Drawer.HighlightImages(self.highlight_layers, False)
        btn_frame = self.Get_button_frame()
        if btn_frame >= 0:
            self.Drawer.SetFrame('button', btn_frame)
        self.is_selected = False
        self.Drawer.ShowImages('select', False)
# ============================================================
    def on_before_building_upgrade(self):
        '''Вызывается перед апгрейдом здания. Включая начальную инициализацию'''
        #self.lost_resource()
        #self.is_generating_res = False
        #self.Signals.Cancel("resource_generated")   # отменим генерацию ресурса
        self.init_building_cells()
# ============================================================
    def on_upgrade_cancel(self):
        pass
# ============================================================
    def on_upgrade_started(self):
        pass
# ============================================================
    def on_building_upgrade(self):
        '''Метод инициализации здания при смене варианта или первичном размещении на карте
            Вырезает туман войны, строит дороги и прочее...'''
        self.max_units_count = self.GetAttrInt("max_units")
        self.build_progress = 0
        self.build_time = self.GetAttrInt("build_time")
        self.max_build_units = self.GetAttrInt('max_build_units')
        self.res_generation_time = self.GetAttrInt("res_gen_time")
        #self.reinit_effectiveness_params()  # после "res_gen_time"
        self.start_cell_pos = self.GetAttrCellFixed("start_cell")
        #self.start_cell_pos = self.FixAddCell(self.cell_pos, start_cell)
        self.road_cell_pos = self.GetAttrCellFixed("road_cell")
        if self.HasAttr("res_cell"):
            self.res_cell = self.GetAttrCellFixed("res_cell")
        else:
            self.res_cell = self.start_cell_pos # если у здания нет ресурсной клетки, то стартовая подменяет ее
        self.prev_status = self.status
        self.status = self.GetAttrStr("status")
        _is_home = self.is_home()
        if _is_home:
            self.SetIsHome(True)
        self.add_fog_circle()
        self.init_default_images()
        self.init_building_cells()
        # если нужно, то построим дорогу:
        self.build_road_on_upgrade(self.prev_status)
        # если нужно, то создадим юнитов внутри здания:
        self.create_building_units()
        #self.start_resource_generation()
        if not self.is_deactivated:
            self.call_units_or_start_resgen()
        self.update_next_res()
        if self.is_shaded:
            self.Drawer.SetShaded(self.shaded_layers, True)
        #self.is_deactivated = self.GetAttrBool('deactivated')
        self.non_selectable = self.GetAttrBool('non_selectable')
        if self.non_selectable:
            self.SetMouseActive(False)
        self.switch_animation()
        self.SendMsg('upgrade_complete')
# ============================================================
    def call_units_or_start_resgen(self):
        if not self.worker_units:       # если юнитов ранее еще не вызывали
            _state = self.SM.GetState()
            if _state in ['', 'normal']:
                _is_home = self.is_home()
                if not _is_home:
                    if self.status == 'normal':
                        if not self.is_indians:
                            if self.GetAttrBool('need_no_worker') == False:
                                TMgr.add_task( task_callworker.CallWorkerTask(self) )   # позовем юнита для начала работ
        else:   # если уже есть работники
            self.start_resource_generation()
# ============================================================
    def add_fog_circle(self):
        '''Данный метод нужен для того, чтобы его можно было переопределять'''
        if self.status != 'broken':
            trace('add_fog_circle:', self.prev_status, self.status)
            self.AddFogCircle(self.is_main())
            if self.subtype in ['totem', 'totem_stone']:
                if self.prev_status not in ['__none__', '']:
                    if self.prev_status == 'normal' and self.status == 'normal':
                        pass
                    else:
                        trace('TOTEM:', self.prev_status, self.status)
                        self.AddEffect('fog_off_big', self.get('position'))
                        self.PlaySoundG('SND_NEW_AREA')
# ============================================================
    def on_create(self):
        '''Метод инициализации при первичной установке на карту (не важно предустановка это или постройка)'''
        self.on_building_upgrade()  # вызывать только здесь, чтобы все объекты уже установились на карту
        self.reinit_effectiveness_params() # после self.on_building_upgrade()  (потому что res_generation_time)
        #self.init_default_images()
        #self.add_fog_circle()
        self.build_road_on_create()
        _rnd_time = tools.Rand(450, 550)
        self.Signals.Restart('update_button_signal', _rnd_time)   # обновляем состояние кнопки раз в полсекунды
        _seq = 0
        if not self.is_green_state(): _seq = 1
        self.Drawer.SetSequence('arrow', _seq)
        self.switch_animation()
# #######################################################
# #######################################################
# #######################################################
    def switch_animation(self):
        state = self.SM.GetCurrentState()
        # далее финальная часть, чтобы в тумане не вылазили части объекта:
        if self.Drawer.IsPartiallyInFog():
            self.Drawer.ShowImages('', False)
            self.Drawer.ShowImages('floor')
            self.Drawer.SetSequence('floor', self.current_episode-1)
            return
        self.Drawer.ShowImages('', False)
        self.Drawer.ShowImages(['floor','icons'])
        self.Drawer.SetSequence('floor', self.current_episode-1)
        self.Drawer.ShowImages('resources', self.is_generated_res)
        self._switch_animation_extra('begin')
        if state in self._normal__empty:         # '' (empty) - это состояние после выхода из любого другого
            self.Drawer.ShowImages(['default','anim'])
            self.Drawer.ShowImages('unit', self.need_to_show_unit())
            self.Drawer.ShowImages('no_action', self.need_no_action())
            self.Drawer.ShowImages('pers_no_action', self.need_pers_no_action())
            has_worker = len(self.worker_units) > 0
            if self.is_under_attack == 0:
                self.Drawer.ShowImages('worker_inside', has_worker)
            _need_no_unit = not has_worker and self.status == 'normal'
            self.Drawer.ShowImages('no_unit', _need_no_unit)
            self._switch_animation_extra('normal')
        elif state == 'awaiting_action':        # ожидания действия юнита - нужно галку показывать
            self.Drawer.ShowImages(['default','anim'])
            self.Drawer.ShowImages('unit', self.need_to_show_unit())
            self.Drawer.ShowImages('no_action', self.need_no_action())
            self._switch_animation_extra('awaiting')
        elif state == 'build':
            self.Drawer.ShowImages('build')
            self.Drawer.SetProgressedAnimation("build")
            #self.Drawer.RestartEffect('build')
            self._switch_animation_extra('build')
        elif state == 'upgrade':
            #if self.get('subtype') not in ['verf', 'boatyard', 'dam']:
            if not self.IsSubTypeOf(['verf', 'boatyard', 'dam']):
                if self.status == 'broken':
                    self.Drawer.ShowImages('default')  # у сломанного состояния нет доп. изображения
                    self.Drawer.ShowImages('repair')
                    #self.Drawer.RestartEffect('repair')
                else:
                    self.Drawer.ShowImages('upgrading')
                    #self.Drawer.RestartEffect('upgrading')
            #if self.status not in self._place__broken:
            #    self.Drawer.ShowImages("anim")      # анимации можно показывать и при строительстве, хотя, возможно, в некоторых зданиях придется их отключать
            self._switch_animation_extra('upgrade')
        btn_frame = self.Get_button_frame()
        if btn_frame >= 0:  self.Drawer.SetFrame('button', btn_frame)
        self.Drawer.ShowImages('select', not self.is_deactivated and self.is_selected)
        _is_active = self.is_active()
        if not _is_active or state in ['build', 'upgrade', 'awaiting_action']:
            self.Drawer.ShowImages('select', False)
            self.Drawer.HighlightImages(self.highlight_layers, False)
        self.check_button_only_selection(state)
        self.Drawer.ShowImages('arrow', self.arrow_shown)
        self.Drawer.ShowImages('clock_wait', self.clock_shown)
        self.Drawer.ShowImages('lock', self.lock_shown)
        if state not in ['build', 'upgrade', 'awaiting_action']:
            if self.show_action_zone:
                self.Drawer.ShowImages('zone', self.is_zone_hlighted)  # для b_woodcutter нужно
            else:
                self.Drawer.ShowImages('zone', False)
        else:
            self.Drawer.ShowImages('zone', False)
        self.anim_helper.show_last_anim()
        self._switch_animation_extra('end')     # всегда в конце
# ============================================================
    def check_button_only_selection(self, state):
        if self.is_cancel_button_mode(state):
            if self.is_mouse_over_zone != 'button':
                self.Drawer.HighlightImages(self.highlight_layers, False)
                self.Drawer.ShowImages('select', False)
                self.is_selected = False
            else:
                self.Drawer.HighlightImages(self.highlight_layers, False)
                self.Drawer.ShowImages('select', False)
                self.is_selected = False
                    #    self.Drawer.ShowImages('select')
# ============================================================
    def _switch_animation_extra(self, place):
        '''Метод для переопределения в подклассах
        place: точка вызова метода'''
        pass
# ============================================================
    def Invalidate(self):
        '''перерисовка объекта, вызывается из C++'''
        self.switch_animation()
# ============================================================
    def need_to_show_unit(self):
        '''Нужно ли показывать юнита в здании'''
        return self.is_generating_res and self.is_under_attack == 0
# ============================================================
    def need_no_action(self):
        '''Нужно ли показывать юнита в здании'''
        return not self.is_generating_res
# ============================================================
    def need_pers_no_action(self):
        '''Нужно ли показывать юнита в здании'''
        return not self.is_generating_res and self.worker_units and self.is_under_attack == 0
# ============================================================
    def reinit_effectiveness_params(self):
        '''Переинициализирует параметры эффективности здания'''
        if not self.has_effectivness_inited:
            self.has_effectivness_inited = True
            _new_max_res_generation_time = self.GetAttrInt('res_gen_time_max')
            _new_max_res_gen_time = self.GetAttrInt('gen_max_time')
            if _new_max_res_generation_time == self.max_res_generation_time:
                if _new_max_res_gen_time == self.max_res_gen_time:
                    return  # если параметры не изменились, то значит значения сохраняем
            self.res_gen_first_times = self.GetAttrInt('res_gen_first_times')
            self.max_res_gen_time = self.GetAttrInt('res_gen_maxtime')
            if self.current_effectiveness == 100 and self.res_gen_first_times > 0:  # если первый отсчет еще
                self.effectiveness_degradation_count = self.res_gen_first_times
            else:
                self.effectiveness_degradation_count = self.GetAttrInt('res_gen_ef_count')   # через сколько генераций ресурсов эффективность падает на 10%
            if self.effectiveness_degradation_count == 0:
                self.effectiveness_degradation_count = 3    # дефолтное значение
            self.max_res_generation_time = self.GetAttrInt('res_gen_time_max')
            if self.max_res_generation_time < self.res_generation_time:
                self.max_res_generation_time = self.res_generation_time + 1 # +1 чтобы избежать деления на ноль
            self.generation_count = 0               # сколько раз уже генерировали ресурс
            self.current_effectiveness = 100        # текущая эффективность (проценты)
# ============================================================
    def update_effectiveness(self):
        '''Нужно вызывать при генерации ресурса зданием'''
        self.generation_count += 1
        if not self.need_max_time:
            if self.current_effectiveness == 10:    # если это последний отсчет
                self.need_max_time = True
                self.on_minimal_effectiveness()
        if self.effectiveness_degradation_count:
            if self.generation_count >= self.effectiveness_degradation_count:
                self.effectiveness_degradation_count = self.GetAttrInt('res_gen_ef_count')  # потому что первая генерация отличается от остальных
                self.generation_count = 0
                if self.current_effectiveness > 10:     # 10% - минимальная эффективность
                    _prev_eff = self.current_effectiveness
                    self.current_effectiveness -= 10    # снимаем 10%
                    _need_help = LBoard.Core.is_help_needed(4)
                    if _need_help:
                        _item = BMgr.get_item('2542')
                        if _item: Camera.MoveTo(_item)
                        UI.open_help(True)
                    if _prev_eff >= 80: # для подсказок - они должны стартовать после падения эффективности менее 80% любого здания
                        if self.current_effectiveness < 80:
                            EMgr.SendGlobalMsg('effectiveness_80', '')
                    if self.current_effectiveness < 10: self.current_effectiveness = 10
# ============================================================
    def on_minimal_effectiveness(self):
        pass
# ============================================================
    def get_effectiveness_coeff(self):
        '''Возвращает текущую эффективность здания в диапазоне [0.0 .. 1.0]'''
        return (self.current_effectiveness / 100)
# ============================================================
    def get_effective_gen_time(self):
        '''Возвращает время генерации ресурса с учетом эффективности здания'''
        #_need_res = self.need_base_resource()
        if self.subtype in self.has_no_effectiveness:
            return self.res_generation_time
        if self.need_max_time:
            if self.max_res_gen_time:
                return self.max_res_gen_time    # если требуется максимальное время генерации
        coeff = self.get_effectiveness_coeff()
        gen_time = self.res_generation_time
        max_gen_time = self.max_res_generation_time
        return gen_time + ((1 - coeff)/0.9)*(max_gen_time - gen_time)
# ============================================================
    def switch_level(self, action = '_none_', extra_text = ''):
        '''Здесь происходит "апгрейд" здания, смена варианта. Здесь должны (!) проверяться все необходимые требования, кроме кол-ва ресурсов'''
        var_name = self.get('variant_name')    # текущий вариант
        if self.max_variant == var_name:
            return      # уже максимальный уровень
        if var_name in self.variants_switch:
            _prev_status = self.status
            next_var_name = self.variants_switch[var_name]
            self.show_arrow(False)
            self.energy = 100   # на всякий случай восстановим энергию
            trace('switch_level: action =', action)
            trace(' switch_level:', self.get('name'), self.get('uid'), next_var_name)
            self.SwitchLevel(next_var_name)   # переключаемся на следующий вариант
            self.energy_hit = self.GetAttrInt('action_hit') # чтобы при смене вариантов обновлялось
            self.update_next_res()
            self.switch_animation()
            self.unreserve_action_cells()
            #if _prev_status == 'broken':    # если здание было сломано, то
            # отремонтировано обычное здание, либо отремонтировано/построено priority-здание
            if next_var_name != 'place':
                BMgr.AddRepaired( self.get('name'), next_var_name )    # добавим его в список отремонтированных
                BMgr.RemoveBuildTemplate(self.get('name'), True)
            if self.get('stype') not in ['farm_field']:
                self.AddEffect('build_end', self.get('position'))
                self.PlaySoundG('SND_BUILDING_COMPLETE')
            letter = []
            if not self.IsSubTypeOf('farm_field'):  # поля не должны ничего подобного генерировать
                if action:
                    if action == 'builded': letter.append( ('text', 'MSG_BUILDED') )
                    elif action == 'upgraded': letter.append( ('text', 'MSG_UPGRADED') )
                    elif action == 'repaired': letter.append( ('text', 'MSG_REPAIRED') )
                    elif action == 'boat_build': letter.append( ('text', 'MSG_BOAT_COMPLETE') )
                    letter.append( 'space' )
                    letter_item_name = self.GetAttrStr('letter_name')
                    if not letter_item_name:    # если значение не определено
                        letter_item_name = self.GetAttrStr('item_name')
                    letter.append( ('text', letter_item_name) )
                else:
                    letter = extra_text
                EMgr.AppendLetter(letter, self.get('uid'))
                if action == 'upgraded':    # после апгрейда сразу вызываем юнита с ресурсом
                    self.call_unit_with_res()
                #if action in ['builded', 'upgraded']:
                #    self.Drawer.ShowImages('star_effect')
                #    self.Drawer.RestartEffect('star_effect')
            if _prev_status == 'broken':
                _workers_count = len(self.worker_units)
                if _workers_count > 0:  # если работник уже внутри
                    self.call_unit_with_res()   # вызовем юнита с ресурсами
            _non_selectable = self.GetAttrBool('non_selectable')
            if _non_selectable:             # может меняться только в сторону невыделяемости, но не обратно
                self.SetMouseActive(False)
                self.non_selectable = True
            self.on_switch_level_complete()
        self.update_res_enough_state()      #@? возможно лишний вызов, в update_next_res должно вызываться
# ============================================================
    def on_switch_level_complete(self):
        pass
# ============================================================
    def switch_to_blocked_level(self):
        '''Здесь происходит "апгрейд" здания, смена варианта. Здесь должны (!) проверяться все необходимые требования, кроме кол-ва ресурсов'''
        var_name = self.get("variant_name")    # текущий вариант
        if var_name in self.blocked_switch:
            _prev_status = self.status
            next_var_name = self.blocked_switch[var_name]
            self.show_arrow(False)
            trace('switch_to_blocked_level:')
            trace(' switch_to_blocked_level:', self.get('name'), self.get('uid'), next_var_name)
            self.SwitchLevel(next_var_name)   # переключаемся на следующий вариант
            self.update_next_res()
            self.switch_animation()
            self.unreserve_action_cells()
            self.is_thrown = True
        self.update_res_enough_state()  #@? лишнее?
# ============================================================
    def switch_level_to_place(self):
        '''Здесь происходит смена шаблона с map_place на place'''
        _is_fixed_place = self.GetAttrBool('fixed_place')
        if _is_fixed_place:     # только для тех зданий, где фиксированное место
            var_name = self.get('variant_name')    # текущий вариант
            #_mplace = 'map_place'
            #_var_name_part = var_name[:len(_mplace)]
            _is_map_place = var_name.startswith('map_place')
            if _is_map_place:
                self.prev_mplace_name = var_name
                next_var_name = self.variants_switch[var_name]
                self.show_arrow(False)
                trace('switch_level_to_place:')
                trace(' switch_level_to_place:', self.get('name'), self.get('uid'), next_var_name)
                self.SwitchLevel(next_var_name)   # переключаемся на следующий вариант
                self.update_next_res()
                self.switch_animation()
# ============================================================
    def cancel_switch_level_to_place(self):
        '''Отмена смены шаблона с map_place на place, т.е. переключение наоборот: place на map_place'''
        _is_fixed_place = self.GetAttrBool('fixed_place')
        if _is_fixed_place:     # только для тех зданий, где фиксированное место
            var_name = self.get("variant_name")    # текущий вариант
            if var_name == 'place':
                next_var_name = self.prev_mplace_name   #self.cancel_switch_place_variant_name
                self.show_arrow(False)
                trace('cancel_switch_level_to_place:')
                trace(' cancel_switch_level_to_place:', self.get('name'), self.get('uid'), next_var_name)
                self.SwitchLevel(next_var_name)   # переключаемся на предыдущий вариант
                self.update_next_res()
                self.switch_animation()
                self.unreserve_action_cells()
# ============================================================
    def update_next_res(self):
        '''Обновляет значение ресурсов, необходимых для апгрейда на следующий уровень'''
        #_stype = self.get('stype')
        _is_home = self.is_home()
        _need_worker = not self.GetAttrBool('need_no_worker')
        if _need_worker and self.status == 'normal' and not self.worker_units and not _is_home:
            self.has_next_level = False
        else:
            next_var_name = self.get_next_level_name()
            if next_var_name:
                self.has_next_level = True
                self.next_res = self.get_needs_res(next_var_name)
            else:
                self.has_next_level = False
        self.update_res_enough_state()
        btn_frame = self.Get_button_frame()
        if btn_frame >= 0:
            self.Drawer.SetFrame('button', btn_frame)
        #if self.get('subtype') == 'hq':
        #    mbox(to_str(self.has_next_level, self.next_res))
# ============================================================
    def create_building_units(self):
        '''Создает необходимое кол-во юнитов в здании, если у здания они должны быть
            При апгрейде здания досоздает необходимое кол-во'''
        cur_units_count = self.GetAttrInt("start_units")
        if self.status not in self._place__broken:
            for i in range(self.cur_units_count, cur_units_count):      # добавим недостающее кол-во юнитов
                unit = UMgr.create_unit(self.action_unit_name)
                self._building_units.append(unit)
                unit.set_home(self)
                unit.CheckIsInFog(True)     # проверка на то, что юнит не в тумане и прочее
                if self.is_internal_free_units:
                    self._internal_free_units.append(unit)
                else:
                    UMgr.add_free_unit(unit)     # новые юниты свободны: у нас свободное общество!
            self.cur_units_count = cur_units_count # обновим текущее кол-во юнитов(созанных данным зданием)
# ============================================================
    def build_road_on_upgrade(self, prev_status):
        '''Строит дорогу, если необходимо'''
        #trace("name:", self.get("name"), "self.road_cell_pos", self.road_cell_pos, "self.cell_pos", self.cell_pos, "road_cell", self.GetAttrCell("road_cell"))
        if not self.road_was_builded:
            if prev_status != '__none__':
                _has_road = self.GetAttrBool('has_road')
                if _has_road:  # если это не предустановленное здание (prev_status != "__none__")
                    if self.status != 'map_place':
                        self.BuildRoad(self.road_cell_pos, True)
                        self.road_was_builded = True
# ============================================================
    def build_road_on_create(self):
        if not self.road_was_builded:
            if self.status in self._normal__broken:
                if self.GetAttrBool("has_road"):  # если это объект предустановленный на уровень (у обычных status == "place")
                    _skipFog = (self.status == 'normal')
                    if not self.get('accessible'):  # если мы в зоне недоступности, то
                        _skipFog = False    # строить дорогу в тумане
                    self.BuildRoad(self.road_cell_pos, _skipFog)
                    #self.BuildRoad(self.road_cell_pos, False)
                    self.road_was_builded = True
# ============================================================
    def init_building_cells(self):
        # сделаем выборку ячеек (имен) строительства (от 1 до 8 точек):
        del self.building_cells_names[:]
        for i in range(1,8+1):
            cell_name = "build" + str(i) + "_cell"
            if self.HasAttr(cell_name):
                self.building_cells_names.append(cell_name)
        self.barb_cells_names = []
        for i in range(0,4):
            cell_name = 'attack' + str(i+1) + '_cell'
            if self.HasAttr(cell_name):
                self.barb_cells_names.append(cell_name)
# ============================================================
    def init_default_images(self):
        self.Drawer.ShowImages("", False)
        self.Drawer.ShowImages("floor")
        self.Drawer.ShowImages("default")
        self.Drawer.ShowImages("unit")
        self.Drawer.ShowImages("anim")
        self.Drawer.ShowImages('resources')
# ============================================================
    def start_resource_generation(self):
        '''Начинает генерацию ресурса, если здание может его генерировать'''
        if self.status == 'broken':  # не производим, если здание поломано
            return
        if self.is_under_attack > 0:    # если под атакой - тоже не производим
            return
        _state = self.SM.GetState()
        if _state == 'upgrade':     # во время апгрейда не генерируем ресурсы
            return
        res = self.GetRes('normal_gives_1')
        _is_res_empty = True
        if res: _is_res_empty = res.Empty()
        if _is_res_empty:     # если ресурс не задан, то здесь делать нечего
            return
        res_name = res.GetSingleName()
        _is_generating = self.has_generating_res_progress()
        if _is_generating:                  return
        if not res_name:                    return
        if not self.res_generation_time:    return
        if self.status != 'normal':         return
        resource_enough = False
        _need_base_resource = self.need_base_resource()
        if _need_base_resource:
            if self.has_base_res:
                resource_enough = True
        else:
            resource_enough = True
        # у нас всегда единичное кол-во ресурса приносится
        if resource_enough: # and self.status == "normal" and self.res_generation_time > 0:
            self.is_generating_res = True
            self.on_res_gen_started()
            self.Drawer.ShowIn('unit')
            self.Signals.Restart("resource_generated", self.get_effective_gen_time())
            self.switch_animation()
# ============================================================
    def on_res_gen_started(self):
        pass
# ============================================================
    def stop_resource_generation(self):
        #if self.is_generating_res:
        self.Signals.Cancel('resource_generated')
        self.is_generating_res = False
        self.switch_animation()
# ============================================================
    def generate_resource(self):
        '''Генерирует ресурс возле здания'''
        self.update_effectiveness()
        if not self.is_generated_res:   # если ресурс еще не сгенерирован
            self.is_generating_res = False
            self.is_generated_res = True
            self.Drawer.ShowOut('unit')
            self.Drawer.ShowImages('resources', True)   # показать ресурс
            _pos = self.GetAttrPoint('center_res_pos')
            self.Drawer.ResIn('resources', _pos, 1000)
            cell = self.GetAttrCellFixed('res_cell')
            TMgr.add_task( task_res.TakeResTask(self, cell) )   # создать таск "забрать ресурс"
            # - нужно попробовать повторить данный таск, только главное не создать багов при этом
            # например дублей...
        self.switch_animation()
# ============================================================
    def scale_bump(self):
        _pos = self.GetAttrPoint('center_item_pos')
        self.Drawer.ScaleBump(self.bump_layers, _pos, 120, 1.016)
        _is_stone = self.GetAttrBool('is_stone')
        if _is_stone:
            self.PlaySound('SND_HAMMER_HIT_ROCK')
        else:
            self.PlaySoundRandom(['SND_HAMMER_HIT_1', 'SND_HAMMER_HIT_2', 'SND_HAMMER_HIT_3'])
# ============================================================
    def call_unit_with_res(self):
        _need_base_resource = self.need_base_resource()
        _state = self.SM.GetState()
        if _need_base_resource:
            _skip = False
            if _state == 'upgrade':         _skip = True
            if self.is_under_attack > 0:    _skip = True
            if self.status == 'broken':     _skip = True
            if not _skip:
                _workers_count = len(self.worker_units)
                if _workers_count > 0:
                    if not self.is_generating_res:
                        if not self.is_generated_res:
                            _res_name = self.GetSingleResName('base_resource')
                            trace('Check - building name:', self.get('name'))
                            _cell = self.FixAddCell(self.cell_pos, self.GetAttrCell("res_cell"))
                            _task = task_res_store.TakeResStoreTask(self, _cell, _res_name)
                            TMgr.add_task( _task )  # добавим таск, там установится UID
                            #self.task_call_res_uid = _task.uid # сохраним UID на случай поломки здания
                            self.Signals.Restart('call_unit_with_res_signal', 5000)     # на всякий случай, чтобы через 5 секунд повторить вызов
                            return
            self.Signals.Restart('call_unit_with_res_signal', 5000)    # каждые 5 секунд пытаемся вызвать снова
# ============================================================
    def move_global_res_to_unit(self, _unit, _res_name, _need_res_value):
        '''Вообще-то данный метод должен быть не в Building, но увы...
        Метод переносит часть глобального ресурса на юнита'''
        _cur_res = UStats.GetCurRes()
        _res_count = _cur_res.Get(_res_name)
        if not _res_count:
            _unit.resource = None
        else:
            if _need_res_value >= _res_count:
                _new_res = UStats.CreateRes(_res_name, _res_count)
            else:
                _new_res = UStats.CreateRes(_res_name, _need_res_value)
            _unit.resource = _new_res
            UStats.SubRes(_new_res)
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит забирает ресурс у здания. Скрывает картинку ресурса и начинает новую цепочку производства'''
        self.Drawer.ShowImages('resources', False)
        self.is_generated_res = False # отдаем ресурс
        resource = self.GetRes('normal_gives_1')
        #if self.need_base_resource():
        #    self.base_resource_count -= resource.GetSingleValue()
        self.has_base_res = False
        self.start_resource_generation()
        TMgr.send_event('res_taken', None)
        self.SendMsg('resource_was_taken')
        self.call_unit_with_res()
        return resource
# ============================================================
    def lost_resource(self):
        '''Уменьшает на 1 кол-во ресурса у здания, при этом выставляет
        некоторые флаги того, что ресурс отдан
        Используется при атаке дикарями, чтобы "потерять" производимый ресурс'''
        if self.is_generating_res:      # если идет производство ресурса:
            self.is_generated_res = False
            self.is_generating_res = False
            self.has_base_res = False
            self.update_effectiveness()
        self.stop_resource_generation()
# ============================================================
    def take_resource(self, resource):
        '''Вызывается в момент, когда юнит отдает ресурс зданию. Может инициировать процесс генерации зависимого ресурса, либо добавляет ресурс к общим ресурсам'''
        #if self.need_base_resource():
        #    self.base_resource_count += resource.GetSingleValue()
        self.has_base_res = True
        self.start_resource_generation()    # пытаемся запустить генерацию - внутри есть проверки, если чего-то не хватает
        self.call_unit_with_res()   # на случай, если ресурса недостаточно
# ============================================================
    def has_generating_res_progress(self):
        '''Генерирует ли данное здание ресурс в данный момент, или ресурс сгенерирован (100% progress).
            Может ли данное здание принимать ресурсы. Оно не может принимать ресурсы, если
            был принят ресурс и идет процесс производства, либо ресурс сгенерирован, но еще не забран из здания,
            либо есть юнит, который намеревается нести что-то в здание.
            Здесь НЕ должно быть зависимости от типа здания (может ли оно вообще принимать ресурс). Данный метод
            используется при выборе доступных зданий'''
        if self.is_generating_res:
            return True
        if self.is_generated_res:
            return True
        else:
            return False
# ============================================================
    def is_next_level_possible(self):
        '''Возможен ли апгрейд/ремонт до следующего уровня'''
        next_var_name = self.get_next_level_name()
        if next_var_name:
            _is_home = self.is_home()
            _need_worker = not self.GetAttrBool('need_no_worker')
            if _need_worker:
                if self.status == 'normal':
                    if not self.worker_units:
                        if not _is_home:
                            return False
            res_need = self.get_needs_res(next_var_name)
            if self.SM.GetCurrentState() in self._normal__empty:   # если не в состоянии стройки и т.д.
                if self.status in self._normal__broken:         # если есть что апгрейдить
                    if res_need:
                        _is_res_enough = UStats.IsResEnough(res_need)
                        if _is_res_enough:          # если ресурсов достаточно
                            return True
        #            else:
        #                mbox("not enough res?")
        #        else:
        #            mbox(self.status)
        #    else:
        #        mbox("SM:" + self.SM.GetCurrentState())
        #else:
        return False
# ============================================================
    def get_next_level_name(self):
        '''Возвращает имя следующего варианта после текущего'''
        _template_name = self.get('name')
        var_name = self.get('variant_name')    # текущий вариант
        _can_be_repaired = BMgr.CanBeRepairedPriority(_template_name)
        if not _can_be_repaired:
            return None
        _max_global_var_name = BMgr.GetMaxBuildingVariant(_template_name)
        _max_global_var_allowed = BMgr.CanBuildMaxVariant(_template_name)
        if _max_global_var_name:
            _max_index = self.variants_indexes[_max_global_var_name]
            _cur_index = self.variants_indexes[var_name]
            if _cur_index >= _max_index:
                return None
        if var_name != self.max_variant:        # если максимальный вариант (не глобальный), то апгрейдить уже некуда
            if var_name in self.variants_switch:
                next_var_name = self.variants_switch[var_name]
                if _max_global_var_name:
                    if next_var_name == _max_global_var_name:
                        if not _max_global_var_allowed:
                            if self.status == 'normal': # если максимальный вариант строить еще нельзя
                                return None
                if self.HasVariant(next_var_name):
                    return next_var_name
        return None
# ============================================================
    def show_arrow(self, show = True):
        '''Показать/скрыть квестовую стрелку'''
        self.arrow_shown = show
        self.switch_animation()
        pass
# ============================================================
    def show_clock(self, show = True):
        '''Показать/скрыть песочные часы'''
        self.clock_shown = show
        self.switch_animation()
# ============================================================
    def show_lock(self, show = True):
        '''Показать/скрыть песочные часы'''
        self.lock_shown = show
        self.switch_animation()
# ============================================================
    def __str__(self):
        result = to_str('{ name:', self.get('name'), 'uid:', self.get('uid'), 'cell:', to_str(self.get('cell')), '}')
        return result
# ============================================================
# ============================================================
    def Get_units_count(self):
        '''Возвращает кол-во юнитов в здании. Вызывается из C++'''
        return len(self._building_units)
# ============================================================
    def is_home(self):  # is home for units
        '''Является ли данное здание домом для юнитов, если да, то нужно переопределить это в классе-потомке'''
        return 0        # default, need to override for camp, etc...
# ============================================================
    def is_store(self):
        '''Является ли данное здание хранилищем ресурсов'''
        if self.status == "normal": # только в нормальное здание можно нести ресурсы, а не в сломанное или только строящееся
            return self.GetAttrBool("handle_resources")
        else:
            return False
# ============================================================
    def need_base_resource(self):
        '''Требуется ли для данного здиния базовый ресурс, из которого идет производство основного'''
        return False
# ============================================================
    def get_status(self):
        return self.status
# ============================================================
    def Get_vacant_places_count(self):
        '''Кол-во свободных мест в домике, учитывая тех юнитов, которые еще только бегут. Вызывается из C++'''
        if not self.is_home:
            return 0
        _max = self.max_units_count
        _max = _max - len(self._building_units) - len(self.walking_home_units)# - len(self.home_sleep_units)
        return _max
# ============================================================
    def leave_unit(self, unit):
        '''Выпускает юнита из здания'''
        self._building_units.remove(unit)
        unit.show()
        trace('Building: leave_unit', unit.get('uid'), self.get('name'), self.get('uid'))
# ============================================================
    def in_unit(self, unit):
        '''Заводит юнита в здание'''
        #self.remove_walking_home_unit(unit)
        if unit not in self._building_units:
            self._building_units.append(unit)
        unit.set_home(self)
        _is_home = self.is_home()
        if _is_home:
            UMgr.add_free_unit(unit)        # на всякий случай еще раз "освободим" юнита (если был занят)
            unit.current_subtype = 'simple'
            TMgr.send_event('free_unit', unit)  # повторяем событие, чтобы сработали таски, которым нужен юнит simple-типа
        trace('Building: in_unit', unit.get('uid'), self.get('name'), self.get('uid'))
# ============================================================
    def add_walking_home_unit(self, unit):
        '''Добавляет юнита в список направляющихся домой. Эта инфа нужна для Get_vacant_places_count'''
        self.walking_home_units.append(unit)
        unit.home_building = self
# ============================================================
    def remove_walking_home_unit(self, unit):
        '''Исключает юнита из списка направляющихся домой'''
        self.walking_home_units.remove(unit)
# ============================================================
    def get_units_count(self):
        _count = 0
        for u in self._building_units:
            if u.is_in_home:
                _count += 1
        return _count
# ============================================================
    def get_first_unit(self):
        for u in self._building_units:
            if u.is_in_home:
                return u
        return None
# ============================================================
    def get_action_cell_name(self):
        '''Метод возвращает случайную клетку для юнита для строительства здания.'''
        _bcells = self.building_cells_names[:]  # работает ли???
        _has_cells = len(_bcells) > 0
        _name = self.get('name')
        for cell_name in self.reserved_building_cells_names:
            _bcells.remove(cell_name)
        for cell_name in self.building_cells_names: # убираем клетки, которые недоступны
            _cell = self.GetAttrCellFixed(cell_name)
            is_passable = self.IsCellPassable(_cell)
            if not is_passable:
                if cell_name in _bcells:
                    _bcells.remove(cell_name)
                    #trace('DBG: non passable cell', cell_name)
        length = len(_bcells)
        if length > 0:
            rnd_index = tools.Rand(0, length-1)
            return _bcells[rnd_index]
        elif _has_cells:    # если есть только непроходимые клетки (либо все зарезервированы)
            #trace('DBG had_cells:', self.get('name'), self.get('uid'))
            return None
        else:                   # если клетка не указана
            return ''
# ============================================================
    def get_attack_cell_name(self):
        '''Метод возвращает случайную клетку для дикаря для атаки здания.'''
        _bcells = self.barb_cells_names[:]
        for cell_name in self.barb_cells_names: # убираем клетки, которые недоступны
            _cell = self.GetAttrCellFixed(cell_name)
            if not self.IsCellAccessible(_cell):
                _bcells.remove(cell_name)
        length = len(_bcells)
        if length > 0:
            rnd_index = tools.Rand(0, length-1)
            return _bcells[rnd_index]
        else:
            return ''
# ============================================================
    def is_cell_passable(self, cell_name):
        '''Проходима ли ячейка здания'''
        _cell = self.GetAttrCellFixed(cell_name)
        _is_passable = self.IsCellAccessible(_cell)
        return _is_passable
# ============================================================
    def reserve_action_cell(self, cell_name):
        '''Резервирует строительную ячейку, чтобы она больше не выдвалась
        в качестве доступной для постройки'''
        if cell_name not in self.reserved_building_cells_names:
            self.reserved_building_cells_names.append(cell_name)
        pass
# ============================================================
    def unreserve_action_cells(self):
        '''Разрезервирует все зарезервированные ячейки'''
        self.reserved_building_cells_names = []
        #del self.reserved_building_cells_names[:]
        pass
# ============================================================
    def start_task_participation(self, task, sub = ''):
        '''Начало участия здания в задании'''
        _name = task.type+sub
        if _name in self.tasks_member:
            trace('ERROR: start_task_participation -> another task already participating', self.get('uid'))
            trace(' ', _name)
        self.tasks_member[_name] = ('started', task)
        trace('start_task_participation:', self.get('name'), task.type, sub, self.get('uid'))
# ============================================================
    def stop_task_participation(self, task, sub = ''):
        '''Конец участия здания в задании'''
        _name = task.type+sub
        if _name not in self.tasks_member:
            trace( self.get('name') + " stop not participating " + _name, self.get('uid') )
            for t in self.tasks_member:
                trace('   but participating in:', t)
        else:
            self.tasks_member[_name] = None
            del self.tasks_member[_name]
        trace('stop_task_participation:', self.get('name'), task.type, sub, self.get('uid'))
# ============================================================
    def is_task_participating(self, type):
        '''Участвует ли уже здание в данном типе задания. Internal use only'''
        if type in self.tasks_member:
            if self.tasks_member[type] != None:
                return True
        return False
# ============================================================
    def get_participating_task(self, type):
        '''Если здание участвует в указанном задании, то возвращает указанное задание, иначе None.
            Если заданий одного типа будет несколько, то сохранится только последнее'''
        if type in self.tasks_member:
            if self.tasks_member[type] != None:
                return self.tasks_member[type][1]
        return None
# ============================================================
    def is_active(self):
        '''Возможны ли действия над объектом в данный момент. Метод может быть переопределен'''
        #return not self.HasAccess() and not self.is_deactivated and not self.non_selectable and self.get_next_level_name() # and self.is_next_level_possible()
        if not self.is_deactivated:
            if not self.non_selectable:
                if self.is_under_attack == 0:
                    _state = self.SM.GetState()
                    if _state not in ['awaiting_action','build','upgrade']:   # если подсветка только по кнопке
                        _next_level_name = self.get_next_level_name() # and self.is_next_level_possible()
                        if _next_level_name:
                            return True
                    else:
                        return True
                    #elif self.is_mouse_over_zone == 'button':
                    #    return True
        return False
# ============================================================
    def is_active_raw(self):
        '''Не деактивировано и может селектиться'''
        #return not self.HasAccess() and not self.is_deactivated and not self.non_selectable and self.get_next_level_name() # and self.is_next_level_possible()
        return not self.is_deactivated and not self.non_selectable# and not self.lock_shown
# ============================================================
    def _cannot_repair_because_of_priority(self):
        '''Нельзя ремонтировать здание, потому что приоритеты мешают?'''
        if not self.is_deactivated:
            if not self.non_selectable:
                if self.status == 'broken':
                    if self.is_under_attack == 0:
                        _state = self.SM.GetState()
                        if _state not in ['awaiting_action','build','upgrade']:   # если подсветка только по кнопке
                            _template_name = self.get('name')
                            var_name = self.get('variant_name')
                            _can_be_repaired = BMgr.CanBeRepairedPriority(_template_name)
                            if not _can_be_repaired:
                                return True
                        else:
                            return False
        return False
# ============================================================
    def is_functional(self):
        '''Здание, которое работает, в том смысле, что не сломано, не выжившее, нормально функционирующее'''
        _has_access = self.HasAccess()
        if not _has_access:
            return False
        _is_broken = self.is_broken()
        _b_state = self.SM.GetState()
        # ---
        if _is_broken:
            if _b_state not in ['upgrade', 'awaiting_action']:   # ремонтируемое здание считается функционирующим, поэтому их оставляем
                return False                                     # остальные скипуем
        if self.is_deactivated: return False
        #if self.is_under_attack: return False
        if self.status not in ['normal', 'place', 'broken']:    # broken - мы выше уже отсекли просто поломанные, теперь только уже ремонтируемые, которые считаем рабочими
            return False # потому что place - это будущее рабочее здание
        return True
# ============================================================
    def is_functional_non_attacked(self):
        _functional = self.is_functional()
        if _functional:
            if self.is_under_attack:
                return False
            else:
                return True
        return False
# ============================================================
    def deactivate(self):
        self.is_deactivated = True
        self.is_selected = False
        self.switch_animation()
# ============================================================
    def activate(self):
        self.is_deactivated = False
        self.call_units_or_start_resgen()       # чтобы вызвать юнита
        self.switch_animation()
# ============================================================
    def get_subtask(self, parent_task, actor):
        '''Возвращает подзадание для юнита, который будет взаимодействовать с данным объектом'''
        return task_classes.Subtask(parent_task, actor)
# ============================================================
    def set_check(self, check):
        '''У зданий галки не ставятся'''
        pass
# ============================================================
    def on_worker_in(self, unit):
        '''Чтобы здание могло отловить когда пришел юнит-работник в здание'''
        self.PlaySound('SND_BUILDING_OCCUPY')
        self.update_next_res()
        self.start_resource_generation()
        self.call_unit_with_res()   # чтобы вызвать юнита с ресурсом
        self.switch_animation()
# ============================================================
# методы для отображения типса
# ============================================================
    _awaiting__build__upgrade = ['awaiting_action', 'build', 'upgrade']
    def is_green_state(self):
        '''Цвет типса/селекта'''
        if self.non_selectable: # если не выделяется, то нет смысл в красном типсе
            return True
        state = self.SM.GetCurrentState()
        if state in self._awaiting__build__upgrade:
            return True # здесь нужен зеленый типс
        _has_access = self.HasAccess()
        if self.is_deactivated:
            if not _has_access:
                return False
            else:
                return True
        if not _has_access:
            return False
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if self.status in ['broken', 'place', 'map_place']: _has_barbarians = False
        if self.subtype == 'watchtower': _has_barbarians = False
        if _has_barbarians:
            if self.status == 'normal':
                if self.has_next_level: # если апгрейдабельное здание
                    return False
        _is_active = self.is_active()
        if self.has_next_level:
            if not self.button_res_enough:
                if self.next_res:   # если НЕ хватает ресурсов на следующий апгрейд
                    return False
            _name = self.get('name')
            _need_worker = not self.GetAttrBool('need_no_worker')
            if not self.clock_shown:
                _build_possible = BMgr.Is_build_action_possible(_name, _need_worker)
                if not _build_possible:
                    return False
        if _is_active:
            return True
        if self.status == 'map_place':
            return True
        state = self.SM.GetCurrentState()
        #if state in self._awaiting__build__upgrade:
        #    return True
        if self.lock_shown:
            return True
        self.update_res_enough_state(False)  # обновим состояние ресурсов
        # нужно:
        # - проверить доступность апгрейда по кол-ву юнитов (п.97)
        # - автообновление статуса для цвета стрелок...
        return True
# ============================================================
    def Get_tip_image(self):
        '''Возвращает ID изображения, которое используется для бэка типса'''
        # чтобы обновить кадр селекта:
        _frame = 0
        _is_green_state = self.is_green_state()
        if not _is_green_state: _frame = 1
        self.Drawer.SetFrame('select', _frame)
        self.Drawer.SetSequence('arrow', _frame)    # номер последовательности сейчас совпадает с номером кадра
        # ---
        if not _is_green_state:   # если хватает ресурсов на следующий апгрейд
            return "IMG_I_TIP_BG_RED"
        return "IMG_I_TIP_BG"
# ============================================================
    def Get_tip_text(self, by_click = False):
        '''Возвращает LIST, содержащий текстовые ID'''
        result = []
        if not self._get_tips_extra('before_name', result, by_click): return result
        item_name = self.GetAttrStr('item_name')
        if not item_name:
            return result
        if item_name == 'NO_TIPS':
            return result
        _has_access = self.HasAccess()
        state = self.SM.GetCurrentState()
        if not by_click:
            if self.is_cancel_button_mode(state):
                if self.is_mouse_over_zone == 'button':
                    result.append( ('text', 'COLOR_HEADER') )
                    result.append( ('text', 'CLICK_TO_CANCEL') )
                    return result
            result.append( ('text', 'COLOR_HEADER') )
            result.append( ('text', item_name) )
            if self.is_deactivated:
                if state in self._normal__empty:
                    return result
            # перенес код для отображения того, что дает здание:
            if state in self._normal__empty:
                _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
                if self.status in ['broken', 'place', 'map_place']:
                    _has_barbarians = False # на них варвары не действуют
                if self.subtype == 'watchtower': _has_barbarians = False
                if not _has_barbarians:
                    if self.has_next_level:
                        if self.status not in ['map_place', 'place']:
                            res = self.next_res
                            if res:
                                self._append_text_willgive(result)
            if not self._get_tips_extra('after_name', result, by_click): return result
            self._append_effectivness(result)
            self._append_genbar(result)
            self._append_lifebar(result)
            if state in self._normal__empty:
                if self.status == 'normal':
                    self._get_gives(result)
            if not self._get_tips_extra('after_gives', result, by_click): return result
            if not self.is_active():
                return result
            if state in self._normal__empty:
                _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
                if self.status in ['broken', 'place', 'map_place']:
                    _has_barbarians = False # на них варвары не действуют
                if self.subtype == 'watchtower': _has_barbarians = False
                if self.has_next_level and self.status not in ['map_place', 'place']:
                    if not self._get_tips_extra('before_upgrade_cost', result, by_click): return result
                    res = self.next_res
                    if res:
                        if not self._get_tips_extra('right_before_upgrade_cost', result, by_click): return result
                        result.append( 'newline' )
                        result.append( ('text', 'COLOR_LINES') )
                        if self.status == 'broken':
                            #if _has_barbarians:
                            #    result.append( ('text', 'COLOR_RED') )
                            #    result.append( ('text', 'TIPS_CANNOT_REPAIR_BARB') )
                            #else:
                                result.append( ('text', 'TIPS_REPAIR') )
                                result.append( 'space' )
                        else:
                            if not self.IsSubTypeOf(['verf', 'boatyard']):
                                if _has_barbarians:
                                    result.append( ('text', 'COLOR_RED') )
                                    result.append( ('text', 'TIPS_CANNOT_UPGRADE_BARB') )
                                else:
                                    result.append( ('text', 'TIPS_UPGRADE') )
                                    result.append( 'space' )
                    #result.append( ("text", "NEED") )
                        if not _has_barbarians:
                            res_numbers = self._append_res_values(res)
                            result.extend( res_numbers )
                            if not self._get_tips_extra('after_upgrade_cost', result, by_click): return result
                            if not self.button_res_enough:
                                diff_res = UStats.GetNotEnoughRes(res)
                                if diff_res:
                                    result.append( 'newline' )
                                    result.append( ('text', 'COLOR_RED') )
                                    result.append( ('text', 'NOT_ENOUGH') )
                                    result.append( 'space' )
                                    res_numbers = self._append_res_values(diff_res)
                                    result.extend( res_numbers )
                                    if not self._get_tips_extra('after_no_res', result, by_click): return result
                    _name = self.get('name')
                    _need_worker = not self.GetAttrBool('need_no_worker')
                    if not BMgr.Is_build_action_possible(_name, _need_worker): # если недостаточно юнитов
                        result.append( 'newline' )
                        result.append( ("text", "COLOR_RED") )
                        result.append( ("text", "NOT_ENOUGH_UNITS") )
            else:
                self._append_pbar(result)   # добавим прогрессбар, если нужно
            if not self._get_tips_extra('end', result, by_click): return result
            _is_debug = tools.IsDebug()
            if _is_debug: # добавить данные по навешанным на здания таскам
                if self.tasks_member:
                    result.append( 'newline' )
                    for tname in self.tasks_member:
                        result.append( ('debug', tname) )
                        result.append( ('debug', ', ') )
        else:
            if not _has_access:
                result = []
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NO_PATH') )
                return result
            if self.is_deactivated:
                _not_accessible = False
                _is_yard = self.IsSubTypeOf(['verf', 'boatyard'])
                if not _is_yard: _not_accessible = True
                if self.status == 'broken': _not_accessible = True
                if _not_accessible:
                    result.append( ('text', 'COLOR_LINES') )
                    #result.append( ('text', ('NOT_NEED_YET','NOT_ACCESSIBLE_YET')[self.status == 'broken']) )
                    result.append( ('text', 'NOT_ACCESSIBLE_YET') )
                    return result
                else:
                    return self.Get_tip_text(False)
            _is_fixed_place = self.GetAttrBool('fixed_place')
            if _is_fixed_place:
                if self.status == 'map_place':
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'MAP_PLACE') )
                    result.append('newline')
                    result.append( ('text', 'COLOR_HEADER') )
                    _item_map_name = self.GetAttrStr('item_map_name')
                    result.append( ('text', _item_map_name) )
                    return result
            _is_active = self.is_active()
            if not _is_active:
                if self.non_selectable:
                    return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
                building_cannot_repair_because_of_priority = self._cannot_repair_because_of_priority()
                if building_cannot_repair_because_of_priority:
                    result.append( ('text', 'COLOR_LINES') )
                    #result.append( ('text', ('NOT_NEED_YET','NOT_ACCESSIBLE_YET')[self.status == 'broken']) )
                    result.append( ('text', 'NOT_ACCESSIBLE_YET') )
                    return result
                else:
                    return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
            _is_cancel_button_mode = self.is_cancel_button_mode(state)
            if _is_cancel_button_mode:
                if self.is_mouse_over_zone == 'button':
                    result.append( ('text', 'COLOR_HEADER') )
                    result.append( ('text', 'CLICK_TO_CANCEL') )
                    return result
            if state in ['', 'normal']:
                if self.has_next_level:
                    _name = self.get('name')
                    _need_worker = not self.GetAttrBool('need_no_worker')
                    _is_build_action_possible = BMgr.Is_build_action_possible(_name, _need_worker) # если недостаточно юнитов
                    if not _is_build_action_possible:
                        result.append( ('text', 'COLOR_RED') )
                        result.append( ('text', 'NOT_ENOUGH_UNITS') )
                        return result
                    _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
                    if self.subtype == 'watchtower': _has_barbarians = False
                    if self.status in ['broken', 'place', 'map_place']:
                        _has_barbarians = False # на них варвары не действуют
                    if _has_barbarians: # если на поле варвары, то улучшить здание нельзя
                        result.append( ('text', 'COLOR_RED') )
                        if self.status == 'broken':
                            result.append( ('text', 'TIPS_CANNOT_REPAIR_BARB') )
                        else:
                            result.append( ('text', 'TIPS_CANNOT_UPGRADE_BARB') )
                    else:
                        res = self.next_res
                        if not self.button_res_enough and res:
                            diff_res = UStats.GetNotEnoughRes(res)
                            if diff_res:
                                if not self._get_tips_extra('before_no_res_c', result, by_click): return result
                                result.append( ('text', 'COLOR_RED') )
                                result.append( ('text', 'NOT_ENOUGH') )
                                result.append( 'space' )
                                res_numbers = self._append_res_values(diff_res)
                                result.extend( res_numbers )
                                if not self._get_tips_extra('after_no_res_c', result, by_click): return result
            if not self._get_tips_extra('end_c', result, by_click): return result
            if not result:
                return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
        return result
# ============================================================
    def _append_repair_hack_text(self, result, hack_text):
        '''Добавляет специальные строчки к типсу'''
        result.append('newline')
        result.append( ('text', 'COLOR_LINES') )
        result.append( ('text', hack_text) )
# ============================================================
    def _append_text_willgive(self, result):
        '''Добавляет к описанию что дает апгрейд/ремонт'''
        _stype = self.get('stype')
        _repair_hack = False
        _repair_hack_text = ''
        if self.status == 'broken':
            _repair_hack = self.GetAttrBool('repair_tip_hack')
            _repair_hack_text = self.GetAttrStr('repair_tip_text')
        # ##
        if _stype in {'granitemine':0, 'silvermine':0, 'fisherman':0, 'farm':0,\
                                'woodcutter':0, 'quarry':0}:
            next_var_name = self.get_next_level_name()
            if next_var_name in ['level_2', 'level_3']:
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                if not _repair_hack:
                    result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[self.status == 'broken']) )
                    result.append('newline')
                    result.append( ('text', ('DOUBLE_PERFORMANCE', 'TRIPLE_PERFORMANCE')[next_var_name == 'level_3']) )
                else:
                    self._append_repair_hack_text(result, _repair_hack_text)
            elif _repair_hack:
                self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype in ['totem', 'totem_stone']:
            next_var_name = self.get_next_level_name()
            if next_var_name:
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                if not _repair_hack:
                    result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[self.status == 'broken']) )
                    result.append('newline')
                    result.append( ('text', 'INCREASE_TERRITORY') )
                else:
                    self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype == 'watchtower':
            next_var_name = self.get_next_level_name()
            if next_var_name:
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                if not _repair_hack:
                    result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[self.status == 'broken']) )
                    result.append('newline')
                    result.append( ('text', 'INCREASE_TERRITORY') )
                    if next_var_name == 'level_2':
                        result.append('newline')
                        result.append( ('text', 'PROTECTION_AGAINST_BARBARIAN') )
                    elif next_var_name == 'level_3':
                        result.append('newline')
                        result.append( ('text', 'FULL_PROTECTION_AGAINST_BARBARIAN') )
                else:
                    self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype == 'warehouse':
            next_var_name = self.get_next_level_name()
            if next_var_name:
                if next_var_name in ['level_2', 'level_3']:
                    result.append('newline')
                    result.append( ('text', 'COLOR_LINES') )
                    if not _repair_hack:
                        result.append( ('text', ('UPGRADE_GIVES', 'REPAIR_GIVES')[self.status == 'broken']) )
                        result.append('newline')
                        if next_var_name == 'level_2':
                            result.append( ('text', 'PROTECTION_BARB_1') )
                        elif next_var_name == 'level_3':
                            result.append( ('text', 'PROTECTION_BARB_2') )
                    else:
                        self._append_repair_hack_text(result, _repair_hack_text)
                elif _repair_hack:
                    self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype == 'house':
            next_var_name = self.get_next_level_name()
            if next_var_name:
                if self.status == 'normal':
                    result.append('newline')
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'UPGRADE_GIVES') )
                    result.append('newline')
                    result.append( ('text', 'ADDITIONAL_UNITS') )
                elif self.status == 'broken':
                    result.append('newline')
                    result.append( ('text', 'COLOR_LINES') )
                    if not _repair_hack:
                        result.append( ('text', 'REPAIR_GIVES') )
                        result.append('newline')
                        result.append( ('text', 'ADDITIONAL_UNITS_2') )
                    else:
                        self._append_repair_hack_text(result, _repair_hack_text)
        elif _stype in ['hq', 'hq_small']:
            next_var_name = self.get_next_level_name()
            if next_var_name:
                if self.status == 'normal':
                    result.append('newline')
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'UPGRADE_GIVES') )
                    result.append('newline')
                    result.append( ('text', 'ADDITIONAL_UNITS') )
        elif _repair_hack:  # если галка установлена и статус сломанного здания
            self._append_repair_hack_text(result, _repair_hack_text)
        else:
            _res = self._get_willgive_res()
            if _res:
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'WILL_GIVE') )
                result.append('space')
                _res_numbers = self._append_res_values(_res)
                result.extend( _res_numbers )
# ============================================================
    def _get_tips_extra(self, place, result, by_click):
        '''Предназначается для переопределения в потомках
        place: метка позиции вставки типса
        result: список значений, в который нужно добавлять данные
        by_click: типс по клику или нет
        returns: False - для завершения типса, т.е. после него ни одной строки не прибавится'''
        return True
# ============================================================
    def _get_gives(self, result):
        '''Возвращает текст для части типса GIVES'''
        _gives = self.GetRes("normal_gives_1")
        if _gives:
            if not _gives.Empty():
                _gives = _gives.Clone()
                _gives.FixFood()        # чтобы еда учитывалась верно
                if not _gives.MainResEmpty():
                    result.append( 'newline' )
                    result.append( ("text", "COLOR_LINES") )
                    result.append( ("text", "GIVES") )
                    result.append( 'space' )
                    res_numbers = self._append_res_values(_gives)
                    result.extend( res_numbers )
# ============================================================
    def _append_bar(self, result, _progress, bar_images, _places_count = 10):
        '''Добавляет bar r result по указанным параметрам'''
        _filled_places = _places_count * _progress
        _filled_places = int(_filled_places + 0.5)
        if _filled_places > _places_count: _filled_places = _places_count
        elif _filled_places < 0: _filled_places = 0
        result.append( ('text', bar_images.left) ) #'TIP_BAR_L'
        for i in range(_filled_places):
            result.append( ('text', bar_images.full) ) #'TIP_BAR_FULL'
        for i in range(_places_count-_filled_places):
            result.append( ('text', bar_images.empty) ) #'TIP_BAR_EMPTY'
        result.append( ('text', bar_images.right) ) #'TIP_BAR_R'
# ============================================================
    _build__upgrade = ['build', 'upgrade']
    def _append_pbar(self, result):
        state = self.SM.GetState()
        if state in self._build__upgrade:
            result.append('newline')
            if state == 'build':
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'TIPS_BUILDING') )
                result.append('newline')
            elif state == 'upgrade':
                if not self.IsSubTypeOf(['verf', 'boatyard']) or self.status == 'broken':
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', ('TIPS_UPGRADING', 'TIPS_REPAIRING')[self.status == 'broken'] ) )
                    result.append('newline')
            _progress = self.build_progress
            if self.build_time > 0: _progress /= self.build_time
            else: _progress = 0
            _bar_images = {'left':'TIP_BAR_L', 'right':'TIP_BAR_R', 'full':'TIP_BAR_FULL', 'empty':'TIP_BAR_EMPTY'}
            self._append_bar(result, _progress, _bar_images)
# ============================================================
    def _append_effectivness(self, result):
        stype = self.get('stype')
        if self.is_deactivated:
            return
        if self.is_indians:
            return
        _need_no_worker = self.GetAttrBool('need_no_worker')
        if _need_no_worker and stype != 'farm_field':
            return
        if self.status in ['broken', 'map_place', 'place']:
            return
        state = self.SM.GetState()
        if state in ['build', 'upgrade', 'repair', 'awaiting']:
            return
        if stype in self.has_no_effectiveness:
            return
        state = self.SM.GetState()
        if state in self._normal__empty:
            if self.status == 'normal':
                _coeff = self.get_effectiveness_coeff()
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'TIP_EFFECTIVNESS') )
                result.append('newline')
                _bar_images = {'left':'TIP_EFFBAR_L', 'right':'TIP_EFFBAR_R', 'full':'TIP_EFFBAR_FULL', 'empty':'TIP_EFFBAR_EMPTY'}
                self._append_bar(result, _coeff, _bar_images)
        if tools.IsDebug():
            result.append( ('digit', self.get_effective_gen_time()) )
# ============================================================
    def _append_lifebar(self, result):
        if self.energy >= 100 or self.energy == 0:
            return
        if self.is_indians:
            return
        _need_no_worker = self.GetAttrBool('need_no_worker')
        if _need_no_worker:   # эти здания вроде как все нельзя атаковать (но ниже они перечислены)
            return
        stype = self.get('stype')
        if stype in self.not_for_attack:
            return
        if self.status in ['broken', 'place', 'map_place']:
            return
        if self.is_under_attack:
            result.append('newline')
            result.append( ('text', 'COLOR_LINES') )
            result.append( ('text', 'TIPS_BREAKING') )
        result.append('newline')
        result.append( ("text", "COLOR_LINES") )
        result.append( ('text', 'TIP_LIFE') )
        result.append('newline')
        _bar_images = {'left':'TIP_LIFEBAR_L', 'right':'TIP_LIFEBAR_R', 'full':'TIP_LIFEBAR_FULL', 'empty':'TIP_LIFEBAR_EMPTY'}
        self._append_bar(result, self.energy/100, _bar_images)
# ============================================================
    def _append_genbar(self, result):
        '''Бар производства на типсе'''
        if self.is_indians:
            return
        if not self.is_generating_res:
            return
        _progress = self.Signals.GetProgress('resource_generated')
        if _progress < 0:
            return
        result.append('newline')
        result.append( ("text", "COLOR_LINES") )
        result.append( ('text', 'TIP_RES_GENERATION') )
        result.append('newline')
        _bar_images = {'left':'TIP_GENBAR_L', 'right':'TIP_GENBAR_R', 'full':'TIP_GENBAR_FULL', 'empty':'TIP_GENBAR_EMPTY'}
        self._append_bar(result, _progress, _bar_images)
# ============================================================
    def _append_res_values(self, resources):
        '''Для типса. Генерирует список со значениями переданного ресурса, с соответствующими изображениями'''
        result = []
        if not resources: return result
        first_res = True
        for res_name in self.resource_names:    # выводим значения ресурсов...
            res_val = resources.Get(res_name)
            if res_val > 0:     # на всякий случай
                if not first_res:
                    result.append( 'comma' )
                    result.append( 'space' )
                first_res = False
                result.append( ("digit", resources.Get(res_name)) )
                result.append( ("image", self.res_images[res_name]) )
        return result
# ============================================================
    def Get_tip_position(self, tip_size, camera_pos, window_rect, zoom):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        return toolz.Tools.get_tip_position(self, tip_size, camera_pos, window_rect)
# ============================================================
    def can_build(self):
        '''Можно ли строить здание - доступны ли юниты'''
        _name = self.get('name')
        _need_worker = not self.GetAttrBool('need_no_worker')
        can_build = BMgr.Is_build_action_possible(_name, _need_worker)
        return can_build
# ============================================================
    def can_build_static(_name, _need_worker = True):
        '''Можно ли строить здание - доступны ли юниты'''
        can_build = BMgr.Is_build_action_possible(_name, _need_worker)
        return can_build
# ============================================================
    __normal_empty = ['', 'normal']
    def get_raw_button_frame(self):
        '''Возвращает номер кадра кнопки, без учета положения курсора мыши'''
        if self.is_deactivated: # если здание деактивировано
            return -1
        _partial_fog = self.Drawer.IsPartiallyInFog()
        if _partial_fog:        # если в тумане
            return -1
        if self.is_under_attack > 0:    # если здание атакуют
            return -1
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if self.status in ['broken', 'place', 'map_place']: _has_barbarians = False
        if self.subtype in ['watchtower']: _has_barbarians = False
        frame = -1
        state = self.SM.GetCurrentState()
        #_name = self.get('name')
        #_need_worker = not self.GetAttrBool('need_no_worker')
        _can_build = self.can_build()    #BMgr.Is_build_action_possible(_name, _need_worker)
        if state in self.__normal_empty:         # '' - это состояние после выхода из любого другого
            if self.status == 'broken' and self.has_next_level: # если можно отремонтировать
                _build_case = False
                if self.button_res_enough:                      # и хватает ресурсов
                    if _can_build:
                        _build_case = True
                if _has_barbarians: _build_case = False
                if _build_case:
                    frame = 6
                else:
                    frame = 8
            elif self.has_next_level and self.status != 'place':    # если возможен апгрейд
                _build_case = False
                if self.button_res_enough:                      # и хватает ресурсов
                    if _can_build:
                        _build_case = True
                if _has_barbarians: _build_case = False
                if _build_case:
                    frame = 0
                    if self.IsSubTypeOf('verf'): frame = 6
                else:
                    frame = 2
                    if self.IsSubTypeOf('verf'): frame = 8
            if self.status == 'place':
                frame = 3
        elif state == 'awaiting_action':            # если ожидаем какого-то действия, правда прибегание юнита тоже вызывает это... нужно проверить
            frame = 3       # галка
        elif state in ['build', 'upgrade']: # в момент действия кнопку не отображаем (отменить уже нельзя)
            frame = -1
        return frame
# ============================================================
    def is_cancel_button_mode(self, state):
        if self.is_mouse_over:
            if state not in ['build', 'upgrade']:   # если подсветка только по кнопке
                frame = self.get_raw_button_frame()
                if frame in self.button_active_frames: # подсветка кнопки при наведении
                    if frame == self.cancel_build_active_frame:     # если кнопка отмены
                        return True
        return False
# ============================================================
    def Get_button_frame(self):
        state = self.SM.GetCurrentState()
        frame = self.get_raw_button_frame()
        if frame >= 0:
            if self.is_mouse_over:
                if state not in ['build', 'upgrade']:   # чтобы в этих режимах кнопка при наведении на объект появлялась
                    if frame in self.button_active_frames: # подсветка кнопки при наведении
                        if frame == self.cancel_build_active_frame:     # для отмены подсвечиваем только над кнопкой
                            if self.is_mouse_over_zone == 'button':
                                frame += 1
                        else:
                            frame += 1
        if frame < 0:
            self.Drawer.ShowImages('button', False)
        else:
            self.Drawer.ShowImages('button')
        return frame
# ============================================================
    def send_extra_event(self):
        if self.extra_event:
            BMgr.SendGlobalMsg('extra_event', self.extra_event)
            self.extra_event = ''
# ============================================================
    def get_needs_res(self, variant_name):
        need_res_name = self.GetAttrStr('need_res_name')
        if need_res_name == '':
            need_res_name = 'normal_needs_1'
        return self.GetRes(variant_name, need_res_name)
# ============================================================
    def _get_willgive_res(self):
        next_var_name = self.get_next_level_name()
        if next_var_name:
            _res = self.GetRes(next_var_name, 'normal_gives_1')
            _is_res_empty = True
            if _res:
                _is_res_empty = _res.Empty()
            if not _is_res_empty:
                return _res
        return None
# ============================================================
    def Force_highlight(self, highlight):
        pass
# ============================================================
    def action_hit_me(self, count=1):
        '''По зданию сделан удар
        count: сколько ударов за раз'''
        if self.status == 'broken':
            return
        if self.energy <= 0:     # на всякий случай, чтобы объект нельзя было разрушить дважды
            return
        #self.action_was_started = True  # чтобы уже нельзя было отменить
        self.energy -= count * self.energy_hit # по 10% за удар
        #self.action_progress = 1 - self.action_hits_last / self.action_hits_count
        self.Drawer.Blink(['default', 'floor'], 1, 0xffff8888, 0.5)
        self.on_action_hit_me()        # чтобы можно было переопределить
        self.scale_bump()
        if self.energy <= 0:
            #self.action_was_started = False # чтобы объект работал, если у него сложная логика
            #effect_digged_name = self.GetAttrStr('effect_complete_name')
            #if effect_digged_name:
            #    self.AddEffect(effect_digged_name, self.get('position'))
            self.on_action_hits_me_complete()
# ============================================================
    def on_action_hit_me(self):
        '''Для переопределения'''
        pass
# ============================================================
    def on_action_hits_me_complete(self):
        # нужно поломать здание
        _vname = self.get('variant_name')
        if _vname in self.broken_switch:
            _next_name = self.broken_switch[_vname]
            self.show_arrow(False)
            trace('on_action_hits_me_complete:')
            trace(' on_action_hits_me_complete:', self.get('name'), self.get('uid'), _next_name)
            self.SwitchLevel(_next_name)   # переключаемся на следующий вариант
            self.AddEffect('brocken_smoke', self.get('position'))   # после разрушения варварами
            self.PlaySound('SND_BUILDING_KILLED')
            self.status = self.GetAttrStr('status')
            self.Signals.Cancel('resource_generated')       # ресурсы больше не генерим
            self.update_next_res()
            self.unreserve_action_cells()
            #letter = []
            #letter.append( ('text', 'MSG_BUILDED') )
            #letter.append( 'space' )
            #item_name = self.GetAttrStr("item_name")
            #letter.append( ('text', item_name) )
            #EMgr.AppendLetter(letter, self.get('uid'))
            self.update_res_enough_state()
            self.is_under_attack = 0
            #TMgr.cancel_task_by_uid(self.task_call_res_uid)
            #self.task_call_res_uid = 0
            self.stop_resource_generation()     # остановим генерацию, если сломано здание
            self.switch_animation()
            UI.HideTopText()
            UI.show_top_text('BARB_BUILDING_BROKEN', self.get('uid'))
# ============================================================
    def on_attack_started(self):
        UI.workers_texts = [] # обрубаем все сообщения
        UI.HideTopText()
        UI.show_top_text('BARBARIAN_ATTACK_BUILDING', self.get('uid'), True)
# ============================================================
    def on_attack_canceled(self):
        '''Вызывается при отмене атаки одним из дикарей'''
        if self.is_under_attack == 0:   # если больше атакующих нет, то
            self.start_resource_generation()    # запускаем генерацию ресурса, либо дровосека/камнелома
# ============================================================
# ============================================================
    def get_action_text(self, for_task_slide = False):
        return ''
# ============================================================
    def start_comet(self, _name, result_signal = 'comet_fly_complete'):
        '''Запускает комету, если указана в атрибутах, иначе просто дает сигнал на завершение удаления'''
        _comet_effect_name = _name
        if not _comet_effect_name:
            _comet_effect_name = self.GetAttrStr('comet_name')
        if _comet_effect_name:
            LBoard.StartComet(self, _comet_effect_name, result_signal)
            self.PlaySoundG('SND_ITEM_FLIGHT')
        else:
            self.Signals.Restart(result_signal, 1)
# ============================================================
    def on_before_action_started(self): # for safe only
        pass
# ============================================================
    def DEBUG_get_info(self):
        r = []
        r.append(('debug',self.get('uid')))
        r.append('space')
        r.append(('digit', len(self._building_units)))
        r.append('space')
        r.append(('digit', len(self.walking_home_units)))
        if self.tasks_member:
            for tname in self.tasks_member:
                r.append( 'newline' )
                r.append( ('debug', tname) )
                t = self.tasks_member[tname][1]
                r.append( 'space' )
                r.append( ('digit', t.uid) )
        return r
# ============================================================


