# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *


import task_walkg
import task_classes
import toolz

class UnitQuestDlgTask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
# ============================================================
    def start_action(self, item):
        self.unit = item
        unit = item
        if unit:
            _is_talking = unit.GetAttrBool('is_talking')
            if _is_talking:
                _uid = self.parent_task.uid
                _dlg_settings = unit.get_dlg_settings(unit.GetAttrStr('talk_text'), _uid)
                #_dlg_settings['quest_name'] = unit.name
                _dlg_settings['is_survived'] = 'true'
                TMgr.cancel_tasks('walk_general')
                Camera.MoveTo(unit)
                dlg.Open("QuestMenuOk", "dlg_quest", _dlg_settings)
                return True
        return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'ok':      # других и быть не должно
            # активировать здания и юнитов из списка,
            # юнитов еще и "по домам" нужно отправить
            if self.unit:
                self.unit.activate_survived()
                self.unit.task = None
                self.unit.is_in_home = False
                _gift = self.unit.GetAttrStr('gift')
                if _gift:
                    self.unit.publish_gift( _gift )
                self.unit.send_extra_event()    # если выжившего активировали
                _unit = UMgr.add_free_unit(self.unit)
                #_unit.start_comet('survived_comet', 'survived_fly_complete')
                UI.show_chest_text('CHEST_MSG_PART_OF_MISSION')
                self.unit = None
                self.parent_task.complete_task()
                UStats.AddLevelValue('survived', 1) # скажем, что спасли выжившего... (самого себя)
            #self.complete()
        # отведем генерала от юнита:
        UMgr.general.step_aside()



#@statemachine
class BaseUnit(Unit):
# ============================================================
    def __init__(self, cdata):
        Unit.__init__(self, cdata)
        self.uid = -1
        self.subtype = self.get('stype')
        self.current_subtype = 'simple'   # подтип юнита: 'simple', 'builder', 'breaker', ...
        self.task = None
        self.task_type = ""
        self.target = None       # unit target - building or another object
        self.unique_name = self.GetAttrStr('unique_name')
        self.is_in_home = False  # в здании ли юнит
        self.home_building = None    # здание, в котором сейчас находится юнит, либо в которое возвращается (только дом!)
        self.res_action_cost = self.get_action_cost_res()
        self.current_action_animation = ''  # анимация при взаимодействии с объектом
        self.is_survived = self.GetAttrBool('is_survived')
        self.is_indian = False
        self.is_mouse_over = False
        self.is_mouse_over_zone = ''
        self.show_talk_sign = False
        self.unit_is_talking = False    # для момента разговора индейца и генерала (возможно не только их)
        self.need_to_show = False   # нужно ли показать юнита?
        self.is_shown = not self.GetAttrBool('hidden_at_start')       # видимый ли данный юнит
        self.has_check = False      # установлена ли галка участия в задании
        self.can_show_uncheck = False   # можно ли показывать иконку отмены (это затрагивает только визуальную часть)
        self.quest = None
        self.need_quest_text = False    # нужно ли тексты для типса брать у квеста
        self.need_to_remove_offscreen = False   # нужно ли удалить юнита при выходе за пределы экрана (используется индейцем после окончания квеста)
        self.is_offscreen = True
        self.action_item = None     # объект, над которым выполняется некое действие
        self.is_another_quest_started = False
        self.is_another_unit_in_queue = False
        self.is_tip_frozen = self.GetAttrBool('is_tip_frozen')
        self.is_woman = self.GetAttrBool('is_woman')
        self.is_quest_started = False  # для индейцев и лодочника
        self.is_quest_complete = False  # для индейцев и лодочника
        self.is_deactivated = self.GetAttrBool('deactivated')
        self.non_selectable = self.GetAttrBool('non_selectable')
        self.extra_event = self.GetAttrStr('extra_event')   # нужно в самом начале прочитать эти данные, чтобы вариант не перетер
        if self.non_selectable:
            self.SetMouseActive(False)
# ============================================================
    def dispose(self):
        pass
# ============================================================
    def show_arrow(self, show = True):
        #self.arrow_shown = True
        #self.switch_animation()
        pass
# ============================================================
    def has_resource(self):
        return self.resource and not self.resource.Empty()
# ============================================================
    def on_msg(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        '''Предобработчик сообщений. Отделяет системные сообщения от обычных. И вызывает соответстующие методы обработки.'''
        if msg_type == 'signal_msg':
            self.on_signal(msg_param1)
        elif msg_type == 'action_hit_item':
            # здесь нужно выбирать анимацию действия - зависит от объекта взаимодействия
            self.Drawer.PlayAnimationOnce(self.current_action_animation, 'action_hit_complete', '', 50, 'action_hit_moment')
        elif msg_type == 'action_hit_complete':
            trace('action_hit_complete')
            self.on_action_hit_complete()
        elif msg_type == 'action_hit_moment':
            trace('action_hit_moment')
            self.on_action_hit_moment()
        elif msg_type == "state_machine":
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == 'click':
            if self.is_shown:
                if self.HasAccess():
                    self.on_click(msg_param1)
                    return
            LBoard.CrossNoToLastClick()
        elif msg_type != 'on_create':
            self.on_message(msg_type, msg_param1, msg_param2, msg_dict)
        elif msg_type == "on_create":
            self.on_create()
# ============================================================
    def on_msg_now(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'mouse_in':
            self.on_mouse_in(msg_param1)
        elif msg_type == 'mouse_out':
            self.on_mouse_out()
# ============================================================
    # interaction interface for objects
    def on_interact(self, sender, cmd, additional):
        '''Пока не используется'''
        pass
# ============================================================
    def on_message(self, msg_type, msg_param1, msg_param2, msg_dict):
        '''Обработчик всех обычных сообщений (которые не были обработаны в on_msg'''
        pass
# ============================================================
    def on_signal(self, signal):
        '''Обработчик сигналов'''
        if signal == 'offscreen':
            if self.is_offscreen: return    # чтобы не дублировать
            self.is_offscreen = True
            if self.need_to_remove_offscreen:   # если нужно удалить после выхода за экран
                BMgr.RemoveItemFromMap(self)    # удалим юнита
                return
            elif not self.is_shown:
                if self.need_to_show:
                    self.show_as_possible()
                    #self.need_to_show = False
                    #self.is_shown = True
                    #self.switch_animation()
        elif signal == 'onscreen':
            self.is_offscreen = False
        elif signal == 'got_access':
            _seq = 0
            if not self.is_green_state(): _seq = 1
            self.Drawer.SetSequence('arrow', _seq)
            self.switch_animation()
        elif signal == 'no_access':
            self.Drawer.SetSequence('arrow', 1)    # в любом случае красная будет
            self.switch_animation()
        elif signal == 'survived_fly_complete':
            UI.show_chest_text('CHEST_MSG_PART_OF_MISSION')
# ============================================================
    def start_talk(self):
        '''Запускает разговор юнита на 2 секунды'''
        self.unit_is_talking = True
        self.SM.SetState('talk', 2000)  # разговор на 2 секунды
        self.switch_animation()
# ============================================================
    def on_talk_complete(self):
        '''Данный метод вызывается каждым классом отдельно при окончании состояния разговора'''
        #TMgr.cancel_tasks('walk_general')
        # этот метод годится только для индейцев, а для генерала и прочих требует корректив
        if self.unique_name:
            BMgr.SendGlobalMsg('unit_talk', self.unique_name)      # задание "поговорить" выполнено
            self.unique_name = '' # чтобы повторно к нему не подходить
            #self.task.complete_task()
            self.on_quest_complete_all()
        if UMgr.general == self:
            self.task.complete_task()
            self.cancel_step_aside()
            self.step_aside()
        self.unit_is_talking = False
        self.switch_animation()
# ============================================================
    def cancel_step_aside(self):
        self.Signals.Cancel('step_aside')
        self.RemoveMsg('signal_msg', 'step_aside')
# ============================================================
    def show_as_possible(self):
        if self.is_offscreen and not self.is_shown: # если не показаны и уже за экраном
            self.need_to_show = False
            self.is_shown = True
            trace('show_as_possible, unit uid:', self.uid)
            self.switch_animation()
        else:
            self.need_to_show = True
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        '''Обработчик всех событий стейт-машины'''
        if type == "enter":
            self.on_state_enter(state_name, additional)
            return
        elif type == "exit":
            self.on_state_exit(state_name, additional)
            return
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_enter(self, state_name, additional):
        pass
# ============================================================
    def on_state_exit(self, state_name, additional):
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        if cur_state != next_state:
            self.switch_animation()
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if _has_barbarians:        # если есть варвары, то не даем кликать по индейцам, чтобы ни взять, ни сдать квест
            LBoard.CrossNoToLastClick()
            return
        _is_talking = self.GetAttrBool('is_talking')
        if _is_talking:
            _is_active = self.is_active()
            if _is_active:
                _is_busy = self.is_busy()
                if not _is_busy:
                    #if UMgr.general and not UMgr.general.task:
                        self.task = task_walkg.WalkGeneralTask(self)
                        TMgr.add_task( self.task )
                        if self.has_check:      # если галка установилась
                            TMgr.add_quest_unit_to_queue(self.uid)
                            Camera.MoveTo(self) # при установке галки - камеру на индейца
                            BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                        return
                else:
                    if self.task:
                        self.task.cancel()
                        self.task = None
                        BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                        return
        #else:
        #LBoard.MoveCameraToLastClick()
        LBoard.CrossNoToLastClick()
# ============================================================
    def is_enough_params(self):
        '''Метод для переопределения'''
        return True
# ============================================================
    def on_mouse_in(self, over_zone):
        _is_active = self.is_active()
        if _is_active:
            self.is_mouse_over = True
            self.is_mouse_over_zone = over_zone
            self.Drawer.HighlightImages('default', True)
            self.Drawer.ShowImages('select')
            check_frame = 0
            if self.need_show_uncheck(): check_frame = 1
            self.Drawer.SetFrame('check', check_frame)
# ============================================================
    def on_mouse_out(self):
        self.can_show_uncheck = True
        #if self.is_active():
        self.is_mouse_over = False
        self.is_mouse_over_zone = ''
        self.Drawer.HighlightImages('default', False)
        self.Drawer.ShowImages('select', False)
        check_frame = 0
        if self.need_show_uncheck(): check_frame = 1
        self.Drawer.SetFrame('check', check_frame)
# ============================================================
    def on_create(self):
        '''Метод инициализации при создании юнита'''
        _seq = 0
        if not self.is_green_state(): _seq = 1
        self.Drawer.SetSequence('arrow', _seq)
        if UStats.GetLevelValue('talk_quest_was_started') > 0:        # если запущен квест на разговор с юнитом до создания подгружаемого уровня
            self.try_show_talk_sign()
# ============================================================
    def try_show_talk_sign(self, show = True):
        '''Для юнитов, которые говорят (индейцы), показывает значок разговора'''
        if not show:
            self.show_talk_sign = False
        elif self.unique_name:
            self.show_talk_sign = True
        self.switch_animation()
# ============================================================
# ============================================================
    def __str__(self):
        '''Выводит полезную информацию о юните'''
        #result = to_str("{name:", self.get("name"), to_str(self.get("cell")), "}")
        task_uid = -1
        if self.task:
            task_uid = self.task.uid
        home_uid = -1
        if self.home_building:
            home_uid = self.home_building.uid
        result = to_str("unit uid:", self.uid, "task.uid:", task_uid, "home_building:", home_uid, result)
        return result
# #######################################################
# #######################################################
# #######################################################
    def switch_animation(self):
        _is_partial_fog = self.Drawer.IsPartiallyInFog()
        if _is_partial_fog:
            self.Drawer.ShowImages('', False)
            return
        if not self.is_shown:
            self.Drawer.ShowImages('', False)
            return
        dir = self.GetDirection()
        self.Drawer.ShowImages('', False)

        self.Drawer.ShowImages('select', self.is_mouse_over and not self.is_deactivated)
        self.Drawer.ShowImages('check', self.has_check)
        if not self.unit_is_talking:
            self.Drawer.ShowImages(['run','shadow'], True)
            self.Drawer.SetSequence('run', dir)
        else:
            self.Drawer.ShowImages(['talk','shadow'], True)
            self.Drawer.SetSequence('talk', dir)
        _has_access = self.HasAccess()
        if _has_access:
            if self.is_survived:
                _is_talking = self.GetAttrBool('is_talking')
                if _is_talking:
                    self.Drawer.ShowImages('sign_e', True)
            self.Drawer.ShowImages('sign_talk', (self.unique_name and self.is_active() and not self.unit_is_talking) )   # последнее - чтобы во время разговора не показывать
# ============================================================
    def need_show_uncheck(self):
        return self.is_mouse_over and self.can_show_uncheck
# ============================================================
    def Invalidate(self):
        '''перерисовка объекта, вызывается из C++'''
        self.switch_animation()
# ============================================================
    def hide(self):
        '''Делает юнита невидимым (нужно тогда, когда юнит в здании)'''
        self.Drawer.Hide(True)
# ============================================================
    def show(self):
        '''Делает юнита видимым (нужно тогда, когда юнит выходит из здания)'''
        self.Drawer.Hide(False)
# ============================================================
    def is_active(self):
        '''Возможны ли действия над объектом в данный момент. Метод может быть переопределен'''
        if not self.is_deactivated and not self.non_selectable and self.is_shown:
            if self.unique_name:        # для ситуации с говорящими индейцами
                return self.show_talk_sign
            else:
                return True
        else:
            return False
    def deactivate(self):
        '''Деактивирует объект - он перестает быть доступным для взаимодействия и соответственно обновляет изображения'''
        self.is_deactivated = True
        self.is_mouse_over = False
        self.switch_animation()
    def activate(self):
        self.is_deactivated = False
        self.switch_animation()
# ============================================================
    def has_sign(self):
        '''Есть ли какой-нить знак над юнитом'''
        _is_talking = self.GetAttrBool('is_talking')
        if self.is_survived:
            if _is_talking:
                return True
        if self.unique_name:
            _is_active = self.is_active()
            if _is_active:
                if not self.unit_is_talking:
                    return True
        return False
# ============================================================
    def is_busy(self):
        if self.task != None or self.unit_is_talking:
            return True
        else:
            return False
# ============================================================
    def set_current_subtype(self, new_subtype):
        self.current_subtype = new_subtype
# ============================================================
    def run_to_target(self, target, override_target = None, cell_shift_name='', going_home = False):
        '''Отправляет юнита к цели.
        target: ячейка или объект.
        override_target: если target - ячейка, но нужно учитывать объект в проходимости, то здесь указываем этот объект
        cell_shift_name: название атрибута-ячейки, в котором содержится смещение относительно позиции объекта-цели
        going_home: отправляется ли юнит домой'''
        trace('run_to_target:', cell_shift_name, ', ', going_home, 'unit:', self.get('name'), self.get('uid'))
        if 'col' not in target:
            if 'row' not in target:
                trace('    run_to_target:', target.get('name'), target.get('uid'))
        self.cancel_step_aside()   # чтобы юнит не глючил

        _target_cell = None
        if 'col' not in target:
            if 'row' not in target:
                #_target_cell = target.get('cell')
                #if cell_shift_name:
                _target_cell = target.GetAttrCellFixed(cell_shift_name)
                _is_passable = target.IsCellPassable(_target_cell)
                if not _is_passable:
                    trace('Error: cell is not passable!', self.get('uid'), target.get('name'), target.get('uid'))
                    return False
        else:
            _target_cell = target

        result = self.TryRunTo(target, cell_shift_name)
        if result == False:
            if 'col' not in target:
                if 'row' not in target:
                    trace('run_to_target failed', self.get('uid'), target.get('name'), target.get('uid'))
            else:
                trace('run_to_target failed', self.get('uid'), target)
            return False
        self.show()
        if not going_home:
            self.start_work()
        self.target = target
        if override_target:
            self.target = override_target
        return True
# ============================================================
    def run_by_path(self, path, target):
        '''Отправляет юнита по переданному пути.
        path: путь, по которому необходимо следовать
        target: к какому объекту направляемся'''
        self.cancel_step_aside()   # чтобы юнит не глючил
        self.RunByPath(path)
        self.show()
        #if not going_home:
        #    self.start_work()
        self.target = target
# ============================================================
    def start_work(self):
        '''Инициализирует юнита на действие. Т.е. выводит его из домика, если он там был.
        Отменяет бег в домик, если бежал и т.д.'''
        if self.home_building:          # если была привязка к дому
            self.home_building.remove_walking_home_unit(self)   # на всякий случай
            if self.is_in_home:                 # если были в доме
                self.home_building.leave_unit(self) # покинем домик
        self.cancel_step_aside()   # чтобы юнит не глючил
        self.home_building = None   # отвязка от домика
        self.is_in_home = False
# ============================================================
    def set_check(self, visible):
        '''Ставит/убирает галку над объектом'''
        if self.has_check == visible:
            return
        if visible == False:
            TMgr.remove_quest_unit_from_queue(self.uid) # используется только для юнитов с квестами, но наследовать не охота
        self.has_check = visible
        if visible: self.PlaySoundG('SND_CLICK_TASK')
        if self.has_check:
            self.can_show_uncheck = False   # чтобы крестик не показывался, пока курсор не выйдет за пределы объекта
        self.Drawer.ShowImages('check', visible)
        self.Drawer.SetFrame('check', 0)
# ============================================================
    def is_action_complete(self):
        '''Действие над данным объектом уже было выполнено'''
        return True     #! need to override
# ============================================================
    def set_quest(self, quest):
        pass        # need to override
# ============================================================
    def get_subtask(self, parent_task, actor):
        '''Возвращает подзадание для юнита, который будет взаимодействовать с данным объектом'''
        _is_talking = self.GetAttrBool('is_talking')
        if _is_talking:
            return UnitQuestDlgTask(parent_task, actor)
        return task_classes.Subtask(parent_task, actor)
# ============================================================
    def get_action_cell_name(self):
        '''Метод возвращает название ячейки к которой будет подбегать юнит'''
        return 'action_cell'
# ============================================================
    def activate_survived(self):
        '''Готовит юнита к исчезновению по окончании квеста, если у юнита есть такая необходимость'''
        self.is_survived = False        # себя отметим уже как "приписанного"
        UStats.AddLevelValue('progress', 1) # прогресс по уровню
        survived_items_str = self.GetAttrStr('survived_activate')
        if survived_items_str:
            survived_items = BMgr.get_items(survived_items_str)
            if survived_items:
                for item in survived_items:
                    if item:
                        item.activate()
                        _type = item.get('type')
                        if _type == 'unit':  # если это юнит
                            item.is_survived = False
                            item.task = None
                            item.is_in_home = False
                            item = UMgr.add_free_unit(item) # если это выживший, то он подменяется!
                            #item.start_comet('survived_comet', 'survived_fly_complete')
                            UI.show_chest_text('CHEST_MSG_PART_OF_MISSION')
                            UStats.AddLevelValue('survived', 1) # скажем, что спасли выжившего...
                        elif _type == 'building':
                            _tname = item.get('name')
                            _vname = item.get('variant_name')
                            BMgr.AddRepaired(_tname, _vname)  # чтобы учесть здание в приоритетных и апгрейдах
                            _cur_units_count = item.GetAttrInt("start_units")
                            if _cur_units_count:
                                UStats.AddLevelValue('survived', _cur_units_count) # скажем, что спасли выжившего...
                                #for i in range(0, _cur_units_count):
                                #    item.start_comet('survived_comet', '')
                            item.on_survived_activate()
# ============================================================
    def get_survived_count(self):
        '''Возвращает кол-во выживших, которые будут переданы игроку, включая самого себя'''
        _count = 1  # себя тоже включаем сюда
        survived_items_str = self.GetAttrStr('survived_activate')
        if survived_items_str:
            survived_items = BMgr.get_items(survived_items_str)
            if survived_items:
                for item in survived_items:
                    if item:
                        _type = item.get('type')
                        if _type == 'unit':  # если это юнит
                            _count += 1
                        elif _type == 'building':
                            _cur_units_count = item.GetAttrInt("start_units")
                            if _cur_units_count:
                                _count += _cur_units_count
        return _count
# ============================================================
    def set_face_direction(self):
        '''Установить юнита в одном из двух боковых положений лицом к экрану'''
        _dirs = [1,7]
        _rnd_dir = _dirs[tools.Rand(0,1)]
        self.SetDirection(_rnd_dir)
        dir = self.GetDirection()
        self.Drawer.SetSequence('run', dir)
        self.Drawer.SetSequence('default', dir)
        self.switch_animation()
# ============================================================
    def get_gift_cell(self):
        '''Возвращает ячейку, в которую можно выложить подарок'''
        _cell_pos = self.get('cell')
        for i in range(1,6):
            _cell_name = 'gift' + str(i) + '_cell'
            _cell = self.GetAttrCell(_cell_name)
            _cell = self.FixAddCell(_cell_pos, _cell)
            _is_free = self.IsCellFree(_cell)
            if _is_free:
                return _cell
        mbox(to_str("ERROR: all cells are busy. UID:",str(self.uid), 'Name:', self.get('name'), 'Cell:', _cell_pos))
        return None
# ============================================================
    def publish_gift(self, gift_template_name):
        '''Выкладывает на игровое поле подарок от NPC'''
        if not gift_template_name: # если имя шаблона не указано
            return
        _gift_cell = self.get_gift_cell()       # позиция, в которую будет выложен подарок
        #_cell = self.get('cell')
        #_gift_cell = self.FixAddCell(_cell, _gift_cell)
        variant_name = ''
        if ';' in gift_template_name:
            _parts = gift_template_name.split(';')
            gift_template_name = _parts[0]
            variant_name = _parts[1]
        _new_item = BMgr.AddItemToMap(gift_template_name, variant_name, _gift_cell)        # hack - BuildingsManager может добавлять на карту не только здания
        if _new_item:
            _pos = _new_item.GetAttrPoint('center_item_pos')
            _new_item.Drawer.ResIn(_new_item.item_layers, _pos, 1000)
# ============================================================
# ============================================================
# ВЗАИМОДЕЙСТВИЕ С ОБЪЕКТАМИ
    def action_hit_item(self, item):
        self.action_item = item
        self.SM.SetState('action') #@fixit  здесь нужно еще разобраться какое состояние выставлять
        self.SendMsg('action_hit_item')
# ============================================================
    def cancel_action_hits(self):
        self.action_item = None
        self.SM.SetState('stay')
# ============================================================
    def on_action_hit_moment(self):
        if self.action_item:
            self.action_item.action_hit_me()      # удар по объекту
            self.action_item.scale_bump()
            self.action_item.play_hit_sound()
# ============================================================
    def on_action_hit_complete(self):
        if self.action_item:      # проверяем на случай, если отменили задание
            if not self.action_item.is_action_complete():   # объект еще не разрушен
                self.Drawer.PlayAnimationOnce(self.current_action_animation, 'action_hit_complete', '', 50, 'action_hit_moment')        # ударим еще раз
            else:
                #self.SM.SetState('run')
                self.resource = self.action_item.completeGivesRes    # нужно передать юниту ресурсы
                self.action_item.play_complete_sound()
                self.action_item = None
                if self.task:
                    self.task.subtask.on_action_complete()
                _subtype = self.get('subtype')
                if _subtype not in ['worker','general']:
                    self.go_home()      # для всех, кроме работников - они через free_unit -> TMgr убегают назад
                self.switch_animation()
# ============================================================
# ============================================================
# возможно стоит вынести в отдельные классы... а возможно и не стоит.
    def go_home(self):
        '''Отправляет юнита домой в ближайшее здание. Иницализирует необходимые переменные'''
        if self.home_building:
            if self.is_in_home:  # уже дома
                return
        if self.resource and not self.resource.Empty():
            trace('unit go home with resource')
            buildings = BMgr.get_buildings('__store__', '', ['broken', 'place'])
            res_cell = 'res_cell'
            b = BMgr.find_nearest(buildings, res_cell, self, '') # ищем ближайшее здание, принимающее ресурсы
        else:
            b = BMgr.find_nearest_unit_building(self, "", False, True)
        if b == None:
            b = BMgr.find_nearest_unit_building(self, "", False, False) # ищем тогда любое
            if b == None:
                mbox('building is None')    #@fixit! в релизе убрать, и данный метод переделать в trace("MBOX: ..."
                return
        self.home_building = b
        b.add_walking_home_unit(self)
        #self.is_running_home = True
        self.run_to_target( b.start_cell_pos, b, '', True )
# ============================================================
    def set_home(self, building):
        '''Помещает юнита в здание. Инициализирует необходимые переменные, прячет юнита, выставляет координаты'''
        self.home_building = building
        self.is_in_home = True
        self.task = None        # ? попытка что-то поправить
        self.current_subtype = 'simple' # в домике для упрощения считаем его обычным
        self.set('cell', building.start_cell_pos)   # обязательно поставим координату "выхода юнита" - от нее будет считать расстояние
        self.hide()
        if building:
            trace('set_home::building: ', building.get('name'))
            building.remove_walking_home_unit(self)     # еще один "на всякий случай"
        self.give_resource(building)    # отдаем ресурс
# ============================================================
    def give_resource(self, building):
        '''Отдает ресурс зданию'''
        not_empty = self.has_resource()
        if building:
            if not_empty:
                building.take_resource(self.resource)
                self.resource = None
# ============================================================
    def stop_walk(self):
        state_name = self.SM.GetCurrentState()
        if state_name == 'stay':  # уже стоим
            return
        self.StopMove()     # событие сработает не мгновенно, а остановиться нужно сразу!
        self.SM.SetState('stay')
        self.switch_animation() # не поломает ли чего? не должно вроде.
# ============================================================
    def show_magic(self):
        pass
# ============================================================
    def get_dlg_settings(self, text, _uid = 0, complete = False):
        if self.GetAttrBool('is_talking'):
            #_tasks = self.quest.get_tasks_text(complete)
            _tasks = []
            _survived_count = self.get_survived_count()
            _tasks = [('text', 'COLOR_TASKS_TEXT')]
            _tasks.append(['text', 'TASK_CHECK'])
            _tasks.append(('text','QUEST_DLG_TASK_SAVE'))
            _tasks.append('space')
            _tasks.append(('text', 'COLOR_TASKS_NUMBER'))
            _tasks.append(('digit', _survived_count))
            _tasks.append('space')
            _tasks.append(('text', 'COLOR_TASKS_TEXT'))
            if _survived_count == 1:    # если кол-во заканчивается на 1, то
                _tasks.append(('text', 'QUEST_DLG_TASK_SURVIVED'))   # выжившего
            elif _survived_count in [2,3,4]:
                _tasks.append(('text', 'QUEST_DLG_TASK_SURVIVED_2'))   # выживших
            else:
                _tasks.append(('text', 'QUEST_DLG_TASK_SURVIVED_5'))   # выживших
            _dlg_settings = {'imageid': self.GetAttrStr('dlg_avatar'),
                            'nameid': self.GetAttrStr('dlg_name'),
                            'textid': text,
                            'tasks_text': _tasks,
                            'task_uid':str(_uid),
                            'single_mode':str(True),
#                            'showin_effect':'task_fly_in',
                            'pause':str(400),
                            }
            return _dlg_settings
        else:
            return None
# ============================================================
# ============================================================
# ============================================================
    def is_green_state(self):
        '''Цвет типса/селекта'''
        _has_access = self.HasAccess()
        if self.is_deactivated:
            if not _has_access:
                return False
            else:
                return True
        if not _has_access:
            return False
        _is_active = self.is_active()
        if _is_active:
            return True
        if self.res_action_cost:
            _is_res_enough = UStats.IsResEnough(self.res_action_cost)
            if not _is_res_enough:   # если хватает ресурсов на действие над объектом
                return False
        return True
# ============================================================
    def Get_tip_image(self):
        '''Возвращает ID изображения, которое используется для бэка типса'''
        # чтобы обновить кадр селекта:
        _frame = 0
        _is_green = self.is_green_state()
        if not _is_green: _frame = 1
        self.Drawer.SetFrame('select', _frame)
        # ---
        if not _is_green:   # если хватает ресурсов на следующий апгрейд
            return "IMG_I_TIP_BG_RED"
        return "IMG_I_TIP_BG"
# ============================================================
    def Get_tip_text(self, by_click = False):
        '''Возвращает LIST, содержащий текстовые ID'''
        result = []
        if not self.is_shown:
            return result
        if not self._get_tips_extra('before_name', result, by_click): return result
        item_name = self.GetAttrStr("item_name")
        if not item_name or item_name == 'NO_TIPS':
            return result
        _has_access = self.HasAccess()
        if not by_click:
            result.append( ("text", "COLOR_HEADER") )
            result.append( ("text", item_name) )
            if not self._get_tips_extra('after_name', result, by_click): return result
            if not self.is_active():
                return result
            if not self._get_tips_extra('after_name2', result, by_click): return result
            #if self.SM.GetCurrentState() in ["", "normal"]:
            res = self.res_action_cost
            _is_res_empty = True
            if res: _is_res_empty = res.Empty()
            if not _is_res_empty:     # если ресурс не задан, то здесь делать нечего
                result.append( 'newline' )
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NEED_FOR_ACTION') )
                result.append( 'space' )
                res_numbers = self._append_res_values(res)
                result.extend( res_numbers )
                if not UStats.IsResEnough(res):
                    diff_res = UStats.GetNotEnoughRes(res)
                    if diff_res:
                        result.append( ('text', 'NOT_ENOUGH') )
                        result.append( 'space' )
                        res_numbers = self._append_res_values(diff_res)
                        result.extend( res_numbers )
        else:
            if not self._get_tips_extra('before_access_check_click', result, by_click):
                return result
            if not _has_access:
                result = []
                result.append( ('text', 'COLOR_RED') )
                result.append( ('text', 'NO_PATH') )
                return result
            if _has_access:
                if self.is_survived:
                    _can_show = True
                    _is_talking = self.GetAttrBool('is_talking')
                    if _is_talking:
                        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
                        if _has_barbarians:
                            result.append( ('text', 'COLOR_LINES') )
                            result.append( ('text', 'YOU_HAVE_NO_TIME_TO_TALK') )
                            return result
                        _is_active = self.is_active()
                        if _is_active:
                            _can_show = False
                        _is_busy = self.is_busy()
                        if _is_busy:
                            _can_show = False
                    if _can_show:
                        if _is_talking:
                            result.append( ('text', 'COLOR_LINES') )
                            result.append( ('text', ('NOT_READY_TO_TALK','NOT_READY_TO_TALK_W')[self.is_woman == True]) )
                            return result
                        else:
                            result.append( ('text', 'COLOR_LINES') )
                            result.append( ('text', ('NOT_READY_TO_TALK2','NOT_READY_TO_TALK2_W')[self.is_woman == True]) )
                            return result
            if not self.is_active():
                return []
            res = self.res_action_cost
            _is_res_empty = True
            if res: _is_res_empty = res.Empty()
            if not _is_res_empty:     # если ресурс не задан, то здесь делать нечего
                if not UStats.IsResEnough(res):
                    diff_res = UStats.GetNotEnoughRes(res)
                    if diff_res:
                        result.append( ("text", "COLOR_RED") )
                        result.append( ("text", "NOT_ENOUGH") )
                        result.append( 'space' )
                        res_numbers = self._append_res_values(diff_res)
                        result.extend( res_numbers )
            if not result:
                return self.Get_tip_text(False) # если по клику нет типса, то вернем его как без клика
        return result
# ============================================================
    def _get_tips_extra(self, place, result, by_click):
        '''Предназначается для переопределения в потомках
        place: метка позиции вставки типса
        result: список значений, в который нужно добавлять данные
        by_click: типс по клику или нет
        returns: False - для завершения типса, т.е. после него ни одной строки не прибавится'''
        return True
# ============================================================
    def get_params_not_enough_text(self, result, extra_text, how_much = False):
        _need_power = self.GetAttrInt('need_power')
        _need_oratory = self.GetAttrInt('need_oratory')
        _cmp_value = 1
        if how_much:
            _cmp_value = 0
            _need_power -= 1
            _need_oratory -= 1
            _cur_res = UStats.GetCurRes()
            _need_oratory = _need_oratory - _cur_res.Get('gem_green')
            _need_power = _need_power - _cur_res.Get('gem_blue')
        if _need_oratory > _cmp_value:
            #result.append( ('text', 'COLOR_LINES') )
            #result.append('newline')
            if extra_text: result.extend(extra_text)
            #result.append(('text', 'TO_SPEAK'))
            #result.append( 'space' )
            result.append(('text', 'TIPS_ORATORY'))
            result.append( 'space' )
            result.append(('text', 'TIPS_LEV'))
            result.append( 'space' )
            result.append( ('digit', _need_oratory) )
        if _need_power > _cmp_value:
            #result.append( ('text', 'COLOR_LINES') )
            #result.append('newline')
            if extra_text: result.extend(extra_text)
            #result.append(('text', 'TO_SPEAK'))
            #result.append( 'space' )
            result.append(('text', 'TIPS_POWER'))
            result.append( 'space' )
            result.append(('text', 'TIPS_LEV'))
            result.append( 'space' )
            result.append( ('digit', _need_power) )
# ============================================================
    def _append_res_values(self, resources):
        '''Для типса. Генерирует список со значениями переданного ресурса, с соответствующими изображениями'''
        result = []
        first_res = True
        for res_name in self.resource_names:    # выводим значения ресурсов...
            res_val = resources.Get(res_name)
            if res_val > 0:     # на всякий случай
                if not first_res:
                    result.append( ["comma"] )
                    result.append( ["space"] )
                first_res = False
                result.append( ("digit", resources.Get(res_name)) )
                result.append( ("image", self.res_images[res_name]) )
        return result
# ============================================================
    def Get_tip_position(self, tip_size, camera_pos, window_rect, zoom):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        return toolz.Tools.get_tip_position(self, tip_size, camera_pos, window_rect)
# ============================================================
    def send_extra_event(self):
        if self.extra_event:
            BMgr.SendGlobalMsg('extra_event', self.extra_event)
            self.extra_event = ''
# ============================================================
    def get_action_cost_res(self):
        has_resname = self.HasAttr('acost_res_name')
        acost_res_name = 'action_cost'
        if has_resname:
            acost_res_name = self.GetAttrStr('acost_res_name')
        res = self.GetRes(acost_res_name)
        return res
# ============================================================
    def Force_highlight(self, highlight):
        pass
# ============================================================
    def on_quest_complete_all(self):
        pass        # просто затычка для обычных юнитов
# ============================================================
    def start_comet(self, _name, result_signal = 'comet_fly_complete'):
        '''Запускает комету, если указана в атрибутах, иначе просто дает сигнал на завершение удаления'''
        _comet_effect_name = _name
        if not _comet_effect_name:
            _comet_effect_name = self.GetAttrStr('comet_name')
        if _comet_effect_name:
            LBoard.StartComet(self, _comet_effect_name, result_signal)
            self.PlaySoundG('SND_ITEM_FLIGHT')
        else:
            self.Signals.Restart(result_signal, 1)
# ============================================================
    def get_ui_subtext(self):
        '''Текст, который должен быть написан в типсе возле панели с
        лицом персонажа второй строкой
        returns tuple where first item is text and second one is green-state (if True)'''
        return ([('text', 'FACES_READY_TO_SPEAK')], True)
# ============================================================
    def on_before_action_started(self): # for safe only
        pass
# ============================================================


