# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

class BuildingHelper(object):
# ============================================================
    def __init__(self):
        self.drawer = None
        self.signal_name = ''
        self.actions = []           # текущие действия, [ [('action', params)], [('action', params), ('action', params)] ]
        self.current_subactions = []
        self.signaler = None
        pass
# ============================================================
    #def on_update(self, ms):
    #    pass
# ============================================================
    def initialize(self, drawer, signal_name = 'bhelper_signal'):
        '''Задает связку с LayeredDrawer объекта'''
        self.drawer = drawer
        self.signal_name = signal_name
# ============================================================
    def reset(self):
        self.actions = []
        self.current_subactions = []
        if self.signaler:
            self.signaler.Cancel(self.signal_name)
# ============================================================
    def set_actions(self, signaler, actions = []):
        '''Передает список действий-'сигналов' для LayeredDrawer'''
        self.signaler = signaler
        # нужно распарсить actions, и создать несколько сигналов
        # сначала переведем все в списки:
        _actions = []
        for subactions in actions:
            if istype(subactions.actions, 'dict'):
                _actions.append( {'time':subactions.time, 'actions':[subactions.actions]} )
            elif istype(subactions.actions, 'list'):
                _actions.append( {'time':subactions.time, 'actions':subactions.actions} )
            else:
                mbox('ERROR. Wrong data for BuildingHelper')

        self.actions = []
        # теперь можно обрабатывать подготовленный список
        for subactions in _actions:
            signaler.Add( self.signal_name, subactions.time )
            _subactions = []
            for action in subactions.actions:   # обработаем список действий на один сигнал
                _action = {}        # нам время хранить не нужно,
                _action.name = action.name      # только название действия
                _action.params = action.params  # и параметры
                _subactions.append(_action)
            self.actions.append(_subactions)
# ============================================================
    def do_next_action(self):
        '''Выполняет следующее действие из списка действий'''
        if self.actions:
            self.current_subactions = self.actions.pop(0)    # берем первый список действий
            self.do_subactions()
            if not self.actions:    # если действия закончились
                self.signaler.Add( self.signal_name, 1 )
            return True
        else:
            return False    # no more actions
# ============================================================
    def has_more_actions(self):
        if self.actions:
            return True
        else:
            return False
# ============================================================
    def do_subactions(self):
        for action in self.current_subactions:
            self.do_action(action)
# ============================================================
    def do_action(self, action):
        '''Выполняет одно простое действие'''
        name = action.name
        params = action.params
        if name == 'show':
            self.drawer.ShowImages(params.images, True)
        elif name == 'hide':
            self.drawer.ShowImages(params.images, False)
        elif name == 'reset_anim_time':    # сбрасывает время анимации в C++
            self.drawer.ResetAnimTime(params.images)
        elif name == 'set_frame':
            self.drawer.SetFrame(params.image, params.frame)
        elif name == 'stop_animation':
            self.drawer.StopAnimation(params.image, params.time)
        elif name == 'start_once_animation':
            self.drawer.PlayAnimationOnce(params.image, '')
        elif name == 'set_event':
            self.drawer.SetAnimationEvent(params.image, params.percent, params.event)
# ============================================================
# ============================================================
