class Token:
    def __init__(self,pos=(0,0),type='symbol',val=None,items=None):
        self.pos, self.type, self.val, self.items=pos,type,val,items

def u_error(ctx,s,i):
    y,x = i
    line = s.split('\n')[y-1]
    p = ''
    if y < 10: p += ' '
    if y < 100: p += '  '
    r = p + str(y) + ": " + line + "\n"
    r += "     "+" "*x+"^" +'\n'
    raise 'error: '+ctx+'\n'+r

_ISYMBOLS = '`-=[];,./~!@$%^&*()+{}:<>?|'
ISYMBOLS = {}
# _SYMBOLS = [
    # 'def','class','yield','return','pass','and','or','not','in','import',
    # 'is','while','break','for','continue','if','else','elif','try',
    # 'except','raise','True','False','None','global','del','from',
    # '-','+','*','**','/','%','<<','>>',
    # '-=','+=','*=','/=','=','==','!=','<','>', '|=', '&=', '^=',
    # '<=','>=','[',']','{','}','(',')','.',':',',',';','&','|','!', '^'
    # ]
#SYMBOLS = {}
SYMBOLS = {
    'def':0,'class':0,'yield':0,'return':0,'pass':0,'and':0,'or':0,'not':0,'in':0,'import':0,
    'is':0,'while':0,'break':0,'for':0,'continue':0,'if':0,'else':0,'elif':0,'try':0,
    'except':0,'raise':0,'True':0,'False':0,'None':0,'global':0,'del':0,'from':0,
    '-':0,'+':0,'*':0,'**':0,'/':0,'%':0,'<<':0,'>>':0,
    '-=':0,'+=':0,'*=':0,'/=':0,'=':0,'==':0,'!=':0,'<':0,'>':0, '|=':0, '&=':0, '^=':0,
    '<=':0,'>=':0,'[':0,']':0,'{':0,'}':0,'(':0,')':0,'.':0,':':0,',':0,';':0,'&':0,'|':0,'!':0, '^':0
    }
# _B_BEGIN,_B_END = ['[','(','{'],[']',')','}']
B_BEGIN,B_END = {'[':0,'(':0,'{':0}, {']':0,')':0,'}':0}
#B_BEGIN, B_END = {}, {}


# ============================================================
#for val in _SYMBOLS:    # copy from list to array - performance hint
#    SYMBOLS[val] = 0
for sym in _ISYMBOLS:
    ISYMBOLS[sym] = 0
# for sym in _B_BEGIN:
    # B_BEGIN[sym] = 0
# for sym in _B_END:
    # B_END[sym] = 0

# ISYMBOLS = _ISYMBOLS
# SYMBOLS = _SYMBOLS
# B_BEGIN = _B_BEGIN
# B_END = _B_END
# ============================================================

    
class TData:
    def __init__(self):
        self.y, self.yi, self.nl = 1,0,True
        self.res, self.indent, self.braces = [],[0],0
        
    def add(self,t,v): self.res.append(Token(self.f,t,v))

def clean(s):
    s = s.replace('\r\n','\n')
    s = s.replace('\r','\n')
    return s

def tokenize(s):
    global T
    s = clean(s)
    T,i,l = TData(),0,len(s)
    try: return do_tokenize(s,i,l)
    except: u_error('tokenize',s,T.f)

def do_tokenize(s,i,l):
    global T
    T.f = (T.y,i-T.yi+1)
    while i < l:
        c = s[i]; T.f = (T.y,i-T.yi+1)
        if T.nl: T.nl = False; i = do_indent(s,i,l)
        elif c == ' ' or c == '\t': i += 1
        #elif c in (' ', '\t'): i += 1
        elif (c >= 'a' and c <= 'z') or \
            (c >= 'A' and c <= 'Z') or c == '_':  i = do_name(s,i,l)
        elif c >= '0' and c <= '9': i = do_number(s,i,l)
        elif c in ISYMBOLS: i = do_symbol(s,i,l)
        elif c == '\n': i = do_nl(s,i,l)
        elif c=='#': i = do_comment(s,i,l)
        elif c=="'" or c=='"': i = do_string(s,i,l)
        elif c == '\\' and s[i+1] == '\n':
            i += 2; T.y,T.yi = T.y+1,i
        else: u_error('tokenize',s,T.f)
    indent(0)
    r = T.res; T = None
    #for t in r:
        #print (t.pos,t.type,t.val)
    return r

def do_nl(s,i,l):
    if not T.braces:
        T.add('nl',None)
    i,T.nl = i+1,True
    T.y,T.yi = T.y+1,i
    return i

def do_indent(s,i,l):
    v = 0
    while i<l:
        c = s[i]
        if c != ' ' and c != '\t': break
        i,v = i+1,v+1
    if c != '\n' and c != '#' and not T.braces: indent(v)
    return i

def indent(v):
    t_indent = T.indent[-1]
    if v == t_indent: pass
    elif v > t_indent:
        T.indent.append(v)
        T.add('indent',v)
    elif v < t_indent:
        n = T.indent.index(v)
        n_1 = n+1
        while len(T.indent) > n_1:
            v = T.indent.pop()
            T.add('dedent',v)

def do_symbol(s,i,l):
    symbols = []
    v,f,i = s[i],i,i+1
    if v in SYMBOLS: symbols.append(v)
    while i<l:
        c = s[i]
        if not c in ISYMBOLS: break
        v,i = v+c,i+1
        if v in SYMBOLS: symbols.append(v)
    v = symbols.pop(); n = len(v); i = f+n
    T.add('symbol',v)
    if v in B_BEGIN: T.braces += 1
    if v in B_END: T.braces -= 1
    return i

def do_number(s,i,l):
    v,i,c =s[i],i+1,s[i]
    while i<l:
        c = s[i]
        if (c < '0' or c > '9') and (c < 'a' or c > 'f') and c != 'x': break
        v,i = v+c,i+1
    if c == '.':
        v,i = v+c,i+1
        while i<l:
            c = s[i]
            if c < '0' or c > '9': break
            v,i = v+c,i+1
    T.add('number',v)
    return i

def do_name(s,i,l):
    v,i =s[i],i+1
    while i<l:
        c = s[i]
        if (c < 'a' or c > 'z') and (c < 'A' or c > 'Z') and (c < '0' or c > '9') and c != '_': break
        v,i = v+c,i+1
    if v in SYMBOLS: T.add('symbol',v)
    else: T.add('name',v)
    return i

def do_string(s,i,l):
    # need precalculate l-2
    v,q,i = '',s[i],i+1
    if (l-i) >= 5 and s[i] == q and s[i+1] == q: # """
        i += 2
        while i<l-2:
            c = s[i]
            if c == q and s[i+1] == q and s[i+2] == q:
                i += 3
                T.add('string',v)
                break
            else:
                v,i = v+c,i+1
                if c == '\n': T.y,T.yi = T.y+1,i
    else:
        while i<l:
            c = s[i]
            if c == "\\":
                i = i+1; c = s[i]
                if c == "n": c = '\n'
                if c == "r": c = chr(13)
                if c == "t": c = "\t"
                if c == "0": c = "\0"
                v,i = v+c,i+1
            elif c == q:
                i += 1
                T.add('string',v)
                break
            else:
                v,i = v+c,i+1
    return i

def do_comment(s,i,l):
    i += 1
    while i<l:
        #c = s[i]
        #if c == '\n': break
        if s[i] == '\n': break
        i += 1
    return i


