# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class DigBogSubtask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.actor_action_animation = 'dig'

    def start_action(self, item):
        item.stop_attention_signal()        # не показываем эффект когда закапываем
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class Bog(base_diff_item.DiffItem):
    '''Болото'''
    digged_variants = {'normal_left':'digged_left',
                    'normal_right':'digged_right'}

    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.task = None
        self.need_attention_effect = False
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _digged_var = 'digged'
        _cur_var = self.get('variant_name')
        if _cur_var in self.digged_variants:
            _digged_var = self.digged_variants[_cur_var]
        self.switch_variant( _digged_var )
        self.action_hits_last = 0
        bog_info = {'type':self.get('type'), 'subtype':self.get('subtype')}
        EMgr.send_event( 'bog_digged', self, bog_info )
        BMgr.remove_uid(self.get('uid'))
        self.deactivate()
        self.SetMouseActive(False)
        self.send_extra_event()
        EMgr.send_event( 'do_action_complete', self )
# ============================================================
    def play_hit_sound(self):
        self.PlaySound('SND_WATER_SPADE')
# ============================================================
    def get_subtask(self, parent_task, actor):
        return DigBogSubtask(parent_task, actor)
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_DIG'
# ============================================================
# #######################################################
# #######################################################
# #######################################################
