# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class OpenChestSubtask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.actor_action_animation = 'hit'
# ============================================================
    def start_action(self, item):
        self.actor.stop_walk()
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        return True
# ============================================================
# ============================================================
# ============================================================
class Chest(base_diff_item.DiffItem):
    '''Горшок'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.task = None
        self.is_opened = False
        _cur_variant_name = self.get("variant_name")
        if _cur_variant_name not in self.variants:
            self.is_opened = True
        self.content_items = []
# ============================================================
    variants = {
        'closed_1' : 'opened_1',
        'closed_2' : 'opened_2'
    }
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _cur_variant_name = self.get("variant_name")
        _content = self.get_unpacked_content( self.GetAttrStr('content') )  # строго до смены варианта
        #self.publish_contents(_content)
        self.content_items = self.publish_contents_by_one(_content)
        _time = 0
        for item in self.content_items:
            self.Signals.Add('show_item', _time)
            _time += 500
        self.switch_variant( self.variants[_cur_variant_name] ) # переключаемся на открытый вариант
        self.is_opened = True
        self.action_hits_last = self.GetAttrInt('action_hits_count')   # уже после смены варианта
        chest_info = {"type":self.get('type'), "subtype":self.get('subtype')}
        EMgr.send_event( 'chest_opened', self, chest_info )
        self.deactivate()
        self.SetMouseActive(False)
        self.send_extra_event()
        self.switch_animation()
# ============================================================
    def on_signal(self, signal):
        if signal == 'show_item':
            if self.content_items:
                item = self.content_items.pop(0)
                _pos = item.GetAttrPoint('center_item_pos')
                item.Drawer.Hide(False)
                item.Drawer.ResIn(item.item_layers, _pos, 1000)
                item.play_content_sound(self)
        else:
            base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    def get_subtask(self, parent_task, actor):
        if not self.is_opened:
            return OpenChestSubtask(parent_task, actor)
        else:
            return None
# ============================================================
    #@override
    #def on_signal(self, signal):
    #    if signal == 'offscreen':
    #        if self.is_opened:
    #            BMgr.RemoveItemFromMap(self)    # удалим сундук нафиг
    #            return
    #    else:
    #        base_diff_item.DiffItem.on_signal(self, signal)
# ============================================================
    #@override
    def switch_animation(self):
        self.Drawer.ShowImages('', False)
        self.Drawer.ShowImages(['floor','icons'])
        image_category = 'default'
        self.Drawer.ShowImages(image_category, True)
        self.Drawer.ShowImages('select', self.is_mouse_over and not self.is_deactivated and not self.action_started)
        check_frame = 0
        if self.need_show_uncheck(): check_frame = 1
        self.Drawer.SetFrame('check', check_frame)
        self.Drawer.ShowImages('check', self.has_check)
        self.Drawer.ShowImages('arrow', self.arrow_shown)
        self.Drawer.ShowImages('clock_wait', self.clock_shown)
# ============================================================
    def play_hit_sound(self):
        self.PlaySound('SND_CHEST_HIT')
# ============================================================
    def play_complete_sound(self):
        self.PlaySound('SND_CHEST_OPEN')
# ============================================================
# #######################################################
# #######################################################
# #######################################################
