# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class ChopDrTreeSubtask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.actor_action_animation = 'action_w_cut'

    def start_action(self, item):
        item.stop_attention_signal()    # не показываем эффект когда рубим
        self.actor.stop_walk()
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class DrTree(base_diff_item.DiffItem):
    '''Дерево-завал'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.task = None
        self.need_attention_effect = False
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        self.action_hits_last = 0
        drtree_info = {'type':self.get('type'), 'subtype':self.get('subtype')}
        EMgr.send_event( 'bog_digged', self, drtree_info )
        self.play_complete_sound()
        self.remove_me_later()
        self.task.subtask.actor.resource = self.give_resource()
        EMgr.send_event( 'do_action_complete', self )
        self.send_extra_event()
        #BMgr.RemoveItemFromMap(self)
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит забирает ресурс у куста. Скрывает картинку ягод и начинает новую цепочку производства'''
        self.stop_attention_signal()
        #self.switch_animation()
        _gives = self.GetRes('gives')
        return _gives
# ============================================================
    def get_subtask(self, parent_task, actor):
        return ChopDrTreeSubtask(parent_task, actor)
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_CHOP'
# ============================================================
    def play_hit_sound(self):
        self.PlaySound('SND_CHOP_TREE')
# ============================================================
    def play_complete_sound(self):
        self.PlaySound('SND_FALLEN_TREE_FALL')
# ============================================================
# #######################################################
# #######################################################
# #######################################################
