# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class EnablerSubtask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.actor_action_animation = 'pickup'

    def start_action(self, item):
        self.actor.stop_walk()
        item.action_started = True
        self.actor.action_hit_item(item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
        return True
# ============================================================
# ============================================================
class Enabler(base_diff_item.DiffItem):
    '''Переключатель'''
    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.task = None
# ============================================================
    #@override
    def on_create(self):
        base_diff_item.DiffItem.on_create(self)
        self.add_attention_signal()
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        _linked_uids = self.GetAttrStr('linked_uids')
        self.switch_variant( 'complete' )
        self.action_hits_last = 0
        enabler_info = {'type':self.get('type'), 'subtype':self.get('subtype')}
        EMgr.send_event( 'enabler_action', self, enabler_info )
        #self.PlaySound('SND_POT_CRASH')
        self.send_extra_event()
        BMgr.remove_uid(self.get('uid'))
        _linked_items = BMgr.get_items(_linked_uids)
        self.PlaySound('SND_STONEDOOR_SWITCH')
        # открываем двери и прочее:
        for _item in _linked_items:
            try:
                _item.do_action_enable()
            except: pass
# ============================================================
    def get_subtask(self, parent_task, actor):
        if not self.is_action_complete():
            return EnablerSubtask(parent_task, actor)
        else:
            return None
# ============================================================
    def play_hit_sound(self):
        self.PlaySound('SND_POT_HIT')
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_BREAK_POT'
# ============================================================
# #######################################################
# #######################################################
# #######################################################
