# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_diff_item
import task_classes


class HackStoneSubtask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
        self.actor_action_animation = 'action_quarry'

    def start_action(self, item):
        #item.stop_attention_signal()        # не показываем эффект когда закапываем
        self.actor.stop_walk()
        item.action_started = True
        self.actor.action_hit_item(item)
        return True
# ============================================================
# ============================================================
class Stone(base_diff_item.DiffItem):
    '''Камень'''

    def __init__(self, cdata):
        base_diff_item.DiffItem.__init__(self, cdata)
        self.task = None
        self.need_attention_effect = False
        self.skip_frames = self.GetAttrInt('skip_frames')
        self.Drawer.SetProgressedAnimation('default')
# ============================================================
    # @override
    def on_action_hits_me_complete(self):
        self.action_hits_last = 0
        stone_info = {'type':self.get('type'), 'subtype':self.get('stype')}
        EMgr.send_event( 'stone_broken', self, stone_info )
        self.task.subtask.actor.resource = self.give_resource()
        self.switch_variant( 'none' )
        EMgr.send_event( 'do_action_complete', self )
        self.PlaySound('SND_ROCKS_FALL')
        self.send_extra_event()
        BMgr.remove_uid(self.get('uid'))
# ============================================================
    #@override
    def on_action_hit_me(self):
        self.Drawer.SetFramesProgress('default', self.action_progress, self.skip_frames, 1)   # без последнего кадра
# ============================================================
    def get_subtask(self, parent_task, actor):
        return HackStoneSubtask(parent_task, actor)
# ============================================================
    #@override
    def is_action_complete(self):
        '''Действие [юнитом] над данным объектом уже было выполнено'''
        return self.action_hits_last <= 0 or not self.action_started
# ============================================================
    #@override
    def get_action_text(self, for_task_slide = False):
        return 'DLG_TASK_HACK_STONE'
# ============================================================
    def give_resource(self):
        '''Вызывается в момент, когда юнит забирает ресурс у куста. Скрывает картинку ягод и начинает новую цепочку производства'''
        self.stop_attention_signal()
        #self.switch_animation()
        _gives = self.GetRes("gives")
        return _gives
# ============================================================
    def _switch_animation_extra(self, place):
        '''Метод для переопределения в подклассах
        place: точка вызова метода'''
        if place == 'begin':
            self.Drawer.ShowImages('picture_stone', not self.action_started)
            self.Drawer.SetFramesProgress('default', self.action_progress, self.skip_frames, 1)   # без последнего кадра
# ============================================================
    def play_hit_sound(self):
        self.PlaySound('SND_STONE_HIT')
# ============================================================
# #######################################################
# #######################################################
# #######################################################
