# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog
import toolz
import pmgr


class BookDlg(dialog.Dialog):
# ============================================================
    levels_info1 = [{'tag':'0', 'text':'LEVEL_1_1', 'text2':'LEVEL_1_1_DESC', 'level':1, 'frame':2, 'extra':''},
                    {'tag':'1', 'text':'LEVEL_1_2', 'text2':'LEVEL_1_2_DESC', 'level':2, 'frame':3, 'extra':''},
                    {'tag':'2', 'text':'LEVEL_1_3', 'text2':'LEVEL_1_3_DESC', 'level':3, 'frame':2, 'extra':''},
                    {'tag':'3', 'text':'LEVEL_1_4', 'text2':'LEVEL_1_4_DESC', 'level':4, 'frame':3, 'extra':''},
                    {'tag':'4', 'text':'LEVEL_1_5', 'text2':'LEVEL_1_5_DESC', 'level':5, 'frame':1, 'extra':''},
                ]
    levels_info2 = [{'tag':'5', 'text':'LEVEL_2_1', 'text2':'LEVEL_2_1_DESC', 'level':1, 'frame':0, 'extra':''},
                    {'tag':'6', 'text':'LEVEL_2_2', 'text2':'LEVEL_2_2_DESC', 'level':2, 'frame':0, 'extra':''},
                    {'tag':'7', 'text':'LEVEL_2_3', 'text2':'LEVEL_2_3_DESC', 'level':3, 'frame':0, 'extra':''},
                    {'tag':'8', 'text':'LEVEL_2_4', 'text2':'LEVEL_2_4_DESC', 'level':4, 'frame':0, 'extra':''},
                    {'tag':'9', 'text':'LEVEL_2_5', 'text2':'LEVEL_2_5_DESC', 'level':5, 'frame':0, 'extra':''},
                    {'tag':'10', 'text':'LEVEL_2_6', 'text2':'LEVEL_2_6_DESC', 'level':6, 'frame':0, 'extra':'end'},
                ]
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        # если нужно, то доп. параметры можно вытащить из params
        self.EnableMouseMoveEvents(True)
        self.selected_part = 1
        self.selected_level = 1
        self.is_prev_level_complete = True   # чтобы первый всегда был доступен
        tools.PlayMenuMusicIfStopped()
        self.RereadTemplates()  # перечитываем игровые шаблоны
# ============================================================
    def on_signal(self, signal):
        if signal == 'startLevel3':
            _params = {'episode':1, 'level':3}
            DLG.Open_dialog('LoadLevelMenu', 'dlg_loadlevel', _params)
            DLG.Close_dialog(self)
        elif signal == 'openFreemiumDialog':
            DLG.Open_dialog('FreemiumMenu', 'dlg_freemium')
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_mouse_move(self, x, y):
        _item = self.get_over_item(x,y)
        if _item:
            if _item.completion_type != pmgr.LevelStat.COMPLETED_NO:
                result = [('text', 'COLOR_HEADER')]
                if _item.episode == 2 and _item.level == 6:
                    result.append( ['text', 'TIPS_FOR_EXPERTS'] )
                else:
                    result.append( ['text', 'TIPS_EPISODE'] )
                    result.append('space')
                    result.append( ['digit', _item.episode] )
                    result.append('space')
                    result.append( ['text', 'TIPS_LEVEL'] )
                    result.append('space')
                    result.append( ['digit', _item.level] )
                if _item.completion_type != pmgr.LevelStat.COMPLETED_NO:
                    result.append('newline')
                    result.append( ['text', 'COLOR_LINES'] )
                    if _item.completion_type == pmgr.LevelStat.COMPLETED_GOLD:
                        result.append( ('text', 'TIPS_EXPERT') )
                        result.append('newline')
                    result.append( ('text','TIPS_TIME') )
                    result.append('space')
                    _time = self.get_time_formatted(_item.time)
                    result.extend( _time )
                    result.append('newline')
                    result.append( ('text','TIPS_SCORE') )
                    result.append( ('digit', _item.score) )
                self.ShowTips( result, _item.zone.x, _item.zone.y+24, True )
            else:
                self.HideTips()
        else:
            self.HideTips()
# ============================================================
    def Get_tip_position(self, cur_pos, tip_size):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        rects = []
        rects.append( {'x':0, 'y':0, 'w':550, 'h':768} )
        result = toolz.Tools.get_ui_tip_position_r(cur_pos, tip_size, rects)
        return result
# ============================================================
    def on_command(self, name, command, param):
        pass
# ============================================================
    def get_time_formatted(self, time_ms):
        result = []
        _s = time_ms/1000
        _m = int(_s / 60)
        _h = int(_m / 60)
        _d = int(_h / 24)
        _s -= _m * 60
        _m -= _h * 60
        _h -= _d * 24
        if _d > 0:
            result.append( ('digit', _d) )
            result.append( ('text', 'TIME_DAY') )
            result.append('space')
        if _h > 0:
            result.append( ('digit', _h) )
            result.append( ('text', 'TIME_HOUR') )
            result.append('space')
        if _m > 0:
            result.append( ('digit', _m) )
            result.append( ('text', 'TIME_MINUTE') )
            result.append('space')
        if _s > 0:
            result.append( ('digit', _s) )
            result.append( ('text', 'TIME_SECOND') )
        return result
# ============================================================
    def on_create(self):
        #tools.SetGraphicCursor(False)
        DLG.PMgr.reload_current_user()
        self.refill_lists()
        if self.IsDebug():
            self.MoveControl('idLevel_0_0', 0,0)
        # ---
        p_mgr = DLG.PMgr
        _user_progress = p_mgr.get_cur_user_progress()
        completion_type = pmgr.LevelStat.COMPLETED_NO
        for i in range(0,5):
            _lstat = _user_progress.get_level(1, i+1)
            completion_type = _lstat.values.completion_type
            _zone = {'x':556, 'y':128+i*45+4, 'w':352, 'h':45}
            _item = {'episode':1, 'level':i+1, 'zone':_zone, 'completion_type':completion_type,\
                            'score':_lstat.values.score, 'time':_lstat.values.cur_time}
            self.zones.append( _item )
        for i in range(0,6):
            _lstat = _user_progress.get_level(2, i+1)
            completion_type = _lstat.values.completion_type
            _zone = {'x':556, 'y':390+i*45+4, 'w':352, 'h':45}
            _item = {'episode':2, 'level':i+1, 'zone':_zone, 'completion_type':completion_type,\
                        'score':_lstat.values.score, 'time':_lstat.values.cur_time}
            self.zones.append( _item )
        self.refill_lists()
# ============================================================
    last_index = 0
    def refill_lists(self):
        self.is_prev_level_complete = True
        self.fill_levels_list('idLevelsList1', self.levels_info1, 1)
        self.fill_levels_list('idLevelsList2', self.levels_info2, 2)
        #self.SetListSelectedItem('idLevelsList1', 0)

        if self.last_index < 5:
            #self.SetListSelectedItem('idLevelsList1', self.last_index)
            self.set_level('idLevelsList1', self.last_index)
        else:
            self.set_level('idLevelsList2', self.last_index - 5)
            #self.SetListSelectedItem('idLevelsList2', self.last_index - 5)
# ============================================================
    def fill_levels_list(self, list_name, levels_source, episode):
        self.ListClear(list_name)
        index = 1
        for level_info in levels_source:
            str1 = [('text', level_info.text)]
            str2 = [('text', level_info.text2)]
            _frame = self.get_level_frame(episode, index, self.is_prev_level_complete)
            # грязным хаком выбираем последний доступный уровень:
            if self.is_prev_level_complete:
                self.last_index = index
                if episode > 1:
                    self.last_index += 5
                self.last_index -= 1    # потому что ПРЕДЫДУЩИЙ уровень последний
                # freemium start
                if self.last_index > 100:#2:
                    self.last_index = 2
                    self.set_level(list_name, self.last_index)
                else:
                # freemium end
                    self.set_level(list_name, index)
                if self.last_index > 10: self.last_index = 10
                #self.selected_part, self.selected_level = (episode, index)
            if _frame <= 1: self.is_prev_level_complete = False
            self.ListAddLevel(list_name, level_info.tag, str1, str2, 'IMG_MENU_BOOK_POINTS', _frame, (_frame > 0), level_info.extra)
            index += 1
# ============================================================
    def get_level_frame(self, episode, level, prev_complete):
        '''Выбираем кадр картинки для строки уровня'''
        p_mgr = DLG.PMgr
        user_progress = p_mgr.get_cur_user_progress()
        _expert_levels_count = user_progress.get_expert_levels_count()
        lstat = user_progress.get_level(episode, level)
        completion_type = 1
        if 'completion_type' not in lstat.values:
            completion_type = pmgr.LevelStat.COMPLETED_NO
        else:
            completion_type = lstat.values.completion_type
        
        # freemium start
            #if episode == 2:
                #return 0
            #        if level > 3:
                #return 0
        # freemium end

        # финальный уровень должен быть доступен только при экспертном прохождении остальных:
        if episode == 2:
            if level == 6:
                if _expert_levels_count < 10:
                    return 0
        if completion_type == pmgr.LevelStat.COMPLETED_GOLD:
            return 3
        elif completion_type == pmgr.LevelStat.COMPLETED_SILVER:
            return 2
        elif completion_type == pmgr.LevelStat.COMPLETED_NO:
            if prev_complete:
                return 1
            else:
                return 0
# ============================================================
    def on_button(self, id):
        if id == 'idStart':
            _episode, _level = self.selected_part, self.selected_level
            if _episode >= 0 and _level >= 0:
                if _episode == 2 and _level > 6:
                    _level = 6
                
                # freemium start
                if _level == 100:#3:
                    DLG.SendMsg('openFreemiumDialog')
                # freemium end
                else:
                    _params = {'episode':_episode, 'level':_level}
                    DLG.Open_dialog('LoadLevelMenu', 'dlg_loadlevel', _params)
                    DLG.Close_dialog(self)
        elif id == 'idBack':
            DLG.Open_dialog('MainMenu', 'dlg_main')
            DLG.Close_dialog(self)
        elif id == 'idPromo':
            DLG.SendMsg('more_games')
        elif id == 'idSubsribe':
            DLG.SendMsg('subsribe')
        elif id == 'idBuy':
            DLG.SendMsg('openBuyGame')
        elif id == 'idLevel_0_0': # for debug
    	    DLG.PMgr.cheat_all_complete()
    	    self.refill_lists()
            #DLG.Open_dialog("LoadLevelMenu", "dlg_loadlevel", {'episode':0, 'level':0})
            #DLG.StartLevel(0, 0)
            #DLG.Close_dialog(self)
# ============================================================
    def on_key(self, key):
        _cheated = self.IsCheatsEnabled()
        if _cheated:
            if key == 'A':  # reload game scripts:
                self.ReloadGameScripts()
            elif key == 'C':
                DLG.PMgr.cheat_all_complete()
                self.refill_lists()
            elif key == 'N':
                DLG.PMgr.cheat_complete_next()
                self.refill_lists()
            elif key == 'S':
                DLG.PMgr.cheat_complete_next_nonexpert()
                self.refill_lists()
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
    def on_list_selection_change(self, id, new_tag, new_index, old_index, extra):
        if new_index >= 0:
            tools.PlaySound('SND_BTN_OVER_PAPER')
# ============================================================
    def set_level(self, id, index):
        '''Выставялет текущий эпизод и уровень'''
        self.SetListSelectedItem('idLevelsList1', -1)
        self.SetListSelectedItem('idLevelsList2', -1)
        if id == 'idLevelsList1':
            self.selected_part = 1
            self.selected_level = index+1
            self.SetListSelectedItem(id, self.selected_level-1)
        elif id == 'idLevelsList2':
            _episode = 2
            _level = index+1
            #mbox(str(_episode) + '_' + str(_level))
            p_mgr = DLG.PMgr
            user_progress = p_mgr.get_cur_user_progress()
            _expert_levels_count = user_progress.get_expert_levels_count()
            # финальный уровень должен быть доступен только при экспертном прохождении остальных:
            if _episode == 2:
                if _level == 6:
                    if _expert_levels_count < 10:
                        self.selected_part = _episode
                        self.selected_level = _level-1
                        self.SetListSelectedItem(id, self.selected_level-1)
                        return
            self.selected_part = 2
            self.selected_level = index+1
            self.SetListSelectedItem(id, self.selected_level-1)
# ============================================================
    def on_list_click(self, id, tag, index, extra):
        '''Вызывается при клике по элементу списка'''
        self.set_level(id, index)
        tools.PlaySound('SND_BTN_CLICK_PAPER')
# ============================================================
    def on_list_dbl_click(self, id, tag, index, extra):
        '''Вызывается при двойном клике по элементу списка'''
        _episode, _level = self.selected_part, self.selected_level
        self.set_level(id, index)
        if _episode >= 0 and _level >= 0:
            #DLG.StartLevel(_episode, _level)
            if _episode == 2 and _level > 6:
                _level = 6
            DLG.Open_dialog("LoadLevelMenu", "dlg_loadlevel", {'episode':_episode, 'level':_level})
            DLG.Close_dialog(self)
# ============================================================
# ============================================================
# ============================================================
