# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import dialog
import pmgr

class StatsDlg(dialog.Dialog):
    values_controls = ['idSurvivedCountV', 'idGoldSentV', 'idLeftGoldV',\
                        'idLeftFoodV', 'idLeftBoardsV', 'idLeftBricksV',\
                        'idLeftCoinsV', 'idLeftTimeV', 'idSecretsFoundV',\
                        'idSecretsLeftV', 'idTimeV', 'idLevelScoreV',\
                        'idGameScoreV' ]
    eff_pre_pos = [ (538,218),\
                    (538,252),\

                    (538,286),\
                    (538,303),\
                    (538,320),\
                    (538,337),\
                    (538,354),\
                    (538,371),\

                    (538,422),\
                    (538,439),\
                    (538,507),\
                    (538,524),\
                    (538,541) ]
    values_fields = ['survived', 'gold_need', 'gold',\
                        'food', 'boards', 'bricks',\
                        'coins', 'time_left', 'secrets',\
                        'secrets_left', 'time_min', 'score',\
                        'score_total']
                        #'gold_need', 'survived_need']
# ============================================================
    def __init__(self, cdata, params={}):
        dialog.Dialog.__init__(self, cdata, params)
        self.size = 'fullscreen'
        # если нужно, то доп. параметры можно вытащить из params
        self.is_final = ('final' in params)
        self.index = 0
        self.stats = None
        self.eff_pos = []
        for pre_pos in self.eff_pre_pos:
            self.eff_pos.append( {'x':pre_pos[0], 'y':pre_pos[1]} )
# ============================================================
    def on_signal(self, signal):
        if signal == 'next_line':
            _len = len(self.values_controls)
            if self.index < _len:
                if self.values_fields[self.index] == 'time_left':
                    _is_time_left = self.is_time_left()
                    if not _is_time_left:
                        self.index += 1     # пропускаем это поле
                self.ShowEffect('stat_explosion', self.eff_pos[self.index])
                self.Signals.Restart('show_text', 100)
                self.Signals.Restart('next_line', 200)
                #tools.PlaySound('')
            else:
                _is_level_gold = self.is_level_gold()
                if _is_level_gold:
                    self.ShowWidget('idStamp2', True)
                    tools.PlaySound('SND_STAMP')
        elif signal == 'show_text':
            self.ShowWidget(self.values_controls[self.index], True)
            self.index += 1
        elif signal == 'salute':
            #_x = tools.Rand(100, 924)
            #_y = tools.Rand(100, 668)
            _x = 512
            _y = 0
            _pos = {'x':_x, 'y':_y}
            #self.ShowEffect('salute_victory_b', _pos)
            _is_gold = self.is_level_gold()
            if _is_gold:
                self.ShowEffect('statistics_coins', _pos)   # эксперт
            else:
                self.ShowEffect('statistics_coins_silver', _pos)    # обычное прохождение
            tools.PlaySoundRandom(['SND_WIN_SALUTE_1', 'SND_WIN_SALUTE_2', 'SND_WIN_SALUTE_3'])
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == 'enter':
            pass
        elif type == 'exit':
            pass
        elif type == 'change':
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_dlg_command(self, tag, command):
        pass
# ============================================================
    def on_command(self, name, command, param):
        pass
# ============================================================
    def on_create(self):
        for name in self.values_controls:
            self.ShowWidget(name, False)
        DLG.PauseGame(True)
        DLG.clear_awaitinig_dialogs()
        tools.StopMusic()
        tools.PlaySound('SND_WIN')
        UStats.SaveExpertResources()    # если это не экспертное прохождение, то данные метод просто ничего не сделает
        #tools.PlaySound('SND_CHEST_UI')
        _count = len(self.values_controls)
        stats = self.GetFullStats()
        self.stats = stats
        stats.score = self.calc_score(stats)
        # определим как хорошо прошли уровень:
        completion_type = pmgr.LevelStat.COMPLETED_NO
        trace('STATS>', stats.cur_time, stats.level_time)
        _is_level_gold = self.is_level_gold()
        if _is_level_gold:  # успели, либо первый уровень - золото
            completion_type = pmgr.LevelStat.COMPLETED_GOLD
            self.ShowWidget('idOnExpertTime1', False)
            self.ShowWidget('idOnExpertTime2', False)
        else:
            completion_type = pmgr.LevelStat.COMPLETED_SILVER
            self.SetText('idMissionComplete', [('text', 'STAT_DLG_MISSION_COMPLETE_SILVER')])
        stats['completion_type'] = completion_type  # на что прошли уровень
        p_mgr = DLG.PMgr
        user_progress = p_mgr.get_cur_user_progress()
        lstat = user_progress.get_level(stats.episode_index, stats.level_index)
        _need_update_result = False
        if 'completion_type' not in lstat.values:   # если поля нет, то нужно заполнять
            _need_update_result = True
        elif lstat.values.completion_type < stats.completion_type:  # если улучшили результат по типу прохождения
            _need_update_result = True
        elif lstat.values.completion_type > stats.completion_type: # если результат хуже, то
            _need_update_result = False                            # обновлять не нужно
        elif 'score' not in lstat.values or stats.score >= lstat.values.score:# если очков стало больше
            _need_update_result = True
        if _need_update_result:         # нужно перезаписать результат
            lstat.append_values(stats)
            self.ApplyLevelStat(True)     # теперь пропишем новые данные уровня
            p_mgr.save_current_user()     # сохраним результат игрока и статистику в файлы

        # нужно обновить время, оставшееся при экспертном прохождении:
        _is_time_left = self.is_time_left()
        if _is_time_left:
            self.ShowWidget('idLeftTime', True)
            #self.ShowWidget('idLeftTimeV', True)
            stats['time_left'] = int(stats['time_left']/60)
        # нужно обновить очки за игру:
        _total_score = p_mgr.Get_user_setting('total_game_score')
        stats['score_total'] = _total_score
        #self.SetText('idGameScoreV', [('digit', _total_score)])
        for i in range(_count):
            _control = self.values_controls[i]
            _field = self.values_fields[i]
            if _field in stats:
                self.SetText( _control, [('digit', stats[_field])] )
            else:
                self.SetText( _control, [('digit', 0)] )
        self.Signals.Add('next_line', 200)
        for i in range(0,4):
            self.Signals.Add('salute', i*1000)
        part_name_id = 'PART_ONE'
        if stats.episode_index == 2: part_name_id = 'PART_TWO'
        self.SetText('idPartFirst', [('text', part_name_id)])
        self.SetText('idHeadOne', [('text','LEVEL_'+str(stats.episode_index) + '_' + str(stats.level_index))])
        DLG.SendMsg('level_complete', str(self.stats.episode_index) + '.' + str(self.stats.level_index), str(self.stats.score))
        #mbox(str(stats['time_min'])+'-'+str(stats['cur_time']))
# ============================================================
    def is_level_gold(self):
        '''Пройден ли уровень на золото'''
        if not self.stats:
            return False
        mode = DLG.PMgr.cur_user_stat.mode
        _is_gold = False
        if self.stats.cur_time <= self.stats.level_time:
            _is_gold = True
        if self.stats.episode_index == 1:
            if self.stats.level_index == 1:  # успели, либо первый уровень - золото
                _is_gold = True
        if mode == 'relax': _is_gold = True
        return _is_gold
# ============================================================
    def is_time_left(self):
        '''Уровень пройден быстрее экспертного времени (первый уровень и релакс сюда НЕ входят)'''
        if not self.stats:
            return False
        mode = DLG.PMgr.cur_user_stat.mode
        _is_time_left = False
        if self.stats.cur_time <= self.stats.level_time:
            _is_time_left = True
        if self.stats.episode_index == 1:
            if self.stats.level_index == 1:  # успели, либо первый уровень - золото
                _is_gold = False
        if mode == 'relax': _is_time_left = True
        return _is_time_left
# ============================================================
    def calc_score(self, stats):
        modes_coeffs = {'normal':1, 'easy':0.5, 'hard':2, 'relax':1}
        mode = DLG.PMgr.cur_user_stat.mode
        mode_c = modes_coeffs[mode]
        n = stats.level_index + (stats.episode_index > 1) * 5
        n_for_res = 1
        k = n - 2
        # # score_1 = n * r + n * t + 100 * n
        # # score_2 = n * r +n * t + 100*(n+k)

        # score_1 = n * r + n * t + 1000 * n
        # score_2 = n * r +n * t + 1000*(n+k)

        # ---
        result = 0
        res_list = ['expert_food', 'expert_bricks', 'expert_boards', 'expert_coins', 'expert_gold']
        _need_expert_score = False
        _need_nonexpert_res = True
        if stats.cur_time <= stats.level_time:
            _need_expert_score = True
            _need_nonexpert_res = False
        if stats.episode_index == 1 and stats.level_index == 1:
            _need_expert_score = False
            _need_nonexpert_res = True
        if mode == 'relax':
            _need_expert_score = False
            _need_nonexpert_res = True
        if _need_expert_score:
            n_for_res = n
            t = int((stats.level_time - stats.cur_time)/1000)    # секунды
            result += n * t
        # эта часть не зависит от времени:
        result += n * 1000
        if stats.episode_index > 1: # для второго эпизода
            result += 1000 * k
        # учтем ресурсы:
        for name in res_list:
            result += n_for_res * stats[name]
        return int(result * 100) # умножаем на 100 все очки и приводим к целому
# ============================================================
    def on_button(self, id):
        if id == 'idPromo':
            DLG.SendMsg('more_games')
        elif id == 'idSubsribe':
            DLG.SendMsg('subsribe')
        elif id == 'idFacebook':
            DLG.SendMsg('facebook', str(self.stats.episode_index * 10 + self.stats.level_index), str(self.stats.score))
        elif id == 'idOkBtn':
            if self.is_final:
                DLG.StopGame()                  # теперь спокойно стопорим игру
                DLG.clear_awaitinig_dialogs()
            DLG.Close_dialog(self)
            rateUsLevel = self.GetShowRateUs()
            if self.stats.episode_index == 1:
                if self.stats.level_index == rateUsLevel:
                    DLG.Open_dialog('BookMenu', 'dlg_book')
                    DLG.Open_dialog('RateUsMenu', 'dlg_rate_us')
                    return
            if self.stats.episode_index == 2:
                if self.stats.level_index == 5:
                    _params = {'episode':self.stats.episode_index,
                                'level':self.stats.level_index,
                                'is_start_comics':False}
                    DLG.Open_dialog('ComicsMenu', 'dlg_comics', _params)
                    return
            if self.is_final:
                DLG.Open_dialog('BookMenu', 'dlg_book')
        pass
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
# ============================================================
# ============================================================
# ============================================================
