# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *
# ============================================================
# ============================================================
# ============================================================
class GameTask(object):
    def __init__(self, qtdata):
        self.uid = -1
        self.is_complete = False
        self.is_started = False
        self.slot = -1      # слот задания в интерфейсе, возвращается UI.AddGameTask(...)
        self.task_image = qtdata.image
        self.task_image_frame = qtdata.frame
        self.task_template = qtdata.task_template
        self.task_text = ""
        self.game_event = ""    # событие, которое должно быть сгенерировано игрой, чтобы данное задание проверило его выполнение
        self.events_count = 0   # кол-во событий (game_event), необходимое для выполнения задания
        self.events_remain = 0  # сколько событий осталось дождаться (при 0 - задание выполнено)
        EMgr.add_event_listener(self)
# ============================================================
    def on_event(self, name, obj, extra_dict):
        '''Обработчик игровых событий'''
        pass
# ============================================================
    def on_complete(self):
        '''Вызывается при выполнении задания'''
        EMgr.remove_event_listener(self)
# ============================================================
    def set_complete(self):
        self.is_complete = True
        UI.SendMessage(self.slot, 'task_complete')
        self.on_complete()
        #UI.SendMessage(self.slot, 'set_task_text', '')
        pass
# ============================================================
    def update_count(self):
        trace('TASK:', self.task_image, self.task_template, self.task_text) # для отладки
        UI.SendMessage(self.slot, 'set_task_count', str(self.events_remain))
# ============================================================
    def force_completeness_check(self):
        pass
# ============================================================
    def on_update(self):
        pass
# ============================================================
    def __str__(self):
        extra = to_str("game_task: ", self.uid, "is_complete", self.is_complete, "is_started", self.is_started)
        return to_str("{", extra, "}", str(self))
# #######################################################
# #######################################################
# #######################################################
# #######################################################
# #######################################################
