# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *


import base_unit
import unit_worker
import unit_general
import unit_wcutter
import unit_quarry
import unit_indian_sit
import unit_questman_boat
import unit_barb

import base_building
import b_bakery
import b_boatyard
import b_bridge
import b_camp
import b_dam
import b_farm
import b_farm_field
import b_fisherman
import b_garden
import b_granitemine
import b_house
import b_ind_house
import b_mint
import b_nofog
import b_quarry
import b_sawmill
import b_shipyard
import b_silvermine
import b_smokery
import b_stonecutter
import b_totem
import b_tower
import b_warehouse
import b_woodcutter
import d_barbarian_nest
import d_boards_helper
import d_bog
import d_bonuskey
import d_bush
import d_chest
import d_dr_tree
import d_enabler
import d_enter
import d_gate
import d_geyser
import d_gold
import d_granite
import d_grave
import d_ind_altar
import d_ind_bridge
import d_ind_house_br
import d_inventory
import d_key
import d_lama
import d_letter
import d_mais
import d_none
import d_pot
import d_random_res
import d_res
import d_stalactite
import d_stone
import d_stonegate
import d_test
import d_totem_barb
import d_tree
import d_unit_res
import mgr_b
import mgr_u
import mgr_t
import mgr_q
import mgr_e
import ui

import base_diff_item
#from unit_worker import UnitWorker     # не работает, потому что encode.py требует __dict__, которого нет

units_uid = 0
buildings_uid = 0
different_uid = 0
current_level_board = None
global_episode = 0
global_level = 0
is_first_barbarian = True
# ============================================================
buildings_classes = {
    "": base_building.BaseBuilding,
    'bakery': b_bakery.BakeryBuilding,
    'boatyard': b_boatyard.BoatyardBuilding,
    'bridge': b_bridge.Bridge,
    'dam': b_dam.DamBuilding,
    'farm': b_farm.FarmBuilding,
    'farm_field': b_farm_field.FarmField,
    'fisherman': b_fisherman.FishermanBuilding,
    'garden': b_garden.GardenBuilding,
    'granitemine': b_granitemine.GranitemineBuilding,
    'house': b_house.HouseBuilding,
    'hq': b_camp.CampBuilding,
    'hq_small': b_camp.CampBuilding,
    'ind_house_w': b_ind_house.IndBuilding,
    'mint': b_mint.MintBuilding,
    'no_fog': b_nofog.Nofog,
    'quarry': b_quarry.QuarryBuilding,
    'sawmill': b_sawmill.SawmillBuilding,
    'silvermine': b_silvermine.SilvermineBuilding,
    'smokery': b_smokery.SmokeryBuilding,
    'stonecutter': b_stonecutter.StonecutterBuilding,
    'totem': b_totem.Totem,
    'totem_stone': b_totem.Totem,
    'verf': b_shipyard.ShipyardBuilding,
    'warehouse': b_warehouse.WarehouseBuilding,
    'watchtower': b_tower.TowerBuilding,
    'woodcutter': b_woodcutter.WoodcutterBuilding,
    }
units_classes = {
    #"": unit_worker.UnitWorker,
    '': base_unit.BaseUnit,
    'survived': unit_worker.UnitWorker,
    'worker': unit_worker.UnitWorker,
    'general': unit_general.UnitGeneral,
    'woodcutter': unit_wcutter.UnitWoodcutter,
    'qman': unit_quarry.UnitQuarry,
    'indian_1': unit_indian_sit.UnitIndianSit,
    'indian_2': unit_indian_sit.UnitIndianSit,
    'questman_boat': unit_questman_boat.UnitQuestmanBoat,
    'indianwarr': unit_indian_sit.UnitIndianSit,
    'barb': unit_barb.UnitBarbarian,
    }
different_classes = {
    '': base_diff_item.DiffItem,
    'boards_helper': d_boards_helper.BoardsHelper,
    'bricks_helper': d_boards_helper.BoardsHelper,
    'bog': d_bog.Bog,
    'bonuskey': d_bonuskey.BonusKey,
    'burrel': d_pot.Pot,
    'bush': d_bush.Bush,
    'chest': d_chest.Chest,
    'dr_tree': d_dr_tree.DrTree,
    'enabler': d_enabler.Enabler,
    'enter': d_enter.Enter,
    'gate': d_gate.Gate,
    'general_res': d_res.GeneralResource,
    'geyser': d_geyser.Geyser,
    'granite': d_granite.Granite,
    'grave_in': d_grave.Grave,
    'indian_bridge': d_ind_bridge.IndBridge,
    'ind_house_br': d_ind_house_br.IndHouseBreakable,
    'inventory': d_inventory.Inventory,
    'key': d_key.Key,
    'indian_lama': d_lama.Lama,
    'letter': d_letter.Letter,
    'mais': d_mais.Mais,
    'pot': d_pot.Pot,
    'gold': d_gold.Gold,
    'nest': d_barbarian_nest.Nest,
    'none': d_none.None,
    'test': d_test.Test,
    'indians_altar': d_ind_altar.IndAltar,
    'random_res': d_random_res.RandomRes,
    'stalactite': d_stalactite.Stalactite,
    'stone': d_stone.Stone,
    'stonegate': d_stonegate.StoneGate,
    'totem_barb': d_totem_barb.BarbarianTotem,
    'tree': d_tree.Tree,
    'unit_res': d_unit_res.UnitResource,
    }
managers_classes = {
    "buildings_mgr": mgr_b.BuildingsMgr,
    "units_mgr": mgr_u.UnitsMgr,
    "tasks_mgr": mgr_t.TasksMgr,
    "events_mgr": mgr_e.EventsMgr,
    "quests_mgr": mgr_q.QuestsMgr,
    }
# ============================================================
# ============================================================
class LBCore(object):
# ============================================================
    def __init__(self, episode, level, subindex = 0):
        self.episode = episode
        self.level = level
        self.subindex = subindex
        self.settings = {}
        if self.episode == 1 and self.level == 5:
        #if self.episode == 0 and self.level == 0:
            self.is_first_barbarian = True
        else:
            self.is_first_barbarian = False
        if self.episode == 1 and self.level == 1:
            UStats.AddLevelValue('main_tasks_complete', 1)  # затычка просто
# ============================================================
    def need_barbarian_arrow(self):
        if self.episode == 1 and self.level == 5 and self.is_first_barbarian:
        #if self.episode == 0 and self.level == 0 and self.is_first_barbarian:
            self.is_first_barbarian = False
            return True
        else:
            return False
# ============================================================
    def is_main_level(self):
        return (self.subindex == 0)
# ============================================================
    def get_setting(self, name):
        if name in self.settings:
            return self.settings[name]
        else:
            return 0
# ============================================================
    def is_help_needed(self, index):
        '''Нужно ли показывать экран хэлпа'''
        trace('LB.is_help_needed:', index)
        if self.episode == 1:
            if self.level == 1:
                help_shown = LBoard.GetUserSetting('help_shown')
                trace('     LB.is_help_needed:', help_shown)
                if index == help_shown + 1:
                    return True
            elif self.level == 2:
                if index >= 5:
                    help_shown = LBoard.GetUserSetting('help_shown')
                    if index == help_shown + 1:
                        return True
        return False
# ============================================================
# ============================================================
def reset():
    del mgr_b.BuildingsMgr.all_buildings[:]
    del mgr_b.BuildingsMgr.all_units[:]
    del mgr_b.BuildingsMgr.all_items[:]
    mgr_b.BuildingsMgr.FBC = mgr_b.BuildingsContainer()
    mgr_b.BuildingsMgr.uids_dict = {}

    # Inventory TEST:
    # item = {'name':'test', 'image':'ITEM_POT2', 'frame':str(0)}
    # UStats.Inventory.AddQuestItem(item)
# ============================================================
def create_unit(type, subtype, cdata):
    #trace(Globals.GString("LOCALE_NAME"))
    unit = None
    if type == 'unit' and subtype in units_classes:
        classname = units_classes[subtype]
        unit = classname(cdata)
        #UMgr.all_units.append(unit)
        #if template_name in ['tunit1', 'survived1']:
        if subtype == 'worker':
            UMgr.all_units.append(unit)
            UMgr._total_workers.append(unit)
    if unit != None:
        _buildings_mgr = mgr_b.BuildingsMgr
        _buildings_mgr.all_units.append(unit)
        _buildings_mgr.uids_dict[unit.get('uid')] = unit
        global units_uid
        unit.uid = units_uid
        units_uid = units_uid + 1
        if unit.get('subtype') == 'general':   # if general was created
            UMgr.general = unit         # store him
    return unit
# ============================================================
def create_building(type, subtype, cdata):
    result = None
    if type == 'building':
        if subtype in buildings_classes:
            classname = buildings_classes[subtype]
        else:
            classname = buildings_classes[""]
        result = classname(cdata)
        global buildings_uid
        result.uid = buildings_uid
        trace('New Building UID:', buildings_uid)
        buildings_uid = buildings_uid + 1
        _buildings_mgr = mgr_b.BuildingsMgr
        _buildings_mgr.all_buildings.append(result)
        _buildings_mgr.FBC.append(result)
        _buildings_mgr.uids_dict[result.get('uid')] = result
    return result
# ============================================================
def create_item(type, subtype, cdata):
    result = None
    if subtype in different_classes:
        classname = different_classes[subtype]
    else:
        classname = different_classes['']
    result = classname(cdata)
    _buildings_mgr = mgr_b.BuildingsMgr
    _buildings_mgr.all_items.append(result)
    _buildings_mgr.uids_dict[result.get('uid')] = result
    #mgr_b.BuildingsMgr.all_items.append(result)
    #mgr_b.BuildingsMgr.uids_dict[result.get('uid')] = result
    global different_uid
    result.uid = different_uid
    different_uid = different_uid + 1
    return result
# ============================================================
def create_mgr(type, cdata):
    return managers_classes[type](cdata)
# ============================================================
def create_ui(cdata):
    return ui.GameUI(cdata)
# ============================================================
def hide_ui():
    UI.hide()   #@! remove frect link
# ============================================================
def show_ui():
    UI.show()   #@! remove frect link
# ============================================================
def Set_level_board(level_board):
    global current_level_board
    current_level_board = level_board
# ============================================================
def On_init_complete():
    '''Вызывается после того, как уровень загружен и всё инициализировано'''
    trace("On_init_complete >>")
    _main_buildings = BMgr.get_buildings('__main__')
    trace(_main_buildings)
    trace(UMgr.general)
    if UMgr.general:
        Camera.SetTo(UMgr.general)
    elif _main_buildings:
        Camera.SetTo(_main_buildings[0])
    trace("<< On_init_complete")
# ============================================================
def Time_is_up():
    episode = global_episode
    level = global_level
    if episode > 1 or level > 1:
        UStats.AddLevelValue('time_is_up', 1)   # запомним, что экспертное время вышло
        tools.PlaySound('SND_NO_EXPERT')
        EMgr.send_event('time_is_up', None)   # чтобы событие могли услышать другие объекты, для которых это важно
        dlg.Open('TimeOffMenu', 'dlg_timeoff', {'single_mode':'1'})
    pass
# ============================================================
def GetS(settings, setting_name):
    if setting_name in settings:
        return settings[setting_name]
    else:
        return ''
# ============================================================
def Hardcode_on_start(episode, level_number, settings):
    global global_episode
    global global_level
    trace('Hardcode_on_start >>')
    global_episode = episode
    global_level = level_number

    LBoard.episode = episode
    LBoard.level = level_number

    LBoard.Core = LBCore(episode, level_number, 0)
    LBoard.Core.settings = settings

    if episode == 1 and level_number == 1:
        # нужно заставить генерала подойти к индейцу
        _g = UMgr.general
        _indian = BMgr.get_item('1345')     # индеец, к которому нужно подойти на старте уровня
        if _g and _indian:
            _indian.SendMsg('click', 'default')

    if episode != 1 or level_number != 1:  # кроме первого пока везде показываем кнопку, на минилокациях ее не будет, если там нечего строить
        BMgr.ShowBuildButton(False)     # False - стрелку над кнопкой не показывать, True - показывать

    trace('<< Hardcode_on_start')
# ============================================================
def Hardcode_on_start_sublevel(episode, level_number, subindex, settings):
    global current_level_board
    global global_episode
    global global_level

    trace('Hardcode_on_start_sublevel >>')

    global_episode = episode
    global_level = level_number

    LBoard.Core = LBCore(episode, level_number, subindex)

    _level_type = GetS(settings, 'level_type')
    if _level_type == 'underlevel':
        BMgr.HideBuildButton()
        BMgr.HideMapButton()
        if current_level_board:
            LBoard.DisableClouds(current_level_board)
    elif _level_type == 'sublevel':
        BMgr.ShowBuildButton(False)
        BMgr.HideMapButton()
    trace('<< Hardcode_on_start_sublevel')
# ============================================================
def Cheat_level_complete():
    '''Чит для завершения уровня'''
    tools.PlaySound('SND_ARTEFACT_ITEM')
    dlg.Open('KeyMenu', 'dlg_key', {'single_mode':'1', 'is_final':'1',
                                            'episode':str(LBoard.episode),
                                            'level':str(LBoard.level)})
    EMgr.send_event('game_win', None)   # игру можно завершать
# ============================================================
# ============================================================