# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import game_helper
import tut_helper

# #######################################################
# - может таски разделять на те, что запущены и те, что нет?
# #######################################################

class TasksMgr(TasksMgr_class):
    '''Обрабатывает таски действий юнитов, а также содержит таски игры, ту их часть, что не в UI'''
    #all_tasks = []
    #postpoined_tasks = []
# ============================================================
    def __init__(self, cdata):
        TasksMgr_class.__init__(self, cdata)
        self.events = []
        self.tasks = []
        self.quest_unit_in_queue = None
        self.gameHelper = game_helper.GameHelper()
        self.tutHelper = tut_helper.TutHelper()
        self.update_ticks = 0
# ============================================================
    def Get_tut_helper_data(self):
        '''Метод для передачи в C++ данных об уровне'''
        result = []
        _is_cave = self.tutHelper.is_cave()
        if not _is_cave:
            self.tutHelper.refresh_info()
            self.tutHelper.serialize(result)
        return result
# ============================================================
    def Get_ui_tips_data(self):
        '''Метод для передачи в C++ данных об уровне'''
        result = []
        _is_cave = self.tutHelper.is_cave()
        if not _is_cave:        # в пещерах нет зданий
            _buildings = BMgr.get_buildings('__generating__', '', ['map_place'])
            _k = -1
            b_dict = {}
            for b in _buildings:
                if b.is_indians:
                    continue
                _has_access = b.HasAccess()
                if _has_access:
                    _is_passable = b.IsPassable()
                    if _is_passable:
                        res = None
                        _is_res_empty = True
                        b_state = b.SM.GetState()
                        if b.status in ['broken', 'place']:
                            _need_check = False
                            if b_state in ['upgrade', 'build']:
                                res = b.GetRes('level_1', 'normal_gives_1')
                            if b.clock_shown:
                                res = b.GetRes('level_1', 'normal_gives_1')
                        elif b.status == 'normal':
                            res = b.GetRes('normal_gives_1')
                            #_is_res_empty = True
                        if res: _is_res_empty = res.Empty()
                        if not _is_res_empty:     # если ресурс не задан, то здесь делать нечего
                            val = res.GetSingleValue()
                            k = -1
                            name = b.get('stype')
                            if name in b_dict:
                                k = b_dict[name]
                            # --
                            if val < k:
                                b_dict[name] = val
                            elif k < 0:
                                b_dict[name] = val
            items_count = len(b_dict)
            result.append(items_count)  # кол-во записей
            for b_name in b_dict:
                count = b_dict[b_name]
                result.append(b_name)
                result.append(count)
        return result
# ============================================================
    def on_msg(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        if msg_type == "state_machine":
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == "signal_msg":
            self.on_signal(msg_param1)
        elif msg_type == 'global_event':
            self.on_global_event(msg_param1, msg_param2)
        elif msg_type == 'task_callback':
            self.on_task_callback(int(msg_param1), msg_param2, msg_dict)
        elif msg_type == 'quest_callback':
            self.on_quest_callback(msg_param1, msg_param2, msg_dict)
        elif msg_type == "on_create":
            self.on_create()
# ============================================================
    def on_signal(self, signal):
        if signal.startswith('th_'):
            self.tutHelper.on_signal(signal)
            return

        if signal == 'increase_territory':
            _has_territory_complete = UStats.GetLevelValue('territory_complete') > 0
            if not _has_territory_complete:
                UI.show_chest_text('CHEST_MSG_INCREASE_TERRITORY')
                self.Signals.Restart('increase_territory', 300000)
                UI.ButtonStartBlink('idChest', 3)
        elif signal == 'keep_in_mind_tasks':
            UI.show_chest_text('CHEST_MSG_KEEP_IN_MIND_TASKS')
            self.Signals.Restart('keep_in_mind_tasks', 15*60*1000)
# ============================================================
    def on_task_callback(self, task_uid, result, extra_dict):
        '''Для передачи данных из диалога в задание по UID'у задания'''
        if task_uid == -1:  # для диалога генерала
            QMgr.on_dlg_callback(result, extra_dict)
        elif task_uid == 0:
            pass        # ignore callback
        else:
            _task = self.get_task(task_uid)
            if _task != None:
                _task.on_callback(result, extra_dict)
# ============================================================
    def on_quest_callback(self, quest_name, result, extra_dict):
        '''Для передачи данных из диалога в квест по имени'''
        _q = QMgr.get_quest(quest_name)
        _q.on_dlg_callback(result, extra_dict)
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        '''Обработчик стейт-машины'''
        if type == "enter":
            return
        elif type == "exit":
            return
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_create(self):
        trace("TasksManager on_create")
        EMgr.add_event_listener(self)
        self.gameHelper.on_create()
        self.tutHelper.on_create()
        if LBoard.Core.episode > 1 or LBoard.Core.level != 1:
            self.Signals.Restart('increase_territory', 300000)
        self.Signals.Restart('keep_in_mind_tasks', 15*60*1000)
# ============================================================
    def on_global_event(self, event, param):
        self.tutHelper.on_global_event(event, param)     # чтобы передать событие в подсказки
# ============================================================
    def on_update(self, ms):                # данный метод должен вызываться из C++ каждый квант
        '''Вызывается каждый второй quant! См. BaseManager.cpp::Update'''
        self.gameHelper.on_update(ms)
        _is_main_level = LBoard.Core.is_main_level()
        self.tutHelper.on_update(ms)
        # ###
        self.update_ticks += 1
        # >>>
        if _is_main_level:  # строго только на главном! Иначе куча окон.
            if not (self.update_ticks%50):  #! каждую секунду (31)
                UI.check_main_tasks()   # обновляем их здесь, потому что UI on_update засыпает при переходе в подуровень
        # <<<
        if not (self.update_ticks%15):   #! эевенты и обработку заданий сделаем чуть реже (12)
            _events = self.events[:]    # копируем эвенты, на случай, если внутри добавляются другие
            for event in _events:     # сгенерим эвенты
                name, obj = event
                self.on_event_local(name, obj)
            for event in _events:     # освободим юнитов, которым не нашлось задания
                name, unit = event
                if name == 'free_unit':
                    _unit_is_busy = unit.is_busy()
                    if not _unit_is_busy:
                        if not unit.is_in_home:     # если задания нет и юнит еще не дома
                            unit.go_home()    # то отправим юнита домой
                    unit.switch_animation() # обновим анимацию юнита на всякий случай
            del self.events[:]
            self.start_postpoined_tasks()
        # заодно уберем отыгравшие таски:
        if not (self.update_ticks%10):   #! чуть проредим проверку (0)
            tasks_to_remove = []
            for task in self.tasks:
                if task.is_complete:
                    tasks_to_remove.append(task)
            # удалим завершенные таски:
            if tasks_to_remove:
                #mbox(to_str(self.tasks))
                for rtask in tasks_to_remove:
                    self.tasks.remove(rtask)
                #mbox(to_str(self.tasks))
        # вызываем апдейты у всех запущенных тасков:
        for task in self.tasks:
            if not task.is_complete:
                if task.is_started:
                    task.on_update(ms)
# ============================================================
    def on_rare_update(self, ms):
        pass
# ============================================================
    def start_postpoined_tasks(self):
        for task in self.tasks:
            if not task.is_event_task:
                if not task.is_started:
                    if not task.is_complete:     # если таск не запущен и не выполнен, то
                        task.try_do_action()    # пытаемся запустить
# ============================================================
    def start_next_general_task(self):
        for task in self.tasks:
            if task.type == 'walk_general':
                if not task.is_started:
                    if not task.is_complete:     # если таск не запущен и не выполнен, то
                        task.try_do_action()    # пытаемся запустить
# ============================================================
    def on_event(self, event, obj, extra={}):
        trace("TMgr.on_event recevied:", event)#, obj)
        self.gameHelper.on_event(event, extra)     # чтобы передать событие в подсказки
        self.tutHelper.on_event(event, extra)     # чтобы передать событие в подсказки
# ============================================================
    def on_event_local(self, event_name, event_obj):
        # проверить Event-Task'и, вдруг кому нужен юнит, если нет, то
        trace('TMgr.on_event_local start:', event_name)#, event_obj)
        for task in self.tasks:
            _was_not_started = task.was_not_started()
            if _was_not_started:
                if task.is_event_task:
                    _our_trigger = task.is_event_trigger(event_name)
                    if _our_trigger:
                        _is_action_ready = task.try_do_action()
                        if _is_action_ready:
                            return              # таск запустили, поэтому дальше делать нечего
        trace('TMgr.on_event_local end')
# #######################################################
    task_uid = 1
# ============================================================
    def add_task(self, task):
        '''Добавляет новую задачу, по возможности - сразу запускает ее'''
        if task.is_unique_task:
            for t in self.tasks:
                if t.is_unique_task:
                    if t.unique_id == task.unique_id:   # схожий уникальный таск есть, поэтому не добавляем
                        return
        task.uid = self.task_uid
        self.task_uid += 1
        if task.do_pre_action():        # возможен ли запуск данного таска в принципе?
            self._append_task_by_priority(task)
            if task.type != 'walk_general': # генеральские выполняем строго по приоритету
                task.try_do_action()            # сразу же пытаемся выполнить таск
            else:
                self.start_next_general_task()
            #@(Возможно стоит переделать!
            #@ Иначе в некоторых ситуациях приоритеты не будут действовать)
# ============================================================
    def cancel_task_by_uid(self, uid):
        '''Отменяет таск по UID'''
        for task in self.tasks:
            if task.uid == uid:
                self.tasks.remove(task)
                task.cancel(True)
                return
# ============================================================
    def cancel_tasks(self, task_type):
        '''Удаляет задания определенного типа из списка заданий
            Нужно для того, чтобы когда генерал подошел к индейцу -
            отключить все последующие задания'''
        UMgr.general.cancel_step_aside()   #$ чтобы никуда не отходил дважды...
        _new_tasks = []
        _cancel_tasks = []
        for task in self.tasks:
            if task.type != task_type:
                _new_tasks.append(task)
            else:
                if not task.is_started:    # запущенные НЕ отменяем!
                    _cancel_tasks.append(task)
                else:
                    _new_tasks.append(task)
        self.tasks = _new_tasks
        for _t in _cancel_tasks:
            _t.cancel(True)
# ============================================================
    def _append_task_by_priority(self, task):
        '''Добавляет задание в список заданий согласно своему приоритету'''
        #self.tasks.append(task)
        _i = len(self.tasks)
        if _i > 0:      # проверка для случая когда приоритет нового таска выше всех остальных
            _first_p = self.tasks[0].priority
            if task.priority > _first_p:
                self.tasks.insert(0, task)
                return
        while _i > 0:   # пробегаем в обратном порядке
            _i -= 1
            _p = self.tasks[_i].priority
            if task.priority <= _p: # если приоритет нового таска не больше, то
                self.tasks.insert(_i+1, task)   # то добавим наш таск после этого
                return
        self.tasks.insert(0, task)  # если дошли сюда - значит у таска высший приоритет, либо это самый первый таск
# ============================================================
    def get_task(self, uid):
        for t in self.tasks:
            if t.uid == uid:
                return t
        return None
# ============================================================
    def send_event(self, event_name, event_object):
        trace('TMgr.send_event:', event_name)#, event_object)
        self.events.append( (event_name, event_object) )
# ============================================================
    def add_quest_unit_to_queue(self, uid):
        '''Организует очередь квестовых юнитов... Для того, чтобы управлять значками над
        индейцами (еще и собирателем золота)'''
        if self.quest_unit_in_queue:
            return False
        else:
            self.quest_unit_in_queue = uid;
            EMgr.send_event( 'quest_unit_added', None, {'uid':uid} )
            return True
# ============================================================
    def remove_quest_unit_from_queue(self, uid):
        _unit_in_queue = False
        if self.quest_unit_in_queue:
            if self.quest_unit_in_queue == uid:
                _unit_in_queue = True
        if _unit_in_queue:
            self.quest_unit_in_queue = None
            EMgr.Send_event('quest_unit_removed')
            return True
        else:
            return False
# ============================================================
    def has_quest_unit_in_queue(self):
        if self.quest_unit_in_queue: return True
        else: return False
# ============================================================
    def get_quest_unit_in_queue_uid(self):
        return self.quest_unit_in_queue
# ============================================================
    def Get_debug_tasks_info(self):
        r = []
        for task in self.tasks:
            if not task.is_complete:     # если таск не запущен и не выполнен, то
                if task.is_event_task:
                    r.append(['text', 'COLOR_YELLOW'])
                if task.is_started:
                    r.append(['debug', '+'])
                r.append(['debug', task.type])
                r.append('space')
                r.append(['digit', task.uid])
                r.append('space')
                r.append(['debug', task.extra])
                r.append('newline')
                r.append(['text', 'COLOR_WHITE'])
        return r
# ============================================================
# ============================================================
