# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

class UnitsMgr(UnitsMgr_class):
    all_units = []
    _free_units = []     # все юниты, которые только освободились и бегут в домики
    _total_workers = []
# ============================================================
    def __init__(self, cdata):
        UnitsMgr_class.__init__(self, cdata)
        self.general = None
        self.update_ticks = 0
        self._units_building_workers = 0     # кол-во юнитов, которые работают в том или
                                    # ином здании, т.е. заняты почти навсегда
                                    # (исключение - лесоруб, но его сюда тоже добавляем)
# ============================================================
    def on_msg(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        if msg_type == "on_create":
            self.on_create()
        elif msg_type == "state_machine":
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == "signal_msg":
            self.on_signal(msg_param1)
        elif msg_type == 'global_event':
            self.on_global_event(msg_param1, msg_param2)
# ============================================================
    def on_global_event(self, event, param):
        if event == 'talk_quest_started':    #$@ код для активации разговорчивых юнитов писать здесь
            for unit in BMgr.all_units:
                unit.try_show_talk_sign()   # покажем значки разговора
        elif event == 'talk_quest_completed':
            for unit in BMgr.all_units:
                unit.try_show_talk_sign(False)  # спрячем значки разговора
        elif event in ['give_obj_quest_started', 'give_obj_quest_completed']:
            for unit in BMgr.all_units:
                unit.switch_animation()     # обновим анимации всех юнитов (включая значки)
# ============================================================
    def on_signal(self, signal):
        pass
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            return
        elif type == "exit":
            return
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
# ============================================================
    def on_state_change(self, cur_state, next_state):
        #trace(cur_state.append(next_state))
        return
# ============================================================
    def on_create(self):
        trace("UnitsManager on_create")
# ============================================================
    def on_update(self, ms):                # данный метод должен вызываться из C++ каждый квант
        #self.update_ticks += 1
        pass
# ============================================================
    def on_rare_update(self, ms):
        for unit in BMgr.all_units:
            _has_access = unit.HasAccess()
            if _has_access:
                if unit.is_indian:
                    if not unit.unit_is_talking:
                        unit.switch_animation()     # обновим знаки и прочее
# #######################################################
# #######################################################
# #######################################################

    #@ ! посмотреть где вызывается и добавить unit_subtype
    #def send_unit_to(self, target, cell_shift_name = ""):
    #    nearest_unit = self.get_free_nearest_unit(target, cell_shift_name)
    #    if nearest_unit == None:
    #        return None
    #    nearest_unit.run_to_target(target, None, cell_shift_name)
    #    return nearest_unit

    def get_free_nearest_unit(self, target, cell_shift_name = '', unit_subtype = '', _from_units = None):
        if cell_shift_name == None:
            return None, None
        if not _from_units:
            units = self.get_free_units(unit_subtype)
        else:
            units = _from_units
        if not units:
            return None, None
        else:
            pathes = []
            # найдем ближайшего юнита:
            #for unit in units:
            #    map_path = self.CalcPathTo(unit.get("cell"), target, cell_shift_name, True) # считаем путь от каждого пользовательского юнита
            #    if map_path.is_path_exist:
            #        pathes.append( (map_path,unit) )
            #if not pathes:
            #    trace("get_free_nearest_unit: no pathes")
            #    return None
            # need to find nearest unit:
            # in-place compare function:
            #def cmp_fnc(a, b):
            #    path1, d = a
            #    path2, d = b
            #    return path1.cost - path2.cost
            #path, nearest_unit = min_ex(cmp_fnc, pathes)
            #return nearest_unit
            cells = []
            for unit in units:
                _u_cell = unit.get('cell')
                cells.append(_u_cell)
            result = UMgr.FindNearestCell(target, cell_shift_name, cells)
            if result:  # найдем юнита по ячейке
                for unit in units:
                    _u_cell = unit.get('cell')
                    _cells_same = self.__cells_equal(_u_cell, result)
                    if _cells_same:
                        return unit, None
            return None, None
# ============================================================
    def __cells_equal(self, c1, c2):
        if c1.col == c2.col:
            if c1.row == c2.row:
                return True
        return False
# ============================================================
    def create_unit(self, template_name, variant_name = ""):
        '''Создает нового юнита'''
        new_unit = self.CreateUnit(template_name, variant_name) # C++ вызывает затем level_board.create_unit(...)
        # перенесено в level_board:
        #self.all_units.append(new_unit)
        #if template_name in ['tunit1', 'survived1']:
        #    self._total_workers.append(new_unit)
        return new_unit
# ============================================================
    def add_free_unit(self, unit):
        '''Добавляет юнита к списку свободных, генерирует соответствующее событие для TasksMgr'''
        _uname = unit.get('name')
        if _uname == 'survived1': # чтобы выжившие подменялись на обычных работников
            _new_unit = self.create_unit('tunit1')
            _cell = unit.get('cell')
            _new_unit.set('cell', _cell)
            self.all_units.remove(unit)
            #BMgr.all_units.remove(unit) # - следующая строка это проделает
            BMgr.RemoveItemFromMap(unit)
            unit = _new_unit
            unit.CheckIsInFog(True)     # проверка на то, что юнит не в тумане и прочее
            UMgr.add_free_unit(unit)     # новые юниты свободны: у нас свободное общество!
            return unit  # потому что предыдущий вызов рекурсивен и добавит юнита
        if unit in self._free_units:
            trace('Unit is already free', unit.get('name'), unit.get('uid'))
            return unit
        if unit not in self._free_units:
            self._free_units.append(unit)
            TMgr.send_event('free_unit', unit)
        return unit # на случай, если произошла подмена выжившего работником
# ============================================================
    def remove_free_unit(self, unit):
        '''Убирает юнита из списка свободных'''
        if unit not in self._free_units:
            trace('UMgr: unit is not free!', unit.get('name'), unit.get('uid'))
            return False
        self._free_units.remove(unit)
        return True
# ============================================================
    def add_building_worker(self):
        self._units_building_workers += 1
# ============================================================
    def remove_building_worker(self):
        self._units_building_workers -= 1
# ============================================================
    def get_free_units_count(self):
        return len(self._free_units)
# ============================================================
    def get_free_real_units_count(self):
        #_total_workers = len(self._total_workers)
        _total_workers = 0
        for worker in self._total_workers:
            if not worker.home_building:
                if not worker.is_survived:
                    _total_workers += 1
            elif not worker.home_building.is_deactivated:
                _total_workers += 1
        _free_count = _total_workers - self._units_building_workers
        return _free_count
# ============================================================
    def get_units_at_home_count(self):
        '''Кол-во юнитов в зданиях'''
        _count = 0
        _buildings = BMgr.get_buildings_simple('__home__')
        for b in _buildings:
            _is_smallhouse = b.get('stype') == 'house'
            if _is_smallhouse:
                if b.is_deactivated:
                    continue
            _count += b.Get_units_count()
        return _count
# ============================================================
    def Get_total_workers_count(self):
        #_total_workers = len(self._total_workers)
        _total_workers = 0
        for worker in self._total_workers:
            if not worker.home_building:
                if not worker.is_survived:
                    _total_workers += 1
            elif not worker.home_building.is_deactivated:
                _total_workers += 1
        #_free_count = _total_workers - self._units_building_workers
        return _total_workers
# ============================================================
    def is_free_real_units_enough(self):
        _free_count = self.get_free_real_units_count()
        _min_count = Globals.GInt('MIN_UNITS_COUNT')
        return (_free_count > _min_count)
# ============================================================
    worker_types = {'simple':0, 'builder':0, 'dt_wcutter':0, 'soldier':0, 'quarryman':0, 'breaker':0}
    def get_free_units(self, unit_subtype = '', only_at_home = False):
        '''Возвращает список свободных юнитов, список уникален по позициям юнитов, т.е. юниты, находящиеся
            в одной точке входят в список единожды'''
        units = []
        cells = []
        if not self._free_units:
            trace("get_free_units: no free units")
            return units
        # выбираем юнитов, уникальных в разных ячейках:
        for unit in self._free_units:
            # если подходит любой юнит (что редкость), либо юнит в доме - он любой, либо юнит подходящего типа
            _add = False
            if not unit_subtype:
                _add = True
            elif unit.is_in_home:
                if unit.current_subtype in self.worker_types:
                    _add = True
            if not only_at_home:
                if not _add:
                    if unit_subtype == unit.current_subtype:
                        _add = True
            if _add:
                unit_cell = unit.get('cell')    # позиция юнита
                cell_present = False
                for c in cells:     # ищем - нет ли уже такой ячейки:
                    _is_cells_equal = self.__cells_equal( unit_cell, c )
                    if _is_cells_equal:
                        cell_present = True
                        break
                if not cell_present:
                    if unit.home_building:
                        if not unit.home_building.is_deactivated:    # проверяем только в активированных зданиях
                            cells.append(unit_cell)
                            units.append(unit)
        return units
# ============================================================
    def get_free_units_at_home(self, unit_subtype):
        '''Возвращает список свободных юнитов, список уникален по позициям юнитов, т.е. юниты, находящиеся
            в одной точке входят в список единожды'''
        units = []
        cells = []
        if not self._free_units:
            trace("get_free_units: no free units")
            return units
        # выбираем юнитов, уникальных в разных ячейках:
        for unit in self._free_units:
            if unit.is_in_home:
                if unit.current_subtype == unit_subtype:
                    #_is_store = unit.home_building.is_store()
                    #if _is_store:   # только из хранилища можно нести ресурсы
                    # по факту - мы вызываем юнита только из главного здания...
                        unit_cell = unit.get("cell")    # позиция юнита
                        cell_present = False
                        for c in cells:     # ищем - нет ли уже такой ячейки:
                            _is_cells_equal = self.__cells_equal( unit_cell, c )
                            if _is_cells_equal:
                                cell_present = True
                                break
                        if not cell_present:
                            cells.append(unit_cell)
                            units.append(unit)
        return units
# ============================================================
    def get_units_for_faces(self):
        '''Возвращает список юнитов, лица которых нужно показать'''
        result = []
        for unit in BMgr.all_units:         # выборка из всех юнитов
            _has_access = unit.HasAccess()
            if _has_access:                 # все, к которым есть доступ
                _has_sign = unit.has_sign()
                if _has_sign:
                    _is_active = unit.is_active()
                    #_is_enough_params = unit.is_enough_params()
                    if _is_active:
                        if unit.is_shown:              # только активные юниты которым достаточно доп. параметров (обычно это камни)
                            _is_talking = unit.GetAttrBool('is_talking')
                            _is_ready_to_talk = False
                            if unit.is_survived:
                                if _is_talking:
                                    _is_ready_to_talk = True
                            if _is_ready_to_talk:        # если это выживший юнит
                                result.append(unit)
                            elif unit.unique_name:                      # если это юнит, с которым нужно поговорить
                                result.append(unit)
                            elif unit.quest:                            # если это юнит с квестом (индеец обычно)
                                result.append(unit)
        return result
# ============================================================
    def has_indians_with_quests(self):
        '''Возвращает список индейцев, к которым можно подойти за квестом'''
        result = []
        for unit in BMgr.all_units:         # выборка из всех юнитов
            _has_access = unit.HasAccess()
            if _has_access:                 # все, к которым есть доступ
                if unit.is_indian:
                    if unit.quest:          # с квестом
                        _has_sign = unit.has_sign()
                        if _has_sign:
                            _is_active = unit.is_active()
                            #_is_enough_params = unit.is_enough_params()
                            if _is_active:
                                if unit.is_shown:              # только активные юниты которым достаточно доп. параметров (обычно это камни)
                                    _is_enough_params = unit.is_enough_params()
                                    if _is_enough_params:
                                        _is_start_possible = unit.quest.is_start_possible()
                                        if _is_start_possible:
                                            result.append(unit)
                                    #_is_talking = unit.GetAttrBool('is_talking')
                                    #if unit.is_survived and _is_talking:        # если это выживший юнит
                                    #    result.append(unit)
                                    #elif unit.unique_name:                      # если это юнит, с которым нужно поговорить
                                    #    result.append(unit)
                                    #elif unit.quest:                            # если это юнит с квестом (индеец обычно)
                                    #    result.append(unit)
        return result
# ============================================================
    def has_ready_units(self):
        '''Возвращает список юнитов, к которым можно подойти (за исключением говорящих индейцев)'''
        indians = []
        survived = []
        precomplete = []
        for unit in BMgr.all_units:         # выборка из всех юнитов
            _has_access = unit.HasAccess()
            if _has_access:            # все, к которым есть доступ
                if unit.is_indian:
                    if unit.quest:          # с квестом
                        _has_sign = unit.has_sign()
                        if _has_sign:
                            _is_active = unit.is_active()
                            #_is_enough_params = unit.is_enough_params()
                            if _is_active:
                                if unit.is_shown:              # только активные юниты которым достаточно доп. параметров (обычно это камни)
                                    _is_enough_params = unit.is_enough_params()
                                    _is_precomplete = unit.quest.is_quest_precomplete()
                                    if _is_precomplete:
                                        precomplete.append(unit)
                                    elif _is_enough_params:
                                        _is_start_possible = unit.quest.is_start_possible()
                                        if _is_start_possible:
                                            indians.append(unit)
                else:       # not indian
                    _is_talking = unit.GetAttrBool('is_talking')
                    if unit.is_survived:
                        if _is_talking:
                            _has_sign = unit.has_sign()
                            if _has_sign:
                                _is_active = unit.is_active()
                                #_is_enough_params = unit.is_enough_params()
                                if _is_active:
                                    if unit.is_shown:              # только активные юниты которым достаточно доп. параметров (обычно это камни)
                                        survived.append(unit)
        return (indians, precomplete, survived)
# ============================================================
    def Is_units_count_critical(self):
        _is_units_enough = self.is_free_real_units_enough()
        if not _is_units_enough:
            return True
        else:
            return False
# ============================================================
    def Get_total_units_text(self):
        '''DEPRECATED
        Возвращает текст для индикатора кол-ва свободных юнитов'''
        result = []
        _free_count = self.get_free_real_units_count()
        _workers_at_home_count = self.get_units_at_home_count()
        if not self.is_free_real_units_enough():
            result.append( ("text", 'COLOR_RED') )
        result.append( ('digit', _workers_at_home_count) )
        result.append( ("text", 'UNITS_COUNT_DELIMETER') )
        result.append( ('digit', _free_count) )
        # ##result.append( ('digit', len(self._total_workers)) )
        return result
# ============================================================
    def Get_free_real_units_count(self):    # просто чтобы видно было, что извне вызывается
        return self.get_free_real_units_count()
# ============================================================