# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import task_classes

# #######################################################
# #######################################################
class QuarryManTask(task_classes.Task):
    def __init__(self, stone, unit, path):
        type = "walk_qman"
        task_classes.Task.__init__(self, type)
        self.priority = 1000
        self.stone = stone
        self.unit = unit
        self.path = path
        self.is_event_task = False
        #self.is_event_task = True   # EVENT ONLY
        #self._event_triggers.append("free_unit") # триггеры, которые отрабатывает данный таск
# ============================================================
    def do_pre_action(self):
        if self.stone:
            self.stone.task = self
            self.stone.set_check(True)
        return True
# ============================================================
    def try_do_action(self):
        if not self.unit or not self.stone:
            mbox(str(self.unit) + str(self.stone))   #@test
            return False
        #_action_cell_name = self.stone.get_action_cell_name()       # у дерева всеравно ее нет
        u = self.unit
        # u.show()    # нужно показать юнита перед началом действия
        _unit_unused = u.parent_home._internal_free_units.pop(0) #если заняли юнита делом, то удалим его из списка свободных
        u.start_work()      # 'run_by_path' его не вызывает, в отличии от 'run_to_target'
        u.run_by_path(self.path, self.stone)     # бежим к объекту по указанному пути
        u.task = self
        u.task_type = self.type
        self.is_started = True
        _subtask = self.stone.get_subtask(self, u)
        self.subtask = _subtask
        trace("QuarryManTask: started", u.get('name'))
        return True
# ============================================================
    def _complete_task(self):
        self.is_complete = True
        trace("task 'QuarryManTask' completed")
        self.unit.stop_walk()
        self.unit.task = None
        self.unit.task_type = ""
        _unit = self.unit
        self.unit = None
        #>>>> UMgr.add_free_unit(_unit)
        _unit.parent_home._internal_free_units.append(_unit)
        self.stone.task = None
        self.stone = None
        #_unit.go_home() # отправим юнита домой
# ============================================================
    def target_reached(self, sender):
        '''Вызывается юнитом-строителем при достижении цели'''
        if self.subtask != None:
            self.subtask.start_action(self.stone)
        else:
            self.complete_task()
# ============================================================
    def on_update(self, ms):
        #if self.is_subtask_started:
        pass
# ============================================================
    def cancel(self, force=False):
        '''Нужно вызывать при отмене задания'''
        self.is_complete = True
        trace("task 'WalkW' canceled")
        if self.stone:
            self.stone.set_check(False)
            self.stone.task = None
        self.stone = None
        # нельзя напрямую отменять действие генерала, если сейчас данный таск не обрабатывается!
        if self.is_started:
            self.unit.stop_walk()
            self.unit.task = None
            self.unit.task_type = ""
            _unit = self.unit
            self.unit = None
            _unit.parent_home._internal_free_units.append(_unit)
# ============================================================
    def on_callback(self, result, extra_dict):
        if self.subtask != None:
            self.subtask.on_callback(result, extra_dict)
# ============================================================
# #######################################################
# #######################################################
# #######################################################
