# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import task_classes

# #######################################################
# #######################################################
class WalkGeneralTask(task_classes.Task):
    def __init__(self, item):
        task_classes.Task.__init__(self, 'walk_general')
        self.priority = 1000
        self.is_event_task = True   # EVENT ONLY
        self._event_triggers.append('free_general') # триггеры, которые отрабатывает данный таск
        self.general = None
        self.item = item
        self.subtask = None
# ============================================================
    def do_pre_action(self):
        #if self.type == "take_res":    #если строительство здания
        self.item.set_check(True)
        return True
# ============================================================
    def try_do_action(self):
        trace('trying WalkGeneralTask. uid:', self.uid)
        self.general = UMgr.general
        if self.general and not self.general.task:       # is free
            cell_name = self.item.get_action_cell_name()
            if cell_name == None: return False
            self.general.stop_walk()
            success = self.general.run_to_target(self.item, None, cell_name)
            if success:    # отправим генерала к горшку
                _subtask = self.item.get_subtask(self, self.general)
                self.subtask = _subtask
                self.general.task = self
                self.general.task_type = self.type
                self.is_started = True
                trace('task "WalkG" started')
                _is_different_type = self.item.IsTypeOf('different')
                if _is_different_type: self.item.had_action = True
                return True
        else:
            if self.general:
                trace('General already has a task:', self.general.task)
                trace('Task UID:', self.uid, 'Prev task:', self.general.task.uid)
        return False
# ============================================================
    def _complete_task(self):
        self.is_complete = True
        trace("task 'WalkG' completed. uid:", self.uid)
        if self.general:
            self.general.task = None
            self.general.task_type = ''
            self.general.stop_walk()
            self.general = None
        if self.item:
            #@! опасный код, объекта может уже не быть, а ссылка останется!!!
            self.item.set_check(False)
            self.item.task = None   # ##
        self.item = None
        TMgr.send_event("free_general", None)
        trace('>> dbg end <<<')
# ============================================================
    def target_reached(self, sender):
        '''Вызывается юнитом-исполнителем при достижении цели'''
        if self.subtask != None:
            if not self.is_action_started:
                if not self.subtask.start_action(self.item):
                    self.complete_task()        # на случай, если квест нельзя запустить
                else:
                    self.subtask.actor.current_action_animation = self.subtask.actor_action_animation
                    self.is_action_started = True
                    if self.item:
                        self.item.on_before_action_started()    # перед тем, как начнется действие над объектом
                    self.on_subtask_started()
        else:
            self.complete_task()
        #self.general.stop_walk()
        #self.general.action_hit_item(self.item)     # генерал сам доломает горшок, BUG: возможен, если отмена произойдет в момент ломания
# ============================================================
    #@override
    def on_subtask_started(self):
        if self.item:  self.item.set_check(False)
        pass
# ============================================================
    def on_update(self, ms):
        pass
# ============================================================
    def cancel(self, force=False):
        '''Вызывается, если игрок отменил задание'''
        # делать нужно на основе _complete_task!!!
        self.is_complete = True
        trace("task 'WalkG' canceled. uid:", self.uid)
        # нельзя напрямую отменять действие генерала, если сейчас данный таск не обрабатывается!
        if self.is_started:
            self.general.stop_walk()
            self.general.cancel_hits()
            self.general.task = None
            self.general.task_type = ''
            self.general = None
        if self.item:
            self.item.set_check(False)
            if not force:
                tools.PlaySound('SND_CLICK_TASK_CANCEL')
            self.item.task = None
            self.item = None
        if self.is_started:
            TMgr.send_event("free_general", None)
# ============================================================
    def on_callback(self, result, extra_dict):
        if self.subtask != None:
            self.subtask.on_callback(result, extra_dict)
# ============================================================

