# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import toolz

# ============================================================
class PanelItem(object):
    def __init__(self):
        self.is_hidden = True
        self.is_hiding = False
        self.is_task_complete = False

    def started_hiding(self):
        self.is_hiding = True
# ============================================================
# ============================================================
class TipsZone(object):
    def __init__(self, _x, _y, _w, _h, _tips_x, _tips_y, _text, widget_id):
        self.x = _x
        self.y = _y
        self.w = _w
        self.h = _h
        self.tips_x = _tips_x
        self.tips_y = _tips_y
        self.text = _text
        self.widget_id = widget_id
# ============================================================
# ============================================================
class GameUI(UI_class):
    res_names = ['res_food', 'res_boards', 'res_bricks', 'res_coins']
    binded_res_names = ['food', 'boards', 'bricks', 'coins']
    tasks_names = ['task_1', 'task_2', 'task_3']
    units_names = ['unit_'+str(i) for i in range(1,5+1)]
    move_zones_order = ['workers_count', 'workers', 'food', 'boards', 'bricks',
                        'coins', 'gold1', 'gold2', 'chest', 'letter',
                        'general_params', 'general', 'shop', 'help',
                        'time', 'competitor', 'inventory',
                        'task_3', 'task_2', 'task_1',
                        'unit_1','unit_2','unit_3','unit_4','unit_5']
    move_zones = {
                    'workers': TipsZone(0, 0, 86, 86, 45, 100, '', 'workers_bar'),
                    'workers_count': TipsZone(27, 53, 35, 35, 45, 135, '', 'workers_bar'),
                    'food': TipsZone(274, 0, 112, 36, 332, 55, '', 'res_food'),
                    'boards': TipsZone(395, 0, 112, 36, 453, 55, '', 'res_boards'),
                    'bricks': TipsZone(516, 0, 112, 36, 574, 55, '', 'res_bricks'),
                    'coins': TipsZone(637, 0, 112, 36, 695, 55, '', 'res_coins'),
                    'gold1': TipsZone(832, 0, 192, 37, 898, 55, 'GTIPS_GOLD', 'gold_bar'),
                    'gold2': TipsZone(938, 32, 86, 56, 895, 55, 'GTIPS_GOLD', 'gold_bar'),
                    'chest': TipsZone(759, 0, 66, 40, 791, 55, 'GTIPS_CHEST', 'chest_bar'),
                    'letter': TipsZone(201, 0, 66, 40, 231, 55, 'GTIPS_LETTER', 'news_bar'),
                    'general_params': TipsZone(135, 662, 166, 106, 221, 649, 'GTIPS_GENERAL_PARAMS', 'general_bar'),
                    'general': TipsZone(0, 614, 137, 154, 62, 600, 'GTIPS_GENERAL', 'general_bar'),
                    'shop': TipsZone(303, 670, 42, 40, 324, 660, 'GTIPS_SHOP', 'general_bar'),
                    'help': TipsZone(352, 670, 42, 40, 373, 660, 'GTIPS_HELP', 'general_bar'),
                    'time': TipsZone(86, 0, 108, 35, 132, 55, 'GTIPS_TIME', 'time_bar'),
                    'competitor': TipsZone(0, 0, 512, 294, 0, 0, '', 'competitor_slide'),
                    'inventory': TipsZone(466, 673, 95, 95, 500, 660, 'GTIPS_INVENTORY', 'inventory'),
                    'task_3': TipsZone(873, 656, 122, 112, 936, 650, '', 'task_3'),
                    'task_2': TipsZone(744, 656, 122, 112, 807, 650, '', 'task_2'),
                    'task_1': TipsZone(615, 656, 122, 112, 678, 650, '', 'task_1'),
                    'unit_1': TipsZone(967, 96, 57, 60, 925, 126, '', 'unit_1'),
                    'unit_2': TipsZone(967, 164, 57, 60, 925, 194, '', 'unit_2'),
                    'unit_3': TipsZone(967, 232, 57, 60, 925, 262, '', 'unit_3'),
                    'unit_4': TipsZone(967, 300, 57, 60, 925, 330, '', 'unit_4'),
                    'unit_5': TipsZone(967, 368, 57, 60, 925, 398, '', 'unit_5'),
                    }
    max_progress = {'0_0': 5,
                    '1_1': 9,
                    '1_2': 14,
                    '1_3': 19,
                    '1_4': 20,
                    '1_5': 23,
                    '2_1': 19,
                    '2_2': 20,
                    '2_3': 19,
                    '2_4': 20,
                    '2_5': 27,
                    '2_6': 15,
                    }
# ============================================================
    def __init__(self, cdata):
        UI_class.__init__(self, cdata)
        self.tasks_shown = [None, None, None]
        self.tasks_empty = [True, True, True]
        self.units = [None, None, None, None, None] # ссылки на самих юнитов (чьи лица отображены)
        self.unit_uids = ['', '', '', '', '']
        self.units_texts = ['', '', '', '', '']
        self.tasks_tips_text = ['', '', '']
        self.widgets = {}
        self.ticks = 0
        self.last_zone = ''
        self.tips_text = []
        self.tips_x, self.tips_y = (0,0)
        self.tips_green = True
        self.buildings_res_counts = {}
        self.faces_noclick_time = 0     # сколько времени игрок не кликал по юнитам
        self.general_texts = []     # буфер туториальных текстов для отображения
        self.general_text_id_shown = ''    # text_id который сейчас на экране
        self.workers_texts = []
        self.workers_text_id_shown = ''
        self.chest_texts = []
        self.chest_text_id_shown = ''
        self.general_tip_shown = False
        self.workers_tip_shown = False
        self.chest_tip_shown = False
        self.units_names_units = {}     # здесь хранятся связки units_names и самих юнитов
        self.prev_time_info = {'time':0, 'level_time':0, 'norm_left_time':1.0}
        self.has_waiting_indian = False     # есть ли индеец, который готов дать квест
        self.has_waiting_survived = False     # есть ли выжившие, который готовы поговорить
        self.survived_task_complete = False
        self.main_tasks_complete = False
        self.territory_complete = False
        self.main_tasks_and_terr_complete = False
        self.has_waiting_precomplete = False
        self.on_create_complete = False
# ============================================================
    def on_msg(self, msg_type, msg_param1='', msg_param2='', msg_dict={}):
        if msg_type == 'on_zone':
            self.on_zone(msg_param1)
        elif msg_type == 'global_event':
            self.on_global_event(msg_param1, msg_param2)
        elif msg_type == "state_machine":
            self.on_state_machine(msg_param1, msg_param2, msg_dict)
        elif msg_type == "signal_msg":
            self.on_signal(msg_param1)
        elif msg_type == 'on_cloud_hidden':
            self.on_cloud_hidden(msg_param1)
        elif msg_type == "on_button":
            self.on_button(msg_param1)
        elif msg_type == "on_dlg_closed":
            self.on_dlg_closed(msg_param1)
        elif msg_type == "on_create":
            self.on_create()
        elif msg_type == 'escape_pressed':
            dlg.Open('GameMenu', 'dlg_gamemenu', {'single_mode':'1'})
        #elif msg_type == 'tasks_refresh':
            #self.add_game_tasks(False)
# ============================================================
    was_tutorial_events = {}
    def on_global_event(self, event_id, param):
        dirH = self.screenHeight - 768
        if event_id == 'task_info_change':
            self.refresh_tasks_info()
        #elif event_id == 'barbarian_attack':
        #    tools.PlaySound('SND_BARBARIAN_APPEAR')
        #    self.workers_texts = [] # обрубаем все сообщения
        #    self.HideTopText()
        #    self.show_top_text('BARBARIAN_ATTACK', param, True)
        elif event_id == 'unit_clicked':
            self.faces_noclick_time = 0
        elif event_id == 'all_tasks_complete':
            self.Signals.Restart('all_tasks_complete_signal', 600)
            #self.show_tut_text('CHEST_MSG_ALL_TASKS_COMPLETE')
        elif event_id in ['task_added', 'tasks_refresh']:
            self.add_game_tasks(event_id == 'task_added')
        # --------
        episode, level, sub = self.GetLevelIndex()
        if event_id == 'tutorial_msg':
            pass
            #if param == 'hack1':
            #    if episode == 1 and level == 1 and sub == 0:
            #        self.show_tut_text('TUTORIAL_4_C')
            #    return
        if episode == 1 and level == 1 and sub == 0:
        #if episode == 0 and level == 0 and sub == 0:
            if event_id+param not in self.was_tutorial_events:    # защита от повторных сообщений
                self.was_tutorial_events[event_id+param] = 0
                if event_id == 'first_slide_inventory':
                    self.show_help_text('LEVEL_TUT_INVENTORY', 496, 567 + dirH, 0)
                elif event_id == 'first_slide':
                    if param in ['task_1', 'task_2', 'task_3']:
                        #LBoard.AddXmlOverEffect('arrow_down', {'x':935, 'y':622})
                        #self.show_tut_text('LEVEL_TUT_FIRST_TASK')
                        self.show_help_text('LEVEL_TUT_FIRST_TASK', 645, 567 + dirH, 1)
                elif event_id == 'first_slide_letter':
                    self.show_help_text('LEVEL_TUT_LETTER', 216, 28, 2)
                elif event_id == 'first_slide_task':
                    pass
                elif event_id == 'general_params':
                    self.show_help_text('LEVEL_TUT_GENERAL_PARAMS', 205, 567 + dirH, 0)
                    self.Signals.Add('SHOW_chest_help', 8000)
                elif event_id == 'first_slide_food':
                    self.show_tut_text('LEVEL_TUT_RES_FOOD')
                elif event_id == 'first_slide_boards':
                    self.show_tut_text('LEVEL_TUT_RES_BOARDS')
                elif event_id == 'first_slide_bricks':
                    self.show_tut_text('LEVEL_TUT_RES_BRICKS')
                elif event_id == 'first_slide_coins':
                    self.show_tut_text('LEVEL_TUT_RES_COINS')
                elif event_id == 'show_build_button':
                    self.show_help_text('LEVEL_TUT_SHOP', 306, 567 + dirH, 0)
        elif episode == 1 and level == 2 and sub == 0:
            if event_id not in self.was_tutorial_events:
                self.was_tutorial_events[event_id] = 0
                if event_id == 'first_slide_gold':
                    self.show_help_text('LEVEL_TUT_GOLD', 601, 28, 3)
                    _mode = LBoard.GetUserInfo('game_mode')
                    if _mode != 'relax':
                        self.Signals.Add('SHOW_timebar_help', 8000)
                #elif event_id == 'first_slide_time':
                #    self.show_tut_text('LEVEL_TUT_TIME')
# ============================================================
    def on_signal(self, signal):
        if signal == 'show_tips':
            if self.tips_text:
                self.ShowTips(self.tips_text, self.tips_x, self.tips_y, self.tips_green)
            self.Signals.Restart('show_tips', 300)
        elif signal == 'show_competitor':
            self.ShowCompetitorSlide(True)
            self.tips_text = []
            self.ShowTips([], 0, 0) # типсы убираем
        elif signal == 'general_cloud_signal':
            self.show_next_tip('general_cloud')
        elif signal == 'workers_cloud_signal':
            self.show_next_tip('workers_cloud')
        elif signal == 'chest_cloud_signal':
            self.show_next_tip('chest_cloud')
        #elif signal in ['tut_task_1', 'tut_task_2', 'tut_task_3']:
        #    for _s in ['tut_task_1', 'tut_task_2', 'tut_task_3']:
        #        self.Signals.Cancel(_s) # сбросим все сигналы
        #    self.show_tut_text('TUT_HELP_05')
        elif signal == 'show_start_dlg':
            self.show_start_dlg()
        elif signal == 'remind_about_indians':
            self.show_tut_text('TUT_HELP_04')
            self.Signals.Restart('remind_about_indians', 60000)
        elif signal == 'remind_about_survived':
            self.show_chest_text('CHEST_MSG_SURVIVED_FOUND')
            self.Signals.Restart('remind_about_survived', 30000)
        elif signal == 'remind_about_precomplete':
            self.show_tut_text('TUT_HELP_05')
            self.Signals.Restart('remind_about_precomplete', 60000)
        elif signal == 'SHOW_timebar_help':
            self.show_help_text('LEVEL_TUT_TIME', 115, 28, 2)
            self.Signals.Restart('show_competitor_help', 4000)
        elif signal == 'show_competitor_help':
            self.ShowCompetitorSlide(True)
            self.ShowTips([], 0, 0) # типсы убираем
            #@! как-то нужно панельку на 5 секунд... И чтобы она не уехала...
            self.Signals.Restart( 'hide_competitor_help', 5000 )    # через 5 секунд спрячем
        elif signal == 'hide_competitor_help':
            self.ShowCompetitorSlide(False)
        elif signal == 'SHOW_chest_help':
            self.show_help_text('LEVEL_TUT_CHEST', 500, 28, 3)
        elif signal == 'all_tasks_complete_signal':
            self.show_tut_text('CHEST_MSG_ALL_TASKS_COMPLETE')
# ============================================================
    def on_state_machine(self, type, state_name, additional):
        if type == "enter":
            pass
        elif type == "exit":
            pass
        elif type == "change":
            self.on_state_change(additional.prev_state, additional.next_state)
        pass
# ============================================================
    def on_state_change(self, cur_state, next_state):
        pass
# ============================================================
    def on_create(self):
        self.screenHeight = self.GetHeight(0)
        EMgr.add_event_listener(self)
        self.create_widgets()
        settings = BMgr.GetLevelSettings()
        self.Signals.Restart('show_tips', 300)
        if settings:
            if 'level_type' in settings:
                if settings.level_type == 'underlevel':
                    self.ShowWidget('idUnitsCountText', False)
        episode, level, subindex = self.GetLocationInfo()
        if episode == 1 and level == 1:
            if not LBoard.GetUserSetting('help_button_clicked'):
                self.StartBlinkingHelp()
        for key in self.move_zones_order:
            if self.move_zones[key].y > 500:
                self.move_zones[key].y = self.move_zones[key].y + self.screenHeight - 768
                self.move_zones[key].tips_y = self.move_zones[key].tips_y + self.screenHeight - 768
            mz = self.move_zones[key]
            self.AddMoveZone(key, mz.x, mz.y, mz.w, mz.h)
        self.on_create_complete = True
        #if LBoard.Core.episode > 1 or LBoard.Core.level != 1:
        #if LBoard.Core.subindex == 0:   # на подгружаемых не выводим
        #    self.Signals.Add('show_start_dlg', 20)
# ============================================================
    def show_start_dlg(self):
        if not LBoard: return
        if 'Core' not in LBoard: return  # это хак, работает для подуровней - им всеравно диалог показывать не нужно
        if LBoard.Core.subindex == 0:   # на подгружаемых не выводим
            if self.on_create_complete:             # уже все инициализировали?
                dlg.Open('StartMenu', 'dlg_start')  # тогда покажем стартовый диалог
            else:
                self.Signals.Add('show_start_dlg', 20)  # подождем еще немного
# ============================================================
    def on_cloud_hidden(self, cloud_id):
        if cloud_id == 'general_cloud':
            self.general_tip_shown = False
            self.Signals.Restart('general_cloud_signal', 1000)
        elif cloud_id == 'workers_cloud':
            self.workers_tip_shown = False
            self.Signals.Restart('workers_cloud_signal', 1000)
        elif cloud_id == 'chest_cloud':
            self.chest_tip_shown = False
            self.Signals.Restart('chest_cloud_signal', 1000)
# ============================================================
    def show_next_tip(self, cloud_id):
        '''Показывает следующий типс, если таковой имеется и его можно показать'''
        if cloud_id == 'general_cloud':
            if not self.general_tip_shown:
                if self.general_texts:
                    _info = self.general_texts.pop(0)
                    self.show_tut_text_raw(_info.text, _info.uid, _info.is_important, _info.extra)
        elif cloud_id == 'workers_cloud':
            if not self.workers_tip_shown:
                if self.workers_texts:
                    _info = self.workers_texts.pop(0)
                    self.show_top_text_raw(_info.text, _info.uid, _info.is_important)
        elif cloud_id == 'chest_cloud':
            if not self.chest_tip_shown:
                if self.chest_texts:
                    _info = self.chest_texts.pop(0)
                    self.show_chest_text_raw(_info.text, _info.uid, _info.is_important)
# ============================================================
    def on_zone(self, zone_name):
        prev_zone = self.last_zone
        self.last_zone = zone_name
        if not zone_name:
            if prev_zone != zone_name:
                #self.Signals.Cancel('show_tips')
                self.tips_text = []
                self.Signals.Cancel('show_competitor')
                self.ShowCompetitorSlide(False)
                self.ShowTips([], 0, 0)
        elif zone_name in self.move_zones:
            episode, level, sub = self.GetLevelIndex()
            if episode == 1:
                if level == 2:
                    if zone_name == 'competitor':
                        self.Signals.Cancel( 'hide_competitor_help' )
            mz = self.move_zones[zone_name]
            _is_hidden = self.IsTotalHidden(mz.widget_id)
            if _is_hidden:
                #self.Signals.Cancel('show_tips')
                self.tips_text = []
                self.Signals.Cancel('show_competitor')
                self.ShowTips([], 0, 0)
                return
            _is_workers_cloud_shown = self.IsWorkersCloudShown()
            if _is_workers_cloud_shown:
                if zone_name in ['workers', 'workers_count', 'competitor']:
                    self.tips_text = []
                    self.ShowTips([], 0, 0)
                    self.Signals.Cancel('show_competitor')
                    self.ShowCompetitorSlide(False)
                    return
            _is_general_cloud_shown = self.IsGeneralCloudShown()
            if _is_general_cloud_shown:
                if zone_name in ['shop', 'general', 'general_params', 'help']:
                    #self.Signals.Cancel('show_tips')
                    self.tips_text = []
                    self.ShowTips([], 0, 0)
                    return
            if zone_name == 'shop': # затычка для магазина
                _is_shop_visible = self.IsWidgetVisible('idBuildings')
                if not _is_shop_visible:
                    #self.Signals.Cancel('show_tips')
                    self.tips_text = []
                    self.ShowTips([], 0, 0)
                    return
            self.tips_text, self.tips_green = self.get_tips_text(zone_name, mz)
            self.tips_x, self.tips_y = (mz.tips_x, mz.tips_y)
            if zone_name == 'time':
                _has = self.Signals.Has('show_competitor')
                if not _has:
                    self.Signals.Restart('show_competitor', 20)
            else:
                self.Signals.Cancel('show_competitor')
                #self.ShowCompetitorSlide(True)
            if prev_zone == zone_name:
                if zone_name != 'competitor':
                    return  # чтобы не накосячить с панелью соревнований
            self.ShowTips([], 0, 0) # убрать старый типс
            #self.ShowTips(text, mz.tips_x, mz.tips_y)
# ============================================================
    def get_tips_text(self, zone_name, zone):
        tips_is_green = True
        result = []
        _text_len = len(zone.text)
        if _text_len > 0:
            result.append(['text', 'COLOR_HEADER'])
            result.append(['text', zone.text])
        else:
            if zone_name == 'task_1':
                result = self.tasks_tips_text[0]
            elif zone_name == 'task_2':
                result = self.tasks_tips_text[1]
            elif zone_name == 'task_3':
                result = self.tasks_tips_text[2]
            elif zone_name in self.units_names:
                index = 0
                for u in self.units_names:
                    if u == zone_name:      # zone_name и units_names должны совпадать!
                        result = self.units_texts[index]
                        _unit = self.units[index]
                        if _unit:
                            _under_text_list, _is_green = _unit.get_ui_subtext()
                            _under_text = '#newline#' + tools.ListToStr(_under_text_list)
                            result = result + _under_text
                            tips_is_green = _is_green
                    index += 1
            elif zone_name in ['food','boards','bricks','coins']:
                result = self.gen_tips_res_text(zone_name)
            elif zone_name == 'workers':
                settings = BMgr.GetLevelSettings()
                if 'level_type' in settings:
                    if settings.level_type == 'underlevel':
                        result.append(['text', 'COLOR_HEADER'])
                        result.append(['text', 'NO_WORKERS_INFO'])
                        return result, tips_is_green
                _is_critical = UMgr.Is_units_count_critical()
                _available_count = UMgr.get_free_real_units_count()
                if not _is_critical:
                    _free_count = UMgr.get_units_at_home_count()
                    result.append(['text', 'COLOR_HEADER'])
                    result.append(['text', 'WORKERS_FREE'])
                    result.append('space')
                    result.append(['digit', _free_count])
                    result.append('space')
                    result.append(['text', 'WORKERS_FREE_FROM'])
                    result.append('space')
                    result.append(['digit', _available_count])
                    result.extend(['newline','newline'])
                    result.append(['text', 'WORKERS_TEXT_1'])
                else:
                    tips_is_green = False
                    result.append(['text', 'COLOR_RED2'])
                    if _available_count > 1:
                        result.append(['text', 'WORKERS_TEXT_2'])
                    else:
                        result.append(['text', 'WORKERS_TEXT_3'])
            elif zone_name == 'workers_count':
                settings = BMgr.GetLevelSettings()
                if 'level_type' in settings:
                    if settings.level_type == 'underlevel':
                        result.append(['text', 'COLOR_HEADER'])
                        result.append(['text', 'NO_WORKERS_INFO'])
                        return result, tips_is_green
                _is_critical = UMgr.Is_units_count_critical()
                _text = 'WORKERS_COUNT_TEXT_1'
                if not _is_critical:
                    result.append(['text', 'COLOR_HEADER'])
                else:
                    tips_is_green = False
                    result.append(['text', 'COLOR_RED2'])
                    _available_count = UMgr.get_free_real_units_count()
                    _text = ('WORKERS_COUNT_TEXT_2','WORKERS_COUNT_TEXT_3')[_available_count <= 1]
                result.append(['text', _text ])
        return result, tips_is_green
# ============================================================
    res_images = {'food':'IMG_I_TIP_FOOD',
                'boards':'IMG_I_TIP_BOARDS',
                'bricks':'IMG_I_TIP_BRICKS',
                'coins':'IMG_I_TIP_COINS',
                '_wood':'IMG_I_TIP_WOOD',
                '_fish':'IMG_I_TIP_FISH',
                '_flour':'IMG_I_TIP_BAG',
                '_ore':'IMG_I_TIP_ORE',
                '_stone':'IMG_I_TIP_STONE',
                '_granite':'IMG_I_TIP_STONE',
                }
# ============================================================
    def gen_tips_res_text(self, res_name):
        '''Генерирует типс для ресурса'''
        result = []
        _res = UStats.GetCurRes()
        _img_res = self.res_images[res_name]
        _count = 0
        result.append( ('text', 'COLOR_LINES') )

        _has_res = False
        if res_name == 'food':
            _has_res = self.get_res_imgcount(_res, res_name, '_fish', 'smokery', result)
            _has_res2 = self.get_res_imgcount(_res, res_name, '_flour', 'bakery', result, True)#, _has_res)
            if _has_res2: _has_res = _has_res2
        elif res_name == 'boards':
            _has_res = self.get_res_imgcount(_res, res_name, '_wood', 'sawmill', result)
        elif res_name == 'bricks':
            _has_res = self.get_res_imgcount(_res, res_name, '_granite', 'stonecutter', result)
        elif res_name == 'coins':
            _has_res = self.get_res_imgcount(_res, res_name, '_ore', 'mint', result)
        #if not _has_res:
        #    return []
        return result
# ============================================================
    def get_res_imgcount(self, _res, main_res_name, res_name, stype, result, need_newline = False):
        '''Генерирует картинку и кол-во ресурса'''
        _count = _res.Get(res_name)
        #if _count:
        if need_newline:
            result.append('newline')
        result.append( ('image', self.res_images[res_name]) )
        result.append( ('digit', _count) )
        _gen_count = -1
        if stype in self.buildings_res_counts:
            _gen_count = _count * self.buildings_res_counts[stype]
            if _gen_count:
                result.append( ('image', 'IMG_I_TIP_ARROW') )
                result.append( ('text', 'PLUS') )
                result.append( ('digit', _gen_count) )
                result.append( ('image', self.res_images[main_res_name]) )
        return (_count > 0)
# ============================================================
    def _get_building_resgen_count(self, bname):
        '''Возвращает коэффициент для указанного типа зданий'''
        if bname in self.buildings_res_counts:
            return self.buildings_res_counts[bname]
        else:
            return -1
# ============================================================
    def Get_tip_position(self, cur_pos, tip_size):
        '''Возвращает координаты типса от левого-верхнего угла картинки типса'''
        return toolz.Tools.get_ui_tip_position(cur_pos, tip_size, self.screenHeight)
# ============================================================
    def on_event(self, event, obj, extra={}):
        if event == 'build_repair_complete':
            # 80. в первом уровне после ремонта домика убрать появление облака хэлпа к портрету работников.
            pass
            #episode, level, sub = self.GetLevelIndex()
            #if episode == 1 and level == 1:
            #    if 'workers_help' not in self.was_tutorial_events:
            #        if extra.uid == '2643':     # ремонт домика с юнитами на первом уровне
            #            self.was_tutorial_events['workers_help'] = 0    # чтобы повторно не показывать
            #            self.show_help_text('LEVEL_TUT_WORKERS', 27, 78, 2)
        elif event == 'coins_taken':
            episode, level, sub = self.GetLevelIndex()
            if episode == 1 and level == 1:
                if 'resource_help' not in self.was_tutorial_events:
                    if extra.uid in ['3537', '3538', '3539']:     # взяли монеты на уровне
                        self.was_tutorial_events['resource_help'] = 0    # чтобы повторно не показывать
                        self.show_help_text('LEVEL_TUT_RES_COINS', 358, 28, 4)
        elif event == 'barbarian_attack_started':
            tools.PlaySound('SND_BARBARIAN_APPEAR')
            self.workers_texts = [] # обрубаем все сообщения
            self.HideTopText()
            self.show_top_text('BARBARIAN_ATTACK', obj.get('uid'), True)
        pass
# ============================================================
    def create_widgets(self):
        '''Инициализация виджетов интерфейса'''
        slide_time = 200

        i = 0
        for id in self.tasks_names:
            w = self.GetWidget(id)
            height = self.GetHeight(w)
            self.InitSlide(w, 611 + i*129, self.screenHeight-height, "up", slide_time, "quart", "out")
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        i = 0
        for id in self.units_names:
            w = self.GetWidget(id)
            width = self.GetWidth(w)
            self.InitSlide(w, 1024 - width, 92 + i*68, 'left', 200, 'quart', 'out')
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        w = self.GetWidget("gold_bar")
        self.BindResName(w, 'gold')
        self.widgets["gold_bar"] = w
        width = self.GetWidth(w)
        self.InitSlide(w, 1024-width, 0, "down", slide_time, "quart", "out")
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget("workers_bar")
        self.widgets["workers_bar"] = w
        self.InitSlide(w, 0, 0, "down", slide_time, "quart", "out")
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget("time_bar")
        self.widgets["time_bar"] = w
        self.InitSlide(w, 44, 0, "down", slide_time, "quart", "out")

        w = self.GetWidget("news_bar")
        self.widgets["news_bar"] = w
        self.InitSlide(w, 196, 0, "down", slide_time, "quart", "out")
        #self.Slide(w, slide_time, "quart", "out")   #@ ###

        w = self.GetWidget("chest_bar")
        self.widgets["chest_bar"] = w
        self.InitSlide(w, 753, 0, "down", slide_time, "quart", "out")
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget("inventory")
        self.widgets["inventory"] = w
        height = self.GetHeight(w)
        self.InitSlide(w, 446, self.screenHeight-height, "up", slide_time, "quart", "out")
        #self.Slide(w, slide_time, "quart", "out")

        w = self.GetWidget("general_bar")
        self.widgets["general_bar"] = w
        height = self.GetHeight(w)
        self.InitSlide(w, 0, self.screenHeight-height, "up", slide_time, "quart", "out")
        #self.Slide(w, slide_time, "quart", "out")

        i = 0
        for id in self.res_names:
            w = self.GetWidget(id)
            self.BindResName(w, self.binded_res_names[i])
            self.InitSlide(w, 269 + i*121, 0, "down", slide_time, "quart", "out")
            #self.Slide(w, slide_time, "quart", "out")
            i += 1
            self.widgets[id] = w

        w = self.GetWidget('competitor_slide')
        self.widgets['competitor_slide'] = w
        self.InitSlide(w, 0, 0, 'down', slide_time, 'quart', 'out')


        self.show()

# ============================================================
    def hide(self):
        for w in self.widgets:
            self.SetSlideHidden(w, True)
            self.SlideBack(w, 0)
# ============================================================
    def show(self):
        for w in self.widgets:
            self.SetSlideHidden(w, False)
            self.Slide(w, 200)
# ============================================================
    helpdlg_names = {   0: 'HelpMenu',
                        1: 'HelpMenu_1',
                        2: 'HelpMenu_2',
                        3: 'HelpMenu_3',
                        4: 'HelpMenu_4',
                        5: 'HelpMenu_5',
                        6: 'HelpMenu_6' }
    def on_button(self, id):
        if id == 'idMenu':
            self.HideTips()
            dlg.Open('GameMenu', 'dlg_gamemenu', {'single_mode':'1'})
        elif id == 'idBuildings':
            for id in self.res_names:
                w = self.GetWidget(id)
                self.EnableResUpdates(w, False)
            w = self.GetWidget('gold_bar')
            self.EnableResUpdates(w, False)
            self.HideTips()
            dlg.Open('BuildingsMenu', 'dlg_buildings')
        elif id == 'idLetter':
            self.HideTips()
            dlg.Open('LetterMenu', 'dlg_letter')
        elif id == 'idHelp':
            self.open_help()
        elif id == 'idChest':
            self.HideTips()
            dlg.Open('ChestMenu', 'dlg_chest')
# ============================================================
    def open_help(self, increment_help = False):
        if increment_help:
            help_shown = LBoard.GetUserSetting('help_shown')
            LBoard.SetUserSetting('help_shown', help_shown+1)
        self.HideTips()
        _help_shown = LBoard.GetUserSetting('help_shown')
        _name = self.helpdlg_names[_help_shown] # чтобы запустить "последний" доступный экран хелпа
        trace('UI.open_help:', _name, _help_shown)
        dlg.Open(_name, 'dlg_help', {'single_mode':'1'})
# ============================================================
    def on_dlg_closed(self, name):
        if name == "dlg_buildings":
            for id in self.res_names:
                w = self.GetWidget(id)
                self.EnableResUpdates(w, True)
            w = self.GetWidget('gold_bar')
            self.EnableResUpdates(w, True)
# ============================================================
    def on_update(self, ms):
        #self.hide_completed_tasks()
        self.remove_completed_tasks()
        self.ticks += 1
        if not (self.ticks%50): #! раз в секунду (25)
            self.update_progress()
        if not (self.ticks%26): # раз в полсекунды
            self.update_unit_faces()
        if not (self.ticks%27): # примерно раз в полсекунды
            self._get_other_levels_info()
        #if not (self.ticks%21):
        #    self.check_main_tasks()
        self.faces_noclick_time += ms
        if self.faces_noclick_time >= 10000:
            self.blink_faces()
            self.faces_noclick_time = 0
# ============================================================
    def _get_other_levels_info(self):
        '''Обновляем данные для типсов базовых ресурсов'''
        self.buildings_res_counts = {}  # почистим
        _is_cur_loc_active = TMgr.IsCurrentLocationActive()
        if _is_cur_loc_active:
            count_infos = TMgr.GetOtherLevelsGameInfo('ui_tips')
            for _l in count_infos:
                if _l:
                    items_count = _l.pop(0)
                    for i in range(items_count):
                        name = _l.pop(0)
                        count = _l.pop(0)
                        if count > 0:
                            if name in self.buildings_res_counts:
                                k = self.buildings_res_counts[name]
                                if k < 0:
                                    self.buildings_res_counts[name] = count
                                elif count < k:
                                    self.buildings_res_counts[name] = count
                            else:
                                self.buildings_res_counts[name] = count
# ============================================================
    def calc_cur_progress(self):
        episode, level, sub = self.GetLevelIndex()
        _val = UStats.GetLevelValue('progress')
        _index = str(episode) + '_' + str(level)
        _max = self.max_progress[_index]
        _progress = _val / _max
        if _progress < 0: _progress = 0
        if _progress > 1: _progress = 1
        return _progress
# ============================================================
    def check_main_tasks(self):
        '''Проверяет - не выполнились ли основные задачи игры'''
        _is_main_level = LBoard.Core.is_main_level()
        if _is_main_level:
            # проверка выполнения задания на открытие территории:
            if not self.territory_complete:
                _is_territory_complete = UStats.GetLevelValue('territory_complete') > 0
                if not _is_territory_complete:  # территории проверяем независимо от подуровня
                    _territory = UStats.GetLevelValue('territory')
                    _need_territory = int(LBoard.Core.get_setting('total_territory'))
                    if _need_territory > 0:
                        if _territory >= _need_territory:
                            self.territory_complete = True
                            UStats.AddLevelValue('territory_complete', 1)
                            tools.PlaySound('SND_TARGET_COMPLETE')
                            dlg.Open('ChestMenu', 'dlg_chest', {'task':'TERRITORY', 'single_mode':'1'})
            if not self.main_tasks_complete:
                #_progress = UStats.GetLevelValue('progress')
                _survived = UStats.GetLevelValue('survived')
                _gold_complete = UStats.GetLevelValue('gold_ship_complete')
                _need_gold = int(LBoard.Core.get_setting('need_gold'))
                if _need_gold == 0: _gold_complete = True   # если золота не нужно - значит задания нет
                # получить список заданий и кол-ва
                #_index = str(LBoard.Core.episode) + '_' + str(LBoard.Core.level)
                #_max = self.max_progress[_index]
                #_need_progress = _max
                _need_survived = int(LBoard.Core.get_setting('total_survived'))
                if _need_survived > 0:
                    if not self.survived_task_complete:
                        if _need_survived <= _survived:
                            #UStats.AddLevelValue('survived_complete', 1)
                            tools.PlaySound('SND_TARGET_COMPLETE')
                            self.survived_task_complete = True
                            dlg.Open('ChestMenu', 'dlg_chest', {'task':'SURVIVED', 'single_mode':'1'})
                # проверять что уже выполнилось, если все выполнилось - выставить флаг
                #if _need_progress <= _progress:
                if _gold_complete:
                    if _need_survived <= _survived:
                        #if self.territory_complete:
                            UStats.AddLevelValue('main_tasks_complete', 1)  # все главные задачи выполнены
                            self.main_tasks_complete = True
            if not self.main_tasks_and_terr_complete:
                if self.main_tasks_complete:
                    if self.territory_complete:
                        self.main_tasks_and_terr_complete = True
                        #self.Signals.Restart('all_tasks_complete', 500)
                        EMgr.SendGlobalMsg('all_tasks_complete', '')
# ============================================================
    def update_progress(self):
        '''Показ типсов, указывающих на прошедшее игровое время'''
        episode, level, sub = self.GetLevelIndex()
        _progress = self.calc_cur_progress()
        self.SetOurProgress(_progress)
        _mode = LBoard.GetUserInfo('game_mode')
        if _mode != 'relax':
            if episode > 1 or level > 1:    # на первом уровне нет времени
                _time_info = UStats.GetTimeInfo()
                _time = _time_info.norm_left_time
                _prev_time = self.prev_time_info.norm_left_time
                if _prev_time > 0.75 and _time <= 0.75: # четверть времени прошла
                    _has_25 = UStats.GetLevelValue('time_25_gone')
                    if _has_25 == 0:
                        self.show_top_text('TIME_25_GONE')
                        UStats.AddLevelValue('time_25_gone', 1)
                elif _prev_time > 0.5 and _time <= 0.5:
                    _has_50 = UStats.GetLevelValue('time_50_gone')
                    if _has_50 == 0:
                        self.show_top_text('TIME_50_GONE')
                        UStats.AddLevelValue('time_50_gone', 1)
                #_diff = (_time_info.level_time - _time_info.time)
                #_prev_diff = (self.prev_time_info.level_time - self.prev_time_info.time)
                if _time_info.time <= 30000 and self.prev_time_info.time > 30000:
                    _has_30s = UStats.GetLevelValue('time_30s')
                    if _has_30s == 0:
                        self.show_top_text('TIME_30S_LEFT')
                        UStats.AddLevelValue('time_30s', 1)
                self.prev_time_info = _time_info
# ============================================================
    def blink_faces(self):
        for face_widget_name in self.units_names:
            if face_widget_name in self.units_names_units:
                _unit = self.units_names_units[face_widget_name]
                text, is_green = _unit.get_ui_subtext() # по другому никак...
                if is_green:
                    self.BlinkFace(face_widget_name, 3)
            #pass
# ============================================================
    def hide_all_unit_faces(self):
        '''прячем все аватарки юнитов'''
        index = 0
        self.Signals.Cancel('remind_about_indians')
        self.has_waiting_indian = False
        self.Signals.Cancel('remind_about_survived')
        self.has_waiting_survived = False
        self.Signals.Cancel('remind_about_precomplete')
        self.has_waiting_precomplete = False
        for uid in self.unit_uids:
            self.unit_uids[index] = ''
            self.units[index] = None
            self.units_texts[index] = ''
            u_name = self.units_names[index]
            if u_name in self.units_names_units:
                del self.units_names_units[u_name]
            w = self.widgets[u_name]
            self.SetUnitInfo(w, '', 0, '', [])
            self.SlideBack(w)
            index += 1
# ============================================================
    def update_waiting_units(self):
        '''Обработка напоминаний об ожидающих юнитах'''
        #_has_indians = UMgr.has_indians_with_quests()
        _indians, _precomplete, _survived = UMgr.has_ready_units()
        _has_indians = len(_indians) > 0
        _has_precomplete = len(_precomplete) > 0
        _has_survived = len(_survived) > 0
        if not self.has_waiting_indian:     # если до этого ожидающих индейцев не было
            if _has_indians:
                self.has_waiting_indian = True
                self.Signals.Restart('remind_about_indians', 60000) # напомним через 60 сек
        elif not _has_indians:        # если индейцы "закончились"
                self.Signals.Cancel('remind_about_indians')
                self.has_waiting_indian = False
        if not self.has_waiting_survived:     # если до этого ожидающих выживших не было
            if _has_survived:
                self.has_waiting_survived = True
                self.Signals.Restart('remind_about_survived', 30000) # напомним через 20 сек
        elif not _has_survived:        # если индейцы "закончились"
                self.Signals.Cancel('remind_about_survived')
                self.has_waiting_survived = False
        if not self.has_waiting_precomplete:     # если до этого ожидающих выживших не было
            if _has_precomplete:
                self.has_waiting_precomplete = True
                self.Signals.Restart('remind_about_precomplete', 60000) # напомним через 10 сек
        elif not _has_precomplete:        # если индейцы "закончились"
                self.Signals.Cancel('remind_about_precomplete')
                self.has_waiting_precomplete = False
# ============================================================
    def update_unit_faces(self):
        # - get units faces list
        _units = UMgr.get_units_for_faces()
        self.update_waiting_units()
        _new_uids = [unit.get('uid') for unit in _units]
        #trace('new_uids:', _new_uids)
        #trace('old_uids:', self.unit_uids)
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if _has_barbarians:     # если есть дикарь на поле, то прячем все аватарки
            self.hide_all_unit_faces()
            return
        # сначала проверяем uid, которые "ушли" и убираем их:
        index = 0
        for uid in self.unit_uids:
            if uid and uid not in _new_uids:    # если данного UID нет в новом списке отображаемых юнитов
                self.unit_uids[index] = ''
                self.units[index] = None
                self.units_texts[index] = ''
                u_name = self.units_names[index]
                if u_name in self.units_names_units:
                    del self.units_names_units[u_name]
                w = self.widgets[u_name]
                self.SetUnitInfo(w, '', 0, '', [])  # то убираем панельку данного юнита
                #self.SlideBackFast(w)
                self.SlideBack(w)
            index += 1
        if not _units:
            return
        for unit in _units:
            if unit.is_busy():      # если хотя бы один из юнитов занят, т.е. на него был клик, то не показываем никаких аватарок
                self.hide_all_unit_faces()
                return
        # теперь заполним свободные панельки юнитами:
        _has_free = self.has_free_units_slots() # остались ли свободные слоты под аватарки
        if _has_free:
            for unit in _units:                 # для каждого юнита,
                uid = unit.get('uid')
                if uid not in self.unit_uids:   # который еще не отображен
                    #trace('>> UNIT:', uid, unit.get('name'))
                    _free_index = self.get_free_unit_slot_index()
                    if _free_index >= 0:        # для которого есть слот
                        self.unit_uids[_free_index] = uid   # запомним UID
                        self.units[_free_index] = unit
                        w_name = self.units_names[_free_index]
                        # передадим инфу по юниту:
                        _unit_frame = unit.GetAttrInt('slide_avatar_frame')
                        tips_text = []
                        tips_text.append( ('text', 'COLOR_HEADER') )
                        tips_text.append( ('text', unit.GetAttrStr('item_name')) )
                        self.units_texts[_free_index] = tools.ListToStr(tips_text)
                        self.SetUnitInfo(w_name, 'IMG_I_AVATARS_R', _unit_frame, uid, tips_text )
                        self.units_names_units[w_name] = unit
                        self.Slide(w_name, 500)
                    else:
                        return  # больше свободных панелек нет
# ============================================================
    def has_free_units_slots(self):
        return (self.get_free_unit_slot_index() >= 0)
# ============================================================
    def get_free_unit_slot_index(self):
        if '' in self.unit_uids:
            index = -1
            for w_id in self.units_names:
                index += 1
                if self.IsTotalHidden(w_id):
                    return index
        return -1
# ============================================================
# ============================================================
    def get_free_slot_index(self):
        '''Возвращает индекс первого незантяого слота для заданий'''
        for i in range(len(self.tasks_shown)-1, -1, -1):
            if not self.tasks_shown[i]:
                return i
        return -1
# ============================================================
    def hide_task(self, slot):
        '''Прячет указанное задание'''
        panel = self.tasks_shown[slot]
        panel.started_hiding()
        w = self.widgets[ self.tasks_names[slot] ]
        self.SlideBack(w, 1000)
# ============================================================
    def hide_completed_tasks(self):
        '''Прячет выполненные задания'''
        i = 0
        for panel in self.tasks_shown:
            if panel:
                if panel.is_task_complete and not panel.is_hiding:
                    panel.started_hiding()
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SlideBack(w, 1000)
            i += 1
        pass
# ============================================================
    def remove_completed_tasks(self):
        '''Освободождает слоты от уже скрытых заданий'''
        i = 0
        for panel in self.tasks_shown:
            if panel:
                if panel.is_hiding:
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SetSlideHasContent(w, False)
                    if self.IsTotalHidden(w):
                        self.tasks_shown[i] = None  # прячем таск
                        self.FreeTaskSlot(i)
                        self.tasks_empty[i] = True
            i += 1
        pass
# ============================================================
# ============================================================
# ============================================================
    def show_tut_text(self, text_id, is_important = False, uid = '', extra={}):
        '''Показывает туториальный текст'''
        if text_id:
            #if self.general_texts:  # проверим, если последнее сообщение совпадает
            #    _last = self.general_texts[-1]
            #    if _last.text == text_id: return    # то ничего не добавляем
            for item in self.general_texts:
                if item.text == text_id:    # одинаковые сообщения не добавляем
                    return
            if self.general_tip_shown and self.general_text_id_shown == text_id:    # если сейчас показано такой же текст, то скипуем
                return
            if not is_important:
                self.general_texts.append({'text':text_id, 'is_important':is_important, 'uid':uid, 'extra':extra})
            else:
                self.general_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid, 'extra':extra})
            self.show_next_tip('general_cloud')
# ============================================================
    def show_tut_text_raw(self, text_id, uid, is_important, extra):
        '''Показывает туториальный текст'''
        if text_id:
            trace('UI TutText:', text_id)
            self.general_text_id_shown = text_id
            realHeight = self.GetHeight(0);
            self.ShowTutorialText(106, realHeight - (768 - 668), text_id, 4000, is_important, uid)
            self.general_tip_shown = True
            if 'blink_build_button' in extra:
                if extra.blink_build_button == True:
                    UI.ButtonStartBlink('idBuildings', 3)
# ============================================================
    def remove_tut_text(self, text_id):
        result = []
        for _tmp in self.general_texts:
            if _tmp.text != text_id:
                result.append(_tmp)
        self.general_texts = result
# ============================================================
    def show_top_text(self, text_id, uid = '', is_important = False):
        '''Показывает туториальный текст'''
        if text_id:
            for item in self.general_texts:
                if item.text == text_id:    # одинаковые сообщения не добавляем
                    return
            if self.workers_tip_shown and self.workers_text_id_shown == text_id:    # если сейчас показан такой же текст, то скипуем
                return
            if not is_important:
                self.workers_texts.append({'text':text_id, 'is_important':is_important, 'uid':uid})
            else:
                self.workers_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid})
            self.show_next_tip('workers_cloud')
# ============================================================
    def show_top_text_raw(self, text_id, uid, is_important):
        '''Показывает туториальный текст'''
        if text_id:
            trace('UI TopText:', text_id)
            self.workers_text_id_shown = text_id
            self.ShowTopText(54, 66, text_id, 4000, uid, is_important)
            self.workers_tip_shown = True
# ============================================================
    def show_chest_text(self, text_id, uid = '', is_important = False):
        '''Показывает сундуковый текст'''
        if text_id:
            for item in self.chest_texts:
                if item.text == text_id:    # одинаковые сообщения не добавляем
                    return
            if self.chest_tip_shown and self.chest_text_id_shown == text_id:    # если сейчас показано такой же текст, то скипуем
                return
            if not is_important:
                self.chest_texts.append({'text':text_id, 'is_important':is_important, 'uid':uid})
            else:
                self.chest_texts.insert(0, {'text':text_id, 'is_important':is_important, 'uid':uid})
            self.show_next_tip('chest_cloud')
# ============================================================
    def show_chest_text_raw(self, text_id, uid, is_important):
        '''Показывает сундуковый текст'''
        if text_id:
            trace('UI TutText:', text_id)
            self.chest_text_id_shown = text_id
            self.ShowChestText(502, 42, text_id, 6000, uid, is_important)
            self.chest_tip_shown = True
# ============================================================
    def show_help_text(self, text_id, x, y, frame):
        '''Показывает подсказку
            frame: кадр в изображении'''
        if text_id:
            self.ShowHelpText(x, y, text_id, 4000, frame)
# ============================================================
    def add_game_tasks(self, task_added = False):
        if task_added:
            tools.PlaySound('SND_TASK_GET')
        i = 0
        for panel in self.tasks_shown:
            if self.tasks_empty[i]: # пустая ячейка
                _dinfo = self.GetTaskSlotDefaultInfo(i)
                _einfo = self.GetTaskSlotExtraInfo(i)
                if _dinfo.is_empty: # нет задания
                    i += 1
                    continue
                if _dinfo.count == 0:
                    i += 1
                    continue
                if not panel:   # если задания здесь еще никогда не было
                    self.tasks_shown[i] = PanelItem()
                    panel = self.tasks_shown[i]
                self.tasks_empty[i] = False
                w = self.widgets[ self.tasks_names[i] ]
                self.SetTaskImage(w, _dinfo.image_name, _dinfo.image_frame)
                self.SetTaskInfo(w, 'template', _dinfo.template_name, 'task')
                if 'uid' in _einfo:
                    self.SetTaskInfo( w, 'uid', _einfo['uid'] )
                if 'npc_uid' in _einfo:
                    self.SetTaskInfo( w, 'npc_uid', _einfo['npc_uid'] )
                self.SetTaskInfo( w, 'location_index', _dinfo.location_index )
                self.SetTaskInfo( w, 'count', _dinfo.count )
                self.SetTaskInfo( w, 'text', _dinfo.text_id )
                if 'tips' in _einfo:
                    self.tasks_tips_text[i] = '#text#COLOR_HEADER#text#TIPS_TASKS_TASK#newline' + _einfo.tips
                if _dinfo.is_complete:
                    self.SetTaskInfo( w, 'count', 0 )
                #mbox(self.tasks_names[index])
                self.SetSlideHasContent(w, True)
                self.Slide(w, 200, "quart", "out")
            i += 1
        i = 0
        for panel in self.tasks_shown:
            if not self.tasks_empty[i]:
                _dinfo = self.GetTaskSlotDefaultInfo(i)
                if _dinfo.is_empty: # or _dinfo.is_hiding
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SlideBackFast(w)
                    self.tasks_shown[i] = None
                    self.tasks_empty[i] = True
            #else:
            #    _dinfo = self.GetTaskSlotDefaultInfo(i)
            #    if _dinfo.is_empty:
            #        w = self.widgets[ self.tasks_names[i] ]
            #        self.SlideBackFast(w)
            #        self.tasks_shown[i] = None
            #        self.tasks_empty[i] = True
            i += 1
# ============================================================
    def refresh_tasks_info(self):
        i = 0
        _has_completed_task = False
        for panel in self.tasks_shown:
            if panel:
                if not panel.is_hiding:
                    _dinfo = self.GetTaskSlotDefaultInfo(i)
                    _einfo = self.GetTaskSlotExtraInfo(i)
                    w = self.widgets[ self.tasks_names[i] ]
                    self.SetTaskImage(w, _dinfo.image_name, _dinfo.image_frame)
                    self.SetTaskInfo(w, 'template', _dinfo.template_name, 'task')
                    if 'uid' in _einfo:
                        self.SetTaskInfo( w, 'uid', _einfo['uid'] )
                    if 'npc_uid' in _einfo:
                        self.SetTaskInfo( w, 'npc_uid', _einfo['npc_uid'] )
                    self.SetTaskInfo( w, 'location_index', _dinfo.location_index )
                    self.SetTaskInfo( w, 'count_ne', _dinfo.count )
                    self.SetTaskInfo( w, 'text', _dinfo.text_id )
                    if 'tips' in _einfo:
                        self.tasks_tips_text[i] = '#text#COLOR_HEADER#text#TIPS_TASKS_TASK#newline' + _einfo.tips
                    if _dinfo.is_complete:
                        self.SetTaskInfo( w, 'count', 0 )
                        _has_completed_task = True
                        self.Signals.Restart('tut_' + self.tasks_names[i], 10000)   # tut_task_1, tut_task_2, tut_task_3
            i += 1
        #if _has_completed_task:
        #    EMgr.send_event('has_completed_event', None, {})
# ============================================================
    def On_external_msg(self, slot, msg_id, msg_param):
        '''Передача сообщений таскам, извне VM'''
        trace(msg_id, 'slot:', slot, 'Param:', msg_param)
        if msg_id == 'task_complete':
            self.tasks_shown[slot].is_task_complete = True
            w = self.widgets[ self.tasks_names[slot] ]
            self.SetTaskInfo(w, 'count', 0)
            tools.PlaySound('SND_TASK_END')
            self.Signals.Restart('tut_' + self.tasks_names[slot], 10000)    # tut_task_1, tut_task_2, tut_task_3
            # EMgr.send_event('has_completed_event', None, {})
        elif msg_id == 'task_remove':
            self.hide_task(slot)
            self.tasks_tips_text[slot] = ''
            tools.PlaySound('SND_TASK_COMPLETE')
            self.Signals.Cancel('tut_' + self.tasks_names[slot])
        elif msg_id == 'set_task_text':
            w = self.widgets[ self.tasks_names[slot] ]
            self.SetTaskInfo(w, 'text', msg_param)
        elif msg_id == 'set_task_count':
            w = self.widgets[ self.tasks_names[slot] ]
            self.SetTaskInfo(w, 'count', int(msg_param))
        elif msg_id == 'set_task_tips_text':
            #w = self.widgets[ self.tasks_names[slot] ]
            #self.SetTaskInfo(w, 'text', msg_param)
            self.tasks_tips_text[slot] = '#text#COLOR_HEADER#text#TIPS_TASKS_TASK#newline' + msg_param
# ============================================================
    def Open_game_menu(self):
        dlg.Open('GameMenu', 'dlg_gamemenu')#, {'single_mode':'1'})
# ============================================================
    #def complete_task(self, task):
    #    '''Отмечает задание как выполненное'''
    #    pass
# ============================================================




