# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_unit
import task_walkg
import task_classes


class IndianQuestDlgTask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
# ============================================================
    def start_action(self, item):
        self.indian = item
        indian = item
        if indian.quest:
            _uid = self.parent_task.uid
            _is_q_start_possible = indian.quest.is_start_possible()
            if _is_q_start_possible:
                _dlg_settings = indian.get_dlg_settings(indian.quest.text, _uid)
                qtd_type = indian.quest.quest_tasks_datas[0].type
                if qtd_type != 'give_resources':
                    _dlg_settings['need_task_effect'] = str(1)
                TMgr.cancel_tasks('walk_general')
                Camera.MoveTo(indian)
                dlg.Open('QuestMenu', 'dlg_quest', _dlg_settings)
                return True
            else:
                return False
        else:
            #self.on_action_complete()
            return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'agree':
            trace('Dialog "agree" pressed')
            QMgr.start_quest(self.indian.quest) #  нужно запустить квест на выполнение
            self.parent_task.complete_task()    # таск по взятию квеста выполнен - теперь нужно выполнять сам квест и все управление переходит на него
        elif result == 'postpone':
            trace('Dialog "postpone" pressed')
            self.parent_task.cancel()
        # отведем генерала от юнита:
        UMgr.general.step_aside()
# ============================================================
# ============================================================
class IndianCompleteQuestDlgTask(task_classes.Subtask):
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
# ============================================================
    def start_action(self, item):
        self.indian = item
        indian = item
        if indian.quest:
            _uid = self.parent_task.uid
            _dlg_settings = indian.get_dlg_settings(indian.quest.text_complete, _uid, True)
            TMgr.cancel_tasks('walk_general')
            Camera.MoveTo(indian)
            dlg.Open('QuestMenuOk', 'dlg_quest_ok', _dlg_settings )
            return True
        else:
            #self.on_action_complete()
            return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'ok':      # а других и быть не должно
            trace('Dialog "ok" pressed (IndianCompleteQuestDlgTask)')
            if self.indian.quest:
                _q = self.indian.quest
                _q.complete()
                self.parent_task.complete_task()
                self.indian.switch_animation()
                self.indian.on_quest_complete_all()
            else:
                mbox('on_callback: no quest')
        # отведем генерала от юнита:
        UMgr.general.step_aside()
# ============================================================
# ============================================================
class IndianQuestTalkTask(task_classes.Subtask):
    '''Подзадание для разговора с индейцем'''
    def __init__(self, parent_task, actor):
        task_classes.Subtask.__init__(self, parent_task, actor)
# ============================================================
    def start_action(self, item):
        self.indian = item
        indian = item
        if indian:
            if not indian.quest:
                if indian.unique_name:
                    _has_dlg = indian.GetAttrBool('has_dialog')
                    if _has_dlg:
                        _uid = self.parent_task.uid
                        _dlg_settings = indian.get_dlg_settings_talk(indian.GetAttrStr('talk_text'), _uid)
                        #_dlg_settings['is_survived'] = 'true'
                        #TMgr.cancel_tasks('walk_general')   # не нужно, иначе результату некуда приходить
                        Camera.MoveTo(indian)
                        indian.start_talk() # по хорошему квест нужно считать выполненым после разговора, а не до
                        self.actor.start_talk()
                        dlg.Open('QuestMenuOk', 'dlg_quest', _dlg_settings)
                        return True
                    else:
                        # #qtd_type = indian.quest.quest_tasks_datas[0].type
                        #TMgr.cancel_tasks('walk_general')
                        # #dlg.Open("QuestMenu", "dlg_quest", _dlg_settings)
                        #BMgr.SendGlobalMsg('unit_talk', self.indian.unique_name)      # задание "поговорить" выполнено
                        #indian.unique_name = '' # чтобы повторно к нему не подходить
                        #self.parent_task.complete_task()
                        #self.indian.switch_animation()
                        #self.indian.on_quest_complete_all()
                        indian.start_talk() # по хорошему квест нужно считать выполненым после разговора, а не до
                        self.actor.start_talk()
                        return True
        return False
# ============================================================
    def on_callback(self, result, extra_dict):
        '''Обработка данных от диалога (диалог у нас в другой VM)'''
        if result == 'ok':
            trace('Dialog "ok" pressed (IndianQuestTalkTask)')
            self.parent_task.complete_task()    # таск по взятию квеста выполнен - теперь нужно выполнять сам квест и все управление переходит на него
        #if _unit_name:
        #    self.SendGlobalMsg('unit_talk', self.indian.unique_name)      # задание "поговорить" выполнено
            #TMgr.cancel_tasks('walk_general')
        # отведем генерала от юнита:
        UMgr.general.step_aside()
# ============================================================
# ============================================================
# ============================================================
class UnitIndianSit(base_unit.BaseUnit):
    def __init__(self, cdata):
        base_unit.BaseUnit.__init__(self, cdata)
        self.is_indian = True       # чтобы отличать индейцев от не индейцев
        self.quest = None
        EMgr.add_event_listener(self)
# ============================================================
    # @override
    def dispose(self):
        EMgr.remove_event_listener(self)
# ============================================================
    #@override
    def on_signal(self, signal):
        base_unit.BaseUnit.on_signal(self, signal)
        if signal == 'face_to_screen':
            self.set_face_direction()   # чтобы лицом к экрану стоял
# ============================================================
    def on_message(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        if msg_type == 'quest_start':
            self.on_quest_start(msg_param1)
        elif msg_type == 'quest_complete':
            self.on_quest_complete(msg_param1)
        elif msg_type == 'quest_activated':
            self.on_quest_activated()
        elif msg_type == 'at_target':
            self.Signals.Restart('face_to_screen', 250)
# ============================================================
    def on_click(self, btn_name):
        '''Вызывается при клике по объекту'''
        #@b если есть варвары на поле, то клики отменяем, квесты не сдаем
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if _has_barbarians:        # если есть варвары, то не даем кликать по индейцам, чтобы ни взять, ни сдать квест
            LBoard.CrossNoToLastClick()
            return
        _is_active = self.is_active()
        if _is_active:
            _is_enough_params = self.is_enough_params()
            if _is_enough_params:
                if not self.is_another_unit_in_queue:
                    if not self.is_another_quest_started:   # других не запущено
                        if self.quest:
                            if self.quest.is_only_res_not_enough_to_start():
                                #LBoard.MoveCameraToLastClick()
                                return
                            if self.quest.is_final:
                                _is_final_ready = self.quest.is_final_ready()
                                if not _is_final_ready:
                                    _is_final_to_start = self.quest.is_final_to_start()
                                    if _is_final_to_start:   # недостает только завершения задач
                                        return
                        if not self.task:
                            #if UMgr.general and not UMgr.general.task:
                                self.task = task_walkg.WalkGeneralTask(self)
                                TMgr.add_task( self.task )
                                if self.has_check:      # если галка установилась
                                    TMgr.add_quest_unit_to_queue(self.uid)
                                    Camera.MoveTo(self) # при установке галки - камеру на индейца
                                    BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
                        else:
                            #TMgr.remove_quest_unit_from_queue(self.uid)
                            self.task.cancel()
                            self.task = None
                            BMgr.SendGlobalMsg('unit_clicked', self.get('uid'))
            else:
                _param_name = self.get_not_enough_param()
                UI.BlinkGem(3, _param_name)     # подмигнем параметром
        else:
            LBoard.CrossNoToLastClick()
# ============================================================
    def on_state_enter(self, state_name, additional):
        self.switch_animation()
# ============================================================
    def on_state_exit(self, state_name, additional):
        if state_name == 'talk':    # завершаем разговор с юнитом
            self.on_talk_complete()
# ============================================================
# ============================================================
    def on_create(self):
        _talk_quest_started = UStats.GetLevelValue('talk_quest_was_started') > 0        # если запущен квест на разговор с юнитом до создания подгружаемого уровня
        if _talk_quest_started:
            self.try_show_talk_sign()
        self.switch_animation()
# ============================================================
    def __str__(self):
        return base_unit.BaseUnit.__str__(self)
# ============================================================
    def on_event(self, name, obj, extra_dict):
        '''Обработчик игровых событий'''
        if name == 'resources_changed':            # изменилось кол-во ресурсов у игрока
            self.switch_animation()     # чтобы знак над индейцем обновить
        elif name == 'quest_unit_added':
            if self.uid != extra_dict['uid']:   # если событие другого объекта
                self.is_another_unit_in_queue = True
                self.switch_animation()     # чтобы знак над индейцем обновить
        elif name == 'quest_unit_removed':
            self.is_another_unit_in_queue = False
            self.switch_animation()     # чтобы знак над индейцем обновить
        elif name in ['barbarian_attack_started', 'barbarian_attack_completed', 'barbarian_attack_canceled']:
            self.switch_animation()
# ============================================================
# ============================================================
    indian_animation_dict = {'run' : 'run', 'idle' : 'default', 'talk':'speak'}
# ============================================================
    def switch_animation(self):
        _is_partial_fog = self.Drawer.IsPartiallyInFog()
        if _is_partial_fog:
            self.Drawer.ShowImages('', False)
            return
        if not self.is_shown:
            self.Drawer.ShowImages('', False)
            return
        state_name = self.SM.GetCurrentState()
        self.Drawer.ShowImages('', False)
        new_animation_name = 'default'
        if state_name in self.indian_animation_dict:
            new_animation_name = self.indian_animation_dict[state_name]
        state_name = self.SM.GetState()
        self.Drawer.ShowImages([new_animation_name,'shadow'], True)
        self.Drawer.ShowImages('select', self.is_mouse_over and not self.is_deactivated)
        self.Drawer.ShowImages('check', self.has_check)
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if not _has_barbarians:
            _has_access = self.HasAccess()
            if _has_access:
                _quest_precomplete = False
                _is_active = self.is_active()
                if self.quest:
                    if _is_active:
                        if self.quest.is_final:
                            _is_final_ready = self.quest.is_final_ready()
                            if not _is_final_ready:
                                self.Drawer.ShowImages('sign_talk', False)
                                self.Drawer.ShowImages('sign_e', False)
                                self.Drawer.ShowImages('sign_red', self.is_another_quest_started)
                                return
                        _quest_precomplete = self.is_quest_precomplete()
                        if _quest_precomplete:
                            self.Drawer.ShowImages('sign_talk')
                            self.Drawer.ShowImages('sign_e', False)
                            self.Drawer.ShowImages('sign_red', False)
                        else:
                            _need_quest_sign_red = self.need_quest_sign_red()
                            self.Drawer.ShowImages('sign_e', not _need_quest_sign_red)
                            self.Drawer.ShowImages('sign_red', _need_quest_sign_red)
                if not _quest_precomplete:  # чтобы квестовое облако не перетирало
                    self.Drawer.ShowImages('sign_talk', (self.unique_name and self.is_active() and not self.unit_is_talking))
# ============================================================
    # @override
    def is_active(self):
        '''Возможны ли действия над объектом в данный момент. ПЕРЕОПРЕДЕЛЯЕМ'''
        if not self.non_selectable:
            if not self.is_deactivated:
                if self.is_shown:
                    if self.unique_name:
                        return self.show_talk_sign
                    if self.is_quest_precomplete(): # если сдача квеста
                        return True
                    elif not QMgr.has_tutorial_quests():        # туториальных больше нет
                        if not self.is_another_unit_in_queue:
                            if not self.is_another_quest_started:   # других не запущено
                                if self.quest:
                                    _is_giveobject_start_possible = self.quest._is_giveobject_start_possible()
                                    if not _is_giveobject_start_possible:
                                        return False
                                    _is_parent_awaiting = self.quest.is_parent_awaiting()
                                    if _is_parent_awaiting:
                                        return False
                                    if self.quest.is_start_possible():
                                        return True
                                    elif self.quest.is_only_res_not_enough_to_start():
                                        return True     # чтобы при нехватке ресурсов для квеста воскл. знак над индейцем показывался
                                    elif self.quest.is_final_to_start():
                                        return True
                            #elif self.quest:
                            #    if self.quest.parent_quest_name:   # если родительский квест
                            #        if self.quest.is_start_possible():
                            #            return True
                            #        elif self.quest.is_only_res_not_enough_to_start():
                            #            return True
                            #        elif self.quest.is_final_to_start():
                            #            return True
        return False
# ============================================================
    def need_quest_sign_red(self):
        '''Нужно ли показать красное облако над индейцем'''
        if not self.non_selectable:
            if not self.is_deactivated:
                if self.is_shown:
                    if self.quest:
                        _is_quest_precomplete = self.is_quest_precomplete()
                        if _is_quest_precomplete: # если сдача квеста
                            return False
                        _is_enough_params = self.is_enough_params()
                        if not _is_enough_params:
                            return True
                        _has_tut_quest = QMgr.has_tutorial_quests()
                        if not _has_tut_quest:        # туториальных больше нет
                            if not self.is_another_unit_in_queue:
                                if not self.is_another_quest_started:   # других не запущено
                                    _is_start_possible = self.quest.is_start_possible()
                                    if _is_start_possible:
                                        if self.quest.is_final:
                                            _is_final_ready = self.quest.is_final_ready()
                                            if not _is_final_ready:
                                                return True
                                    elif self.quest.is_only_res_not_enough_to_start():
                                        return True
                                #elif self.quest:
                                #    if self.quest.parent_quest_name:   # если родительский квест
                                #        if self.quest.is_start_possible():
                                #            if self.quest.is_final:
                                #                _tasks_complete = UStats.GetLevelValue('main_tasks_complete') > 0
                                #                if not _tasks_complete:
                                #                    return True
                                #            return False
                                #        elif self.quest.is_only_res_not_enough_to_start():
                                #            return True
        return False
# ============================================================
    def has_sign(self):
        if not self.non_selectable:
            if not self.is_deactivated:
                if self.is_shown:
                    if self.unique_name:
                        return self.show_talk_sign
                    _is_quest_precomplete = self.is_quest_precomplete()
                    if _is_quest_precomplete: # если сдача квеста
                        return True
                    _has_tut_quest = QMgr.has_tutorial_quests()
                    if not _has_tut_quest:        # туториальных больше нет
                        if not self.is_another_unit_in_queue:
                            if not self.is_another_quest_started:   # других не запущено
                                if self.quest:
                                    _is_giveobject_start_possible = self.quest._is_giveobject_start_possible()
                                    if not _is_giveobject_start_possible:
                                        return False
                                    _is_parent_awaiting = self.quest.is_parent_awaiting()
                                    if _is_parent_awaiting:
                                        return False
                                    if self.quest.is_start_possible():
                                        return True
                                    elif self.quest.is_only_res_not_enough_to_start():
                                        return True     # чтобы при нехватке ресурсов для квеста воскл. знак над индейцем показывался
                                    elif self.quest.is_final_to_start():
                                        return True
                            #elif self.quest:
                            #    if self.quest.parent_quest_name:   # если родительский квест
                            #        if self.quest.is_start_possible():
                            #            return True
                            #        elif self.quest.is_only_res_not_enough_to_start():
                            #            return True
                            #        elif self.quest.is_final_to_start():
                            #            return True
        return False
# ============================================================
    def is_enough_params(self):
        '''Достаточно ли красноречия и силы'''
        _need_power = self.GetAttrInt('need_power') - 1
        _need_oratory = self.GetAttrInt('need_oratory') - 1
        _cur_res = UStats.GetCurRes()
        _have_oratory = _cur_res.Get('gem_green')
        _have_power = _cur_res.Get('gem_blue')
        if _have_oratory < _need_oratory or _have_power < _need_power:
            return False
        else:
            return True
# ============================================================
    def get_not_enough_param(self):
        '''Возвращает имя параметра, которого недостаточно'''
        _need_power = self.GetAttrInt('need_power') - 1
        _need_oratory = self.GetAttrInt('need_oratory') - 1
        _cur_res = UStats.GetCurRes()
        _have_oratory = _cur_res.Get('gem_green')
        _have_power = _cur_res.Get('gem_blue')
        if _have_oratory < _need_oratory:
            return 'oratory'
        elif _have_power < _need_power:
            return 'power'
        else:
            return ''
# ============================================================
    def set_quest(self, quest):
        self.quest = quest
        self.is_deactivated = False
        #self.non_selectable = False
        #self.switch_animation()    #@? нужно ли оно здесь???
# ============================================================
    def on_quest_start(self, quest_name):
        if not self.quest:
            return
        quest = QMgr.get_quest(quest_name)
        if self.quest != quest:
            _is_parent_linked = self._is_parent_quest_linked(self.quest, quest)
            if not _is_parent_linked:
                _is_parent_linked = self._is_parent_quest_linked(quest, self.quest) # а если обратная связка
            self.is_another_quest_started = not _is_parent_linked
        else:
            self.is_another_quest_started = False
            self.is_quest_started = True
        self.switch_animation()
# ============================================================
    def _is_parent_quest_linked(self, quest, parent_q):
        if quest.parent_quest_name:
            if quest.parent_quest_name == parent_q.name:
                if not quest.after_parent_quest_completed:
                    return True
        return False
# ============================================================
    def on_quest_complete(self, quest_name):
        '''Вызывается при завершении того или иного квеста.
        Но логику этого вызова теперь нужно менять, т.к.
        квест должен завершаться после сдачи квеста'''
        if not self.quest:
            return
        if QMgr.has_tutorial_quests():      # если не все туториальные квесты еще прошли
            return
        quest = QMgr.get_quest(quest_name)
        #@pbug возможен баг, когда завершается зависимый квест - остальные получат сигнал, что они доступны, хотя, на самом деле еще висит родительский квест!
        _still_has_parent_quest = False
        if quest:
            if quest.parent_quest_name != self.quest.name:
                if quest.parent_quest_name: # если у завершенного был родительский квест
                    if not quest.after_parent_quest_completed:
                        _still_has_parent_quest = True
                self.is_another_quest_started = _still_has_parent_quest
        # чтобы не херились данные раньше времени:
        if self.quest == quest:
            self.is_quest_started = False
        #    self.quest = None       # квест закончен, он нам больше не нужен
            # может здесь нужно выложить то, что полагается по квесту
        self.switch_animation()
# ============================================================
    def on_quest_activated(self):
        if not self.quest:
            return
        self.switch_animation()
# ============================================================
    def is_action_complete(self):
        if not self.quest:
            return True
        else:
            return False
# ============================================================
    def is_quest_precomplete(self):
        '''Квест выполнен, его нужно сдать'''
        if self.quest and self.quest.is_quest_precomplete(): # нужно сдать квест
            return True
        return False
# ============================================================
    def get_subtask(self, parent_task, actor):
        if self.unique_name:
            return IndianQuestTalkTask(parent_task, actor)
        elif self.is_quest_precomplete(): # если сдача квеста
            return IndianCompleteQuestDlgTask(parent_task, actor)
        elif not self.is_action_complete():
            return IndianQuestDlgTask(parent_task, actor)
        else:
            return base_unit.BaseUnit.get_subtask(self, parent_task, actor)
# ============================================================
    def on_quest_complete_all(self):
        '''Вызывает "OK"-диалогом, когда квест уже полностью завершен'''
        self.try_step_aside_quest_complete()
        self.try_hide_after_quest_complete()
        self.is_quest_complete = True   # завершили квест, запомним это
# ============================================================
    def try_hide_after_quest_complete(self):
        '''Готовит юнита к исчезновению по окончании квеста, если у юнита есть такая необходимость'''
        hide_items_str = self.GetAttrStr('qc_hide_items')
        if hide_items_str:
            hide_items = BMgr.get_items(hide_items_str)
            if hide_items:
                for item in hide_items:
                    item.need_to_remove_offscreen = True
        _need_hide_self = self.GetAttrBool('qc_hide')
        if _need_hide_self:     # если нужно спрятать юнита
            self.need_to_remove_offscreen = True
            if self.is_offscreen:   # если уже за экраном, то удалим его
                BMgr.RemoveItemFromMap(self)    # удалим юнита
# ============================================================
    def try_step_aside_quest_complete(self):
        '''Отводит индейца в сторону, после того, как квест выполнен'''
        _need_step_aside = self.GetAttrBool('qc_step_aside')
        if _need_step_aside:
            LBoard.RemoveItemPassability(self)
            _destCell = UMgr.GetStepAsideCell( self, self.get('cell'), 5 )
            if _destCell:
                self.run_to_target(_destCell)
# ============================================================
# ============================================================
    #@override
    def get_dlg_settings(self, text, _uid = 0, complete = False):
        if self.quest:
            _tasks = self.quest.get_tasks_text(complete)
            _dlg_settings = {'imageid': self.GetAttrStr('dlg_avatar'),
                            'nameid': self.GetAttrStr('dlg_name'),
                            'textid': text,
                            'tasks_text': _tasks,
                            'task_uid':str(_uid),
                            'single_mode':str(True),
#                            'showin_effect': 'task_fly_in',
                            'pause':str(400),
                            }
            return _dlg_settings
        return None
# ============================================================
    def get_dlg_settings_talk(self, text, _uid = 0, complete = False):
        _tasks = []
        #_tasks = self.quest.get_tasks_text(complete)
        _dlg_settings = {'imageid': self.GetAttrStr('dlg_avatar'),
                        'nameid': self.GetAttrStr('dlg_name'),
                        'textid': text,
                        'tasks_text': _tasks,
                        'task_uid':str(_uid),
                        'single_mode':str(True),
#                        'showin_effect': 'task_fly_in',
                        'hide_complete': '1',
                        'pause':str(400),
                        }
        return _dlg_settings
# ============================================================
# ============================================================
# ============================================================
    def is_not_ready_to_talk(self):
        return False        # пока отключено
        if self.is_deactivated:
        #if not _is_active:
            if self.quest:
                return True
            if self.unit_is_talking:
                if self.unique_name:
                    return True
        return False
# ============================================================
    #@override
    def is_green_state(self):
        '''Цвет типса/селекта'''
        _not_ready_to_talk = self.is_not_ready_to_talk()
        if _not_ready_to_talk:
            return True
        _has_access = self.HasAccess()
        if self.is_deactivated:
            if _has_access: return True
            else:           return False
        if not _has_access: return False
        _is_enough_params = self.is_enough_params()
        if not _is_enough_params:
            return False
        if self.is_another_unit_in_queue:
            return False
        if self.is_another_quest_started:
            return False
        _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
        if _has_barbarians: return False
        _is_active = self.is_active()
        _is_partially_ready_to_start = False
        if self.quest:
            _is_giveobject_start_possible = self.quest._is_giveobject_start_possible()
            if not _is_giveobject_start_possible:
                return False
            _is_partially_ready_to_start = self.quest.is_only_res_not_enough_to_start()
            if not _is_partially_ready_to_start:
                if self.quest.is_final:
                    _is_final_ready = self.quest.is_final_ready()
                    if not _is_final_ready:
                        _is_partially_ready_to_start = True
        if _is_active:
            if _is_partially_ready_to_start:
                return False    # если не хватает только ресурсов
        return base_unit.BaseUnit.is_green_state(self)
# ============================================================
    def Get_tip_text(self, by_click = False):
        '''Возвращает LIST, содержащий текстовые ID'''
        # нужно писать что нужно индейцу, например: красноречие, сила, ресурсы
        result = []
        if not self.is_shown:
            return result
        item_name = self.GetAttrStr('item_name')
        if not item_name:
            return result
        if self.is_tip_frozen:  # для индейцев "болванчиков"
            result.append( ('text', 'COLOR_HEADER') )
            result.append( ('text', item_name) )
            return result
        _is_debug = tools.IsDebug()
        if _is_debug:
            result.append( ('text', 'COLOR_HEADER') )
            result.append( ('debug', str(self.is_active())) )
            result.append( ('debug', str(self.is_deactivated)) )
            #result.append( ('debug', str(self.is_not_ready_to_talk())) )
            result.append('newline')
        if not by_click:
            result.append( ('text', 'COLOR_HEADER') )
            result.append( ('text', item_name) )

            # дальше хитрое шаманство недостающих параметров и ресурсов:
            result_params = []
            self.get_params_not_enough_text(result_params, [('text', 'COLOR_LINES')])
            result_need_res = []
            result_ne_res = []
            if self.quest and self.need_quest_text:
                result_need_res, result_ne_res = self.quest.get_tips_extra_text()
            parts = []
            parts.append(self._get_main_tasks_incomplete_text(True))
            parts.append(result_params)
            parts.append(result_need_res)
            needs_combined = self._combine_not_enough_texts(parts)
            if needs_combined:
                result.append('newline')
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', 'NEED_FOR_ACTION') )
                result.extend(needs_combined)

            result_params = []
            self.get_params_not_enough_text(result_params,\
                                            [('text', 'COLOR_RED')], True )
            parts = []
            parts.append(result_params)
            parts.append(result_ne_res)
            not_enough_combined = self._combine_not_enough_texts(parts)
            if not_enough_combined:
                result.extend( ['newline', ('text', 'COLOR_RED'), ('text', 'NOT_ENOUGH')] )
                result.extend(not_enough_combined)
        else:   # by click:
            if self.is_quest_complete:
                result.append( ('text', 'COLOR_LINES') )
                result.append( ('text', ('NOTHING_TO_TALK','NOTHING_TO_TALK_W')[self.is_woman == True]) )
                return result
            _has_access = self.HasAccess()
            _no_time_to_talk = False
            if self.is_another_quest_started: _no_time_to_talk = True
            _has_barbarians = UStats.GetLevelValue('barbarian_attack') > 0
            if _has_barbarians: _no_time_to_talk = True
            if self.quest:
                _is_giveobject_start_possible = self.quest._is_giveobject_start_possible()
                if not _is_giveobject_start_possible:
                    _no_time_to_talk = True
            _is_active = self.is_active()
            _skip_extra_tips = False
            if _is_active:
                _is_quest_precomplete = self.is_quest_precomplete()
                if _is_quest_precomplete:
                    _skip_extra_tips = True
                elif self.task:
                    _skip_extra_tips = True
            if _has_access:
                if not _skip_extra_tips:
                    if _no_time_to_talk:
                        result.append( ('text', 'COLOR_LINES') )
                        result.append( ('text', 'YOU_HAVE_NO_TIME_TO_TALK') )
                        return result
                    elif self.quest:
                        _is_start_possible = self.quest.is_start_possible(True)
                        if self.is_quest_started:
                            result.append( ('text', 'COLOR_LINES') )
                            result.append( ('text', ('NOT_READY_TO_TALK','NOT_READY_TO_TALK_W')[self.is_woman == True]) )
                            return result
                        elif not _is_start_possible:
                            _is_quest_ready = True
                            if self.quest.is_final:
                                _is_quest_ready = self.quest.is_final_ready()
                            if _is_quest_ready:
                                result.append( ('text', 'COLOR_LINES') )
                                result.append( ('text', ('NOT_READY_TO_TALK','NOT_READY_TO_TALK_W')[self.is_woman == True]) )
                                return result
                elif _has_barbarians:  # спец.типсы пропускаем, но варварские нужно показать
                    result.append( ('text', 'COLOR_LINES') )
                    result.append( ('text', 'YOU_HAVE_NO_TIME_TO_TALK') )
                    return result
            if not self.non_selectable:
                #if not self.is_deactivated:
                if _has_access:
                    if self.is_shown:
                        if self.unique_name:
                            if not _has_barbarians:
                                _talk_quest_started = UStats.GetLevelValue('talk_quest_was_started') > 0
                                if not _talk_quest_started:
                                    result.append( ('text', 'COLOR_LINES') )
                                    result.append( ('text', ('NOT_READY_TO_TALK','NOT_READY_TO_TALK_W')[self.is_woman == True]) )
                                    return result
            if True:
                result = []
                if not _has_access:
                    result.append( ('text', 'COLOR_RED') )
                    result.append( ('text', 'NO_PATH') )
                    return result
            result_ne_res = []
            if self.quest:
                if self.need_quest_text:
                    result_ne_res = self.quest.get_tips_click_text()
            result_params = []
            self.get_params_not_enough_text(result_params,\
                                            [('text', 'COLOR_RED')], True )
            parts = []
            #parts.append( self._get_main_tasks_incomplete_text(True) )
            parts.append( result_params )
            parts.append( result_ne_res )
            combined = self._combine_not_enough_texts(parts)
            result = []
            _main_tasks = self._get_main_tasks_incomplete_text()
            if _main_tasks:
                result.extend(_main_tasks)
                if combined:
                    result.append('newline')
            if not combined:
                if not _main_tasks:
                    return self.Get_tip_text(False)
            else:
                result.extend( [('text', 'COLOR_RED'), ('text', 'NOT_ENOUGH')] )
                result.extend( combined )
        return result
# ============================================================
    def _get_main_tasks_incomplete_text(self, second_variant = False):
        if self.quest:
            if self.quest.is_final:
                _is_final_ready = self.quest.is_final_ready()
                if not _is_final_ready:
                    _is_final_to_start = self.quest.is_final_to_start()
                    if _is_final_to_start:   # недостает только завершения задач
                        r = []
                        if not second_variant:
                            r.append( ('text', 'COLOR_RED') )
                            r.append( ('text', 'MAIN_TASKS_INCOMPLETE') )
                        else:
                            r.append( ('text', 'MAIN_TASKS_INCOMPLETE_2') )
                        return r
        return []
# ============================================================
    def _get_res_not_enough_text(self, result, show_red = False):
        res = self.res_action_cost
        _is_res_enough = UStats.IsResEnough(res)
        if not _is_res_enough:
            diff_res = UStats.GetNotEnoughRes(res)
            if diff_res:
                if show_red:     result.append( ('text', 'COLOR_RED') )
                result.append( ('text', 'NOT_ENOUGH') )
                result.append( 'space' )
                res_numbers = self._append_res_values(diff_res)
                result.extend( res_numbers )
                return True
        return False
# ============================================================
    #@override
    def get_ui_subtext(self):
        '''Текст, который должен быть написан в типсе возле панели с
        лицом персонажа второй строкой'''
        if not self.non_selectable and not self.is_deactivated and self.is_shown:
            if self.quest:
                _is_quest_precomplete = self.is_quest_precomplete()
                if _is_quest_precomplete: # если сдача квеста
                    return ([('text', ('FACES_READY_TO_COMPLETE','FACES_READY_TO_COMPLETE_W')[self.is_woman == True])], True)
                parts = []
                not_enough_result = [('text', 'FACES_NOT_ENOGH_TO_SPEAK')]
                result = []
                maintasks_result = self._get_main_tasks_incomplete_text(True)
                if maintasks_result:
                    parts.append(maintasks_result)
                _is_enough_params = self.is_enough_params()
                if not _is_enough_params:
                    self.get_params_not_enough_text(result, [('text', 'COLOR_RED')], True)
                    parts.append(result)
                result = []
                _is_res_not_enough_to_start = self.quest.is_only_res_not_enough_to_start()
                if _is_res_not_enough_to_start:
                    _r, _ne_r = self.quest.get_tips_extra_text(True)
                    #result.extend(_r)
                    parts.append(_ne_r)
                result = self._combine_not_enough_texts(parts)
                if result:
                    not_enough_result.extend(result)
                    return (not_enough_result, False)

                _is_start_possible = self.quest.is_start_possible()
                if _is_start_possible:
                    return ([('text', ('FACES_READY_TO_SPEAK','FACES_READY_TO_SPEAK_W')[self.is_woman == True])], True)

            _is_active = self.is_active()
            if self.unique_name:
                if _is_active:
                    return ([('text', ('FACES_READY_TO_SPEAK','FACES_READY_TO_SPEAK_W')[self.is_woman == True])], True)
        return [[], True]
# ============================================================
    def _combine_not_enough_texts(self, parts):
        _len = 0
        filtered_parts = []
        for part in parts:
            if part:    # учитываем только не пустые записи
                _len += 1
                filtered_parts.append(part)
        result = []
        if _len == 1:
            result.append('space')  # пробел-разделитель после двоеточия
            result.extend( filtered_parts[0] )
        else:
            for part in filtered_parts:
                result.append('newline')  # перевод строки-разделитель после двоеточия и после предыдущего пункта
                result.extend( part )
        return result

# ============================================================
# ============================================================
