# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_unit


class UnitQuarry(base_unit.BaseUnit):
    def __init__(self, cdata):
        base_unit.BaseUnit.__init__(self, cdata)
        self.current_subtype = 'quarryman'
        self.work_boost = 1
        self.resource = None
        self.parent_home = None    # здание, к которому привязан юнит
        self.current_action_animation = 'action_kirk'
        default_unit_speed = Globals.GFloat("DEFAULT_UNIT_SPEED") # default speed
        cur_unit_speed = Globals.GFloat("UNIT_SPEED")
        self.Drawer.SetAnimBoost(['run','run_stone'], 1000*cur_unit_speed/default_unit_speed)
        self.SM.SetState('run')
# ============================================================
    # @override
    def on_message(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        if msg_type == "at_target":
            trace(self.task_type)
            if self.task:
                self.task.target_reached(self)
            elif self.home_building: # running home and already at home
                if "col" not in self.target:
                    if "row" not in self.target:
                        _home = self.target
                        if _home:
                            trace('UnitQuarryman: ',_home.get('name'))
                        else:
                            trace('UnitQuarryman: _home = None')
                        _home.in_unit(self)    # hide unit in building
# ============================================================
    # @override
    #def on_signal(self, signal):
    #    base_unit.BaseUnit.on_signal(self, signal)
# ============================================================
    # @override
    def on_state_enter(self, state_name, additional):
        self.switch_animation()
# ============================================================
    # @override
    def on_state_change(self, cur_state, next_state):
        if cur_state == "run":
            if next_state == "stay":
                self.StopMove()
# ============================================================
    # @override
    def on_create(self):
        self.switch_animation()
# ============================================================
    # @override
    def __str__(self):
        return base_unit.BaseUnit.__str__(self)

# ============================================================
# ============================================================
# ============================================================
    def switch_animation(self):
        state_name = self.SM.GetCurrentState()
        dir = self.GetDirection()
        self.Drawer.ShowImages("", False)
        self.Drawer.ShowImages("shadow", True)
        new_image_type = "run"
        _dict = {"action": 'action_kirk', "run": 'run', "stay": 'run'}
        if state_name in _dict:
            new_image_type = _dict[state_name]
        if state_name == 'run':
            if self.resource:
                new_image_type = 'run_stone'
        if state_name == 'action':
            self.Drawer.SetAnimBoost(new_image_type, self.work_boost*1000)
        self.Drawer.ShowImages(new_image_type, True)
        self.Drawer.SetSequence(new_image_type, dir)
# ============================================================
    # @override
    def go_home(self):
        '''Отправляет юнита домой. Иницализирует необходимые переменные
        После события "free_unit" TMgr вызывает у юнита данный метод'''
        if self.home_building:
            if self.is_in_home:  # уже дома
                return
        b = self.parent_home
        self.home_building = b
        b.add_walking_home_unit(self)
        self.run_to_target( b.start_cell_pos, b, '', True )
# ============================================================
    # @override
    def set_home(self, building):
        '''Помещает юнита в здание. Инициализирует необходимые переменные, прячет юнита, выставляет координаты'''
        self.home_building = None   # ?
        base_unit.BaseUnit.set_home(self, building)
        self.current_subtype = 'quarryman'
        self.parent_home = building
# ============================================================

