# -*- coding: utf-8 -*-

import sys
if not "tinypy" in sys.version:
    from extra import *

import base_unit


class UnitQuest(base_unit.BaseUnit):
    resource_animation_dict = {
        "": "run"
        }

    def __init__(self, cdata):
        base_unit.BaseUnit.__init__(self, cdata)
        self.is_active = False
        self.is_awaiting_result = False
        #default_unit_speed = Globals.GFloat("DEFAULT_UNIT_SPEED") # default speed
        #cur_unit_speed = Globals.GFloat("UNIT_SPEED")
        #self.Drawer.SetAnimBoost("run", 1000*cur_unit_speed/default_unit_speed)


    def on_message(self, msg_type, msg_param1="", msg_param2="", msg_dict={}):
        if msg_type == "at_target":
            if self.home_building: # running home and already at home
                if "col" not in self.target and "row" not in self.target: # and self.target.__class__ == "base_building.BaseBuiding":
                    self.target.in_unit(self)    # hide unit in building
                return
            else:       # at target
                trace(self.task_type)
                if self.task:
                    self.task.target_reached(self)
                return


    def on_interact(self, sender, cmd, additional):
        pass


    def on_signal(self, signal):
        base_unit.BaseUnit.on_signal(self, signal)
        pass


    def on_state_enter(self, state_name, additional):
        new_image_type = "run"
        if self.resource:
            new_image_type = self.resource_animation_dict[self.resource.GetSingleName()]
        else:
            dict = {"build": "build", "run": "run", "stay": "run"}
            if state_name in dict:
                new_image_type = dict[state_name]
        self.switch_animation(new_image_type)

    def on_state_exit(self, state_name, additional):
        #if state_name == "build":
        #    self.go_home()   # hack - just for test - running to nearest vacant home
        pass

    def on_state_change(self, cur_state, next_state):
        if cur_state == "run":
            if next_state == "stay":
                self.StopMove()

    def on_create(self):
        self.switch_animation("run")

    def __str__(self):
        return base_unit.BaseUnit.__str__(self)

# ============================================================
# ============================================================
# ============================================================
    def switch_animation(self, new_animation_name):
        dir = self.GetDirection()
        self.Drawer.ShowImages("", False)
        self.Drawer.ShowImages(new_animation_name, True)
        self.Drawer.SetSequence(new_animation_name, dir)
        self.Drawer.ShowImages("shadow", True)

    def get_button_image_group(self):
        ''' '''
        pass

    def on_click(self):
        ''' '''
        pass

